{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
osCommerce Product Manager for Windows (oscpmwin).
Copyright 2003,2004,2005 by Mario A. Valdez-Ramirez.

You can contact Mario A. Valdez-Ramirez
by email at mario@mariovaldez.org or paper mail at
Olmos 809, San Nicolas, NL. 66495, Mexico.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
UNIT main;

INTERFACE

USES
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  ToolWin, ComCtrls, DB, ExtCtrls, Menus, StdCtrls, Grids,
  DBGrids, DBTables, ImgList, Buttons, clipbrd, oscpmdata, Dialogs, ShlObj, modules,
  FR_Class, FR_DSet;

TYPE
  Topm_Form_Main = CLASS (TForm)
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N8: TMenuItem;
    opm_DBGrid_DEBUG: TDBGrid;
    opm_DataSource_DEBUG: TDataSource;
    opm_ImageList_List: TImageList;
    opm_ImageList_Status: TImageList;
    opm_ImageList_Tree: TImageList;
    opm_Image_Status: TImage;
    opm_ListView_Main: TListView;
    opm_MainMenu_Main: TMainMenu;
    opm_MenuItem_About: TMenuItem;
    opm_MenuItem_Catalog: TMenuItem;
    opm_MenuItem_Config: TMenuItem;
    opm_MenuItem_Connect: TMenuItem;
    opm_MenuItem_Database: TMenuItem;
    opm_MenuItem_Disconnect: TMenuItem;
    opm_MenuItem_Exit: TMenuItem;
    opm_MenuItem_Help: TMenuItem;
    opm_MenuItem_License: TMenuItem;
    opm_MenuItem_Product: TMenuItem;
    opm_MenuItem_ProductAdd: TMenuItem;
    opm_MenuItem_ProductCopyAsText: TMenuItem;
    opm_MenuItem_ProductDel: TMenuItem;
    opm_MenuItem_ProductEdit: TMenuItem;
    opm_MenuItem_ProductExport: TMenuItem;
    opm_MenuItem_ProductSelAll: TMenuItem;
    opm_MenuItem_RefreshCategories: TMenuItem;
    opm_MenuItem_RefreshProducts: TMenuItem;
    opm_MenuItem_SearchProduct: TMenuItem;
    opm_Panel_DEBUG: TPanel;
    opm_Panel_Main: TPanel;
    opm_PopMenuItem_CatCollapse2: TMenuItem;
    opm_PopMenuItem_CatCollapse: TMenuItem;
    opm_PopMenuItem_CatExpand2: TMenuItem;
    opm_PopMenuItem_CatExpand: TMenuItem;
    opm_PopMenuItem_ConnConn: TMenuItem;
    opm_PopMenuItem_ConnDisconn: TMenuItem;
    opm_PopMenuItem_HideDebug: TMenuItem;
    opm_PopMenuItem_PAdd: TMenuItem;
    opm_PopMenuItem_PAvailability: TMenuItem;
    opm_PopMenuItem_PAvailable: TMenuItem;
    opm_PopMenuItem_PCat: TMenuItem;
    opm_PopMenuItem_PCopyAsText: TMenuItem;
    opm_PopMenuItem_PDelete: TMenuItem;
    opm_PopMenuItem_PEdit: TMenuItem;
    opm_PopMenuItem_PExport: TMenuItem;
    opm_PopMenuItem_PMan: TMenuItem;
    opm_PopMenuItem_PMod: TMenuItem;
    opm_PopMenuItem_PModel: TMenuItem;
    opm_PopMenuItem_PNotAvailable: TMenuItem;
    opm_PopMenuItem_PPrice: TMenuItem;
    opm_PopMenuItem_PQuantity: TMenuItem;
    opm_PopMenuItem_PSelAll: TMenuItem;
    opm_PopMenuItem_PSpecial: TMenuItem;
    opm_PopMenuItem_PWeight: TMenuItem;
    opm_PopupMenu_CatList: TPopupMenu;
    opm_PopupMenu_Connection: TPopupMenu;
    opm_PopupMenu_Debug: TPopupMenu;
    opm_PopupMenu_PList: TPopupMenu;
    opm_ProgressBar_Main: TProgressBar;
    opm_ProgressBar_Sec: TProgressBar;
    opm_SaveDialog_Export: TSaveDialog;
    opm_Splitter_Debug: TSplitter;
    opm_Splitter_Main: TSplitter;
    opm_StatusBar_Main: TStatusBar;
    opm_TreeView_Main: TTreeView;
    opm_MenuItem_Tools: TMenuItem;
    opm_MenuItem_ExternalModules: TMenuItem;
    N7: TMenuItem;
    opm_PopMenuItem_CatRename: TMenuItem;
    opm_PopMenuItem_PPrint: TMenuItem;
    opm_MenuItem_ProductPrint: TMenuItem;
    opm_PrintDialog_Print: TPrintDialog;
    opm_frReport_ProdList: TfrReport;
    opm_frUserDataset_ProdList: TfrUserDataset;
    opm_PopMenuItem_PCopyAsPre: TMenuItem;
    opm_MenuItem_ProductCopyAsPre: TMenuItem;
    opm_MenuItem_ProductCopy: TMenuItem;
    opm_PopMenuItem_PCopy: TMenuItem;
    opm_PopMenuItem_CatDelete: TMenuItem;
    opm_PopMenuItem_CatAdd: TMenuItem;
    opm_ImageList_Toolbar: TImageList;
    opm_ToolBar_Main: TToolBar;
    opm_ToolButton_Connect: TToolButton;
    opm_ToolButton_Disconnect: TToolButton;
    opm_ToolButton_Config: TToolButton;
    opm_ToolButton_Refresh: TToolButton;
    opm_ToolButton_AddProduct: TToolButton;
    opm_ToolButton_EditProduct: TToolButton;
    opm_ToolButton_Search: TToolButton;
    opm_ToolButton_Sep3: TToolButton;
    opm_ToolButton_Sep4: TToolButton;
    opm_ToolButton_Sep6: TToolButton;
    opm_ToolButton_DeleteProduct: TToolButton;
    opm_Panel_ToolbarLanguage: TPanel;
    opm_ToolButton_Sep1: TToolButton;
    opm_ComboBox_DisplayLang: TComboBox;
    opm_ToolButton_Exit: TToolButton;
    opm_ToolButton_ExportProduct: TToolButton;
    opm_ToolButton_PrintProduct: TToolButton;
    opm_ToolButton_AddCat: TToolButton;
    opm_ToolButton_RenCat: TToolButton;
    opm_ToolButton_DelCat: TToolButton;
    opm_ToolButton_Sep2: TToolButton;
    N5: TMenuItem;
    opm_MenuItem_CategoryAdd: TMenuItem;
    opm_MenuItem_CategoryDelete: TMenuItem;
    opm_MenuItem_CategoryRename: TMenuItem;
    opm_ImageList_MainMenu: TImageList;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure opm_ComboBox_DisplayLangSelect(Sender: TObject);
    procedure opm_ListView_MainDblClick(Sender: TObject);
    procedure opm_MenuItem_AboutClick(Sender: TObject);
    procedure opm_MenuItem_ConfigClick(Sender: TObject);
    procedure opm_MenuItem_ConnectClick(Sender: TObject);
    procedure opm_MenuItem_DisconnectClick(Sender: TObject);
    procedure opm_MenuItem_ExitClick(Sender: TObject);
    procedure opm_MenuItem_LicenseClick(Sender: TObject);
    procedure opm_MenuItem_RefreshCategoriesClick(Sender: TObject);
    procedure opm_MenuItem_RefreshProductsClick(Sender: TObject);
    procedure opm_MenuItem_SearchProductClick(Sender: TObject);
    procedure opm_PopMenuItem_CatCollapse2Click(Sender: TObject);
    procedure opm_PopMenuItem_CatCollapseClick(Sender: TObject);
    procedure opm_PopMenuItem_CatExpand2Click(Sender: TObject);
    procedure opm_PopMenuItem_CatExpandClick(Sender: TObject);
    procedure opm_PopMenuItem_HideDebugClick(Sender: TObject);
    procedure opm_PopMenuItem_PAddClick(Sender: TObject);
    procedure opm_PopMenuItem_PAvailableClick(Sender: TObject);
    procedure opm_PopMenuItem_PCatClick(Sender: TObject);
    procedure opm_PopMenuItem_PCopyAsTextClick(Sender: TObject);
    procedure opm_PopMenuItem_PDeleteClick(Sender: TObject);
    procedure opm_PopMenuItem_PExportClick(Sender: TObject);
    procedure opm_PopMenuItem_PManClick(Sender: TObject);
    procedure opm_PopMenuItem_PModelClick(Sender: TObject);
    procedure opm_PopMenuItem_PNotAvailableClick(Sender: TObject);
    procedure opm_PopMenuItem_PPriceClick(Sender: TObject);
    procedure opm_PopMenuItem_PQuantityClick(Sender: TObject);
    procedure opm_PopMenuItem_PSelAllClick(Sender: TObject);
    procedure opm_PopMenuItem_PSpecialClick(Sender: TObject);
    procedure opm_PopMenuItem_PWeightClick(Sender: TObject);
    procedure opm_TreeView_MainChange(Sender: TObject; Node: TTreeNode);
    procedure opm_TreeView_MainCollapsing(Sender: TObject; Node: TTreeNode; var AllowCollapse: Boolean);
    procedure opm_TreeView_MainContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
    procedure opm_TreeView_MainDblClick(Sender: TObject);
    procedure opm_TreeView_MainDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure opm_TreeView_MainDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure opm_TreeView_MainExpanding(Sender: TObject; Node: TTreeNode; var AllowExpansion: Boolean);
    procedure opm_TreeView_MainKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure opm_TreeView_MainKeyPress(Sender: TObject; var Key: Char);
    procedure opm_MenuItem_ExternalModulesClick(Sender: TObject);
    procedure opm_PopMenuItem_CatRenameClick(Sender: TObject);
    procedure opm_TreeView_MainMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure opm_ListView_MainColumnClick(Sender: TObject; Column: TListColumn);
    procedure opm_PopMenuItem_PPrintClick(Sender: TObject);
    procedure opm_frReport_ProdListGetValue(const ParName: String; var ParValue: Variant);
    procedure opm_frUserDataset_ProdListCheckEOF(Sender: TObject; var Eof: Boolean);
    procedure opm_frUserDataset_ProdListFirst(Sender: TObject);
    procedure opm_frUserDataset_ProdListNext(Sender: TObject);
    procedure opm_PopMenuItem_PCopyAsPreClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure opm_PopMenuItem_CatDeleteClick(Sender: TObject);
    procedure opm_PopMenuItem_CatAddClick(Sender: TObject);
    procedure opm_ListView_MainKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure opm_ListView_MainChange(Sender: TObject; Item: TListItem; Change: TItemChange);
  private
    FUNCTION FNopm_Apply_Operation (SourceValue, Conversion: STRING; ValueType : INTEGER; AllowNegative : BOOLEAN) : STRING;
    FUNCTION FNopm_GetProductByID (ProdID, LangID : LONGINT; VAR ProdList : opmT_ProductList) : opmR_Product;
    FUNCTION FNopm_GetRealLangIDByIndex (VAR LangList : opmT_LanguageList; LangIndex : LONGINT) : LONGINT;
    PROCEDURE PRopm_Update_StatusBar (ConnectedStat, ProgressStat, SecProgress : LONGINT; StatusString : STRING; ProductTotal : LONGINT; CurCurr : STRING);
    PROCEDURE PRopm_AddCatTreeNode (VAR CatList : opmT_CategoryList; CatCurrentID : LONGINT; CurNode : TTreeNode; TreeDepth : INTEGER);
    PROCEDURE PRopm_AddProduct (NewProdRecord : opmR_Product; SingleDescList : opmT_SingleDescList);
    PROCEDURE PRopm_ClearCategoryList (VAR CatList : TStringList);
    PROCEDURE PRopm_ClearLanguageList (VAR LangList : TStringList);
    PROCEDURE PRopm_ClearManufacturerList (VAR ManList : TStringList);
    PROCEDURE PRopm_ClearProductList (VAR ListView : TListView);
    PROCEDURE PRopm_ClearTaxList (VAR TaxList : TStringList);
    PROCEDURE PRopm_Disconnect;
    PROCEDURE PRopm_Create_ExportList (VAR ExportString : STRING; VAR CatList : opmT_CategoryList; VAR ManList : opmT_ManufacturerList; JustifyCols : BOOLEAN);
    PROCEDURE PRopm_DeleteProduct (ProdID : LONGINT);
    PROCEDURE PRopm_LoadCategoryBoxList (VAR CatList : opmT_CategoryList; CatCurrentID, TreeDepth : LONGINT; VAR CatIndex : LONGINT; VAR CatBoxList : TStringList);
    PROCEDURE PRopm_LoadCategoryList (VAR CatList : opmT_CategoryList; VAR CatBoxList : TStringList);
    PROCEDURE PRopm_LoadConfiguration;
    PROCEDURE PRopm_LoadLanguageList (VAR LangList : opmT_LanguageList);
    PROCEDURE PRopm_LoadManufacturerList (VAR ManList : opmT_ManufacturerList; VAR ManBoxList : TStringList);
    PROCEDURE PRopm_LoadProductListByCat (ProductCat : LONGINT; VAR ProdList : opmT_ProductList; VAR DescList : opmT_DescriptionList);
    PROCEDURE PRopm_LoadTaxList (VAR TaxList : opmT_TaxList; VAR TaxBoxList : TStringList);
    PROCEDURE PRopm_Connect;
    PROCEDURE PRopm_RenderCategoryDisplay (VAR CatList : opmT_CategoryList; VAR TreeControl : TTreeView; CurCatID : LONGINT);
    PROCEDURE PRopm_RenderLanguageDisplay (VAR ListControl : TComboBox; VAR LangList : opmT_LanguageList);
    PROCEDURE PRopm_RenderProductDisplay (VAR CatList : opmT_CategoryList; VAR ManList : opmT_ManufacturerList; VAR ProdList : opmT_ProductList; VAR ListControl : TListView; CurProdID : LONGINT);
    PROCEDURE PRopm_SaveConfiguration;
    PROCEDURE PRopm_SearchProducts (PCategory, PManufacturer: LONGINT; PModel, PName, PDesc : STRING; PSPrice, PImgURL, PAvailable : LONGINT; VAR ProdList : opmT_ProductList; VAR DescList : opmT_DescriptionList);
    PROCEDURE PRopm_SetControls_Disconnected;
    PROCEDURE PRopm_SetDisplay (RememberVisual : WORD);
    PROCEDURE PRopm_SetControls_FullConnected;
    PROCEDURE PRopm_SetUnknown;
    PROCEDURE PRopm_UpdateProdData (ProdID : LONGINT; ProdTable, ProdField, ProdDataStr : STRING; PDataIsNum : BOOLEAN; SecIDField, SecIDData : STRING; SQLQueryType : INTEGER);
    PROCEDURE PRopm_UpdateProduct (CurProdRecord, NewProdRecord : opmR_Product; SingleDescList : opmT_SingleDescList);
    PROCEDURE PRopm_UpdateCatName (CatData : opmT_SingleCatList; TotalCats : LONGINT);
    PROCEDURE PRopm_AddCategory (CatData : opmT_SingleCatList; TotalCats : LONGINT; ParentCat : LONGINT);
    PROCEDURE PRopm_DeleteCategory (CatID : LONGINT);
    PROCEDURE PRopm_ResetVars;
    PROCEDURE PRopm_Valid_CatOps (WeAreConnected : BOOLEAN; SelectedCat : TTreeNode);
    PROCEDURE PRopm_Valid_ProdOps (WeAreConnected : BOOLEAN; SelectedProduct : TListItem; SelectedProds : LONGINT; SelectedCat : TTreeNode);
    PROCEDURE PRopm_Valid_GralOps (WeAreConnected : BOOLEAN);
    FUNCTION FNopm_LoadCurrency : opmR_Currency;
    FUNCTION FNopm_ClearCurrency : opmR_Currency;
  public
    FUNCTION FNopm_GetCategory (VAR CatList : opmT_CategoryList; CatID : LONGINT; SearchBy : INTEGER) : opmR_Category;
    FUNCTION FNopm_GetManufacturer (VAR ManList : opmT_ManufacturerList; ManID : LONGINT; SearchBy : INTEGER) : opmR_Manufacturer;
    FUNCTION FNopm_GetDescriptionByID (ProdID, LangID : LONGINT; VAR DescList : opmT_DescriptionList) : opmR_Description;
    PROCEDURE PRopm_SetUILang (LangISOID : STRING);
    FUNCTION FNopm_Create_ExchangeList (VAR ExchangeList : opmT_ExchangeList; IndexData, TargetData : STRING) : LONGINT;
    PROCEDURE PRopm_Reload_ProductList (SearchLoad : BOOLEAN);
    PROCEDURE PRopm_GetCategory_Data (CatID : LONGINT; VAR CatData : opmT_SingleCatList);
  end;


var
  opm_Form_Main: Topm_Form_Main;


FUNCTION FNopm_Sort_ProductList (Item1, Item2: TListItem; Column: INTEGER) : INTEGER; STDCALL;

implementation

USES gnugettext, config, license, about, pedit, pimgzoom, search, askuser,
     balloons, regconfig, attention, dataman, network, askupload, imageman, runmod,
     colorsel, printers, strutils, math, askcat;

{$R *.dfm}



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Enable/disable those controls valid when the client is
connected and the product list is downloaded.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_SetControls_FullConnected;
BEGIN
  IF (opmG_UseSSH > 0) THEN
    PRopm_Update_StatusBar (opmC_ConnStatYesSSH, opmC_ProgressIgnore, opmC_ProgressIgnore, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code)
  ELSE
    PRopm_Update_StatusBar (opmC_ConnStatYes, opmC_ProgressIgnore, opmC_ProgressIgnore, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  opm_ListView_Main.Enabled := TRUE;
  opm_TreeView_Main.Enabled := TRUE;
  opm_ComboBox_DisplayLang.Enabled := TRUE;
  opm_WeAreConnected := TRUE;
  PRopm_Valid_GralOps (opm_WeAreConnected);
  PRopm_Valid_CatOps (opm_WeAreConnected, NIL);
  PRopm_Valid_ProdOps (opm_WeAreConnected, NIL, 0, NIL);
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Enable/disable those controls valid when the client is
disconnected.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_SetControls_Disconnected;
BEGIN
  PRopm_Update_StatusBar (opmC_ConnStatNo, opmC_ProgressIgnore, opmC_ProgressIgnore, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  opm_ListView_Main.Enabled := FALSE;
  opm_TreeView_Main.Enabled := FALSE;
  opm_ComboBox_DisplayLang.Enabled := FALSE;
  opm_WeAreConnected := FALSE;
  PRopm_Valid_GralOps (opm_WeAreConnected);
  PRopm_Valid_CatOps (opm_WeAreConnected, NIL);
  PRopm_Valid_ProdOps (opm_WeAreConnected, NIL, 0, NIL);
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Enable/disable those controls valid when the the state
of the client connection is unknown (or waiting for a
connection).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_SetUnknown;
BEGIN
  PRopm_Update_StatusBar (opmC_ConnStatUnknown, opmC_ProgressIgnore, opmC_ProgressIgnore, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  opm_ListView_Main.Enabled := FALSE;
  opm_TreeView_Main.Enabled := FALSE;
  PRopm_Valid_GralOps (opm_WeAreConnected);
  PRopm_Valid_CatOps (opm_WeAreConnected, NIL);
  PRopm_Valid_ProdOps (opm_WeAreConnected, NIL, 0, NIL);
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Open a connection to the database server.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_Connect;
VAR
  StrResult : STRING;
BEGIN
  StrResult := '';
  PRopm_SetUnknown;
  IF (opmG_DBStorePass = 0) THEN
    BEGIN
      opm_Form_AskUser.AU_Title := _('Connecting to database...');
      opm_Form_AskUser.AU_Directions := _('Enter the database password');
      opm_Form_AskUser.AU_TextOrList := TRUE;
      opm_Form_AskUser.AU_PassChar := opmC_PasswordChar;
      opm_Form_AskUser.AU_MaxLen := opmC_DBPassword_MaxLen;
      opm_Form_AskUser.AU_DataText := opmG_DBPassword;
      IF (opm_Form_AskUser.ShowModal = mrOk) THEN opmG_DBPassword := opm_Form_AskUser.AU_DataText ELSE opmG_DBPassword := '';
      opm_Form_AskUser.AU_Title := _('Connecting to database...');
      opm_Form_AskUser.AU_Directions := _('Enter the SSH password');
      opm_Form_AskUser.AU_TextOrList := TRUE;
      opm_Form_AskUser.AU_PassChar := opmC_PasswordChar;
      opm_Form_AskUser.AU_MaxLen := opmC_DBPassword_MaxLen;
      opm_Form_AskUser.AU_DataText := opmG_SSHPassword;
      IF (opm_Form_AskUser.ShowModal = mrOk) THEN opmG_SSHPassword := opm_Form_AskUser.AU_DataText ELSE opmG_SSHPassword := '';
    END;
  Screen.Cursor := opmC_Wait_Mouse;
  IF (opmG_UseSSH > 0) THEN
    BEGIN
      IF (FNopm_CheckStallTunnel = TRUE) THEN
        BEGIN
          IF (FNopm_Message (_('It seems there is already a SSH encrypted tunnel. Do you want to close it before creating a new one?'), mtConfirmation, [mbYes, mbNo], opmG_UISilent) = mrYes) THEN
            PRopm_StopExternalAppByName (opmC_Def_SSHExe);
        END;
      PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, opmC_ProgressIgnore, _('Creating SSH encrypted tunnel...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
      IF (FNopm_OpenSSHTunnel (opmC_Def_SSHLocalHost, opmG_DBHost, opmG_SSHLocalPort, opmG_DBPort, opmG_SSHUsername, opmG_SSHPassword, opmG_UISSHDebug) = FALSE) THEN
        StrResult := _('Cannot connect SSH encrypted tunnel.');
    END;
  IF (StrResult = '') THEN
    IF (opmG_UseSSH > 0) THEN
      BEGIN
        PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, opmC_ProgressIgnore, _('Connecting to database server...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
        StrResult := FNopm_OpenDBConnection (opmC_Def_SSHLocalHost, opmC_Def_SSHLocalPort, opmG_DBProtocol, opmG_DBDatabase, opmG_DBUsername, opmG_DBPassword, opmG_DBCompress);
        IF (StrResult <> '') THEN PRopm_CloseSSHTunnel;
      END
    ELSE
      BEGIN
        PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, opmC_ProgressIgnore, _('Connecting to database server...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
        StrResult := FNopm_OpenDBConnection (opmG_DBHost, opmG_DBPort, opmG_DBProtocol, opmG_DBDatabase, opmG_DBUsername, opmG_DBPassword, opmG_DBCompress);
      END;
  Screen.Cursor := opmC_Normal_Mouse;
  IF (StrResult = '') THEN
    BEGIN
      PRopm_ResetVars;
      {PRopm_SetControls_FullConnected;}
    END
  ELSE
    BEGIN
      PRopm_SetControls_Disconnected;
      FNopm_Message (StrResult, mtError, [mbOk], opmG_UISilent);
    END;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Closes the connection to the database server.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_Disconnect;
VAR
  StrResult : STRING;
BEGIN
  PRopm_SetUnknown;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, opmC_ProgressIgnore, _('Disconnecting to database server...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  Screen.Cursor := opmC_Wait_Mouse;
  StrResult := FNopm_CloseDBConnection;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, opmC_ProgressIgnore, _('Disconnecting SSH encrypted tunnel...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  PRopm_CloseSSHTunnel;
  Screen.Cursor := opmC_Normal_Mouse;
  PRopm_Update_StatusBar (opmC_ConnStatNo, opmC_ProgressNone, opmC_ProgressNone, _('Disconnected from database server.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  PRopm_SetControls_Disconnected;
  PRopm_ResetVars;
  IF (StrResult <> '') THEN FNopm_Message (StrResult, mtError, [mbOk], opmG_UISilent);
END;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Takes a source value, a target conversion value, and a value type.
Then applies the operation or target value to the source value and
return the result (in an integer or currency type according to the
value type). The target values can be simple numbers or operations.
A simple value will simply overwrite the source value with the target
one. An operation will transform the source value. Valid operations
are addition (+X), substraction (-X), percetage increase (+X%),
percentage decrease (-X%).  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
FUNCTION Topm_Form_Main.FNopm_Apply_Operation (SourceValue, Conversion : STRING;
                                               ValueType : INTEGER; AllowNegative : BOOLEAN) : STRING;
VAR
  TmpOperand, TmpSource, TmpTarget : CURRENCY;
  TmpValue : STRING;
BEGIN
  TmpValue := FNopm_CleanNumber (Conversion, opmC_ValIsNumOp);
  TmpOperand := STRTOCURR (FNopm_CleanNumber (Conversion, opmC_ValIsFloat));
  TmpSource := STRTOCURR (FNopm_CleanNumber (SourceValue, opmC_ValIsFloat));
  IF (TmpValue[LENGTH (TmpValue)] = '%') THEN
    BEGIN
      TmpOperand := (TmpSource / 100) * TmpOperand;
    END;
  IF ((TmpValue[1] = '-') OR (TmpValue[1] = '+')) THEN
    BEGIN
      TmpTarget := TmpSource + TmpOperand;
      IF (AllowNegative = FALSE) THEN IF (TmpTarget < 0) THEN TmpTarget := 0;
    END
  ELSE
    BEGIN
      TmpTarget := ABS (TmpOperand);
    END;
  IF (ValueType = opmC_ValIsInteger) THEN
    BEGIN
      FNopm_Apply_Operation := INTTOSTR (ROUND (TmpTarget));
    END
  ELSE
    BEGIN
      FNopm_Apply_Operation := FloatToStrF (TmpTarget, ffFixed, 15, 2);
    END;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Shows the configuration form and then check if any values were
changed (in the global configuration vars) to apply those changes
to the user interface.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_MenuItem_ConfigClick(Sender: TObject);
VAR
  PrevToolTips : WORD;
begin
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Configuring...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  PrevToolTips := opmG_UIToolTips;
  IF (opm_Form_Config.ShowModal = mrOk) THEN
    BEGIN
      {IF (opmG_UIHotTracking > 0) THEN
        BEGIN
          opm_TreeView_Main.HotTrack := TRUE;
          opm_ListView_Main.HotTrack := FALSE;
          opm_ListView_Main.HotTrackStyles := [htHandPoint, htUnderlineHot];
          opm_Form_Config.opm_PageControl_Config.HotTrack := TRUE;
          opm_Form_PEdit.opm_TabControl_PEdit.HotTrack := TRUE;
          opm_Form_PEdit.opm_TabControl_PEdit.HotTrack := TRUE;
          opm_Form_PEdit.opm_PageControl_PEdit.HotTrack := TRUE;
        END
      ELSE
        BEGIN
          opm_TreeView_Main.HotTrack := FALSE;
          opm_ListView_Main.HotTrack := FALSE;
          opm_ListView_Main.HotTrackStyles := [];
          opm_Form_Config.opm_PageControl_Config.HotTrack := FALSE;
          opm_Form_PEdit.opm_TabControl_PEdit.HotTrack := FALSE;
          opm_Form_PEdit.opm_TabControl_PEdit.HotTrack := FALSE;
          opm_Form_PEdit.opm_PageControl_PEdit.HotTrack := FALSE;
        END;}
      IF (opmG_UIDragDrop > 0) THEN
        opm_ListView_Main.DragMode := dmAutomatic
      ELSE
        opm_ListView_Main.DragMode := dmManual;
      IF ((opmG_UIToolTips > 0) AND (PrevToolTips = 0)) THEN
        BEGIN
          PRballoon_DestroyAllBalloons;
          PRballoon_SetFormBalloons (opm_Form_Main, opmG_UIToolTips);
          PRballoon_SetFormBalloons (opm_Form_License, opmG_UIToolTips);
          PRballoon_SetFormBalloons (opm_Form_About, opmG_UIToolTips);
          PRballoon_SetFormBalloons (opm_Form_PEdit, opmG_UIToolTips);
          PRballoon_SetFormBalloons (opm_Form_ImageZoom, opmG_UIToolTips);
          PRballoon_SetFormBalloons (opm_Form_SearchProduct, opmG_UIToolTips);
          PRballoon_SetFormBalloons (opm_Form_UploadImage, opmG_UIToolTips);
          PRballoon_SetFormBalloons (opm_Form_AskUser, opmG_UIToolTips);
          PRballoon_SetFormBalloons (opm_Form_Config, opmG_UIToolTips);
          PRballoon_SetFormBalloons (opm_Form_Runmod, opmG_UIToolTips);
          PRballoon_SetFormBalloons (opm_Form_Colorsel, opmG_UIToolTips);
        END;
      IF ((opmG_UIToolTips = 0) AND (PrevToolTips > 0)) THEN
        PRballoon_DestroyAllBalloons;
      PRopm_SetUILang (opmG_UIGUILang);
      IF (opmG_UIDBDebug > 0) THEN
        BEGIN
          opm_DataSource_DEBUG.Enabled := TRUE;
          opm_DBGrid_DEBUG.Enabled := TRUE;
          opm_DBGrid_DEBUG.Visible := TRUE;
          opm_Panel_DEBUG.Visible := TRUE;
        END
      ELSE
        BEGIN
          opm_DataSource_DEBUG.Enabled := FALSE;
          opm_DBGrid_DEBUG.Enabled := FALSE;
          opm_DBGrid_DEBUG.Visible := FALSE;
          opm_Panel_DEBUG.Visible := FALSE;
        END;
      IF (opmG_UIWBDebug > 0) THEN
        BEGIN
          opm_Form_PEdit.opm_Memo_UploadDEBUG.Enabled := TRUE;
          opm_Form_PEdit.opm_Memo_UploadDEBUG.Visible := TRUE;
        END
      ELSE
        BEGIN
          opm_Form_PEdit.opm_Memo_UploadDEBUG.Enabled := FALSE;
          opm_Form_PEdit.opm_Memo_UploadDEBUG.Visible := FALSE;
        END;
    END;
  opm_PRAddModules_ToMenu (opm_MenuItem_ExternalModules);
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Configuration done.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Terminates the application.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_MenuItem_ExitClick(Sender: TObject);
begin
  Close;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Opens the DB connection, load the language, category and manufacturer
lists in memory, build the language menu and the category tree,
clears the product list and enable some controls.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_MenuItem_ConnectClick(Sender: TObject);
begin
  PRopm_Connect;
  IF (FNopm_ConnectionState = TRUE) THEN
    BEGIN
      PRopm_LoadLanguageList (opmG_LanguageList);
      PRopm_LoadCategoryList (opmG_CategoryList, opmG_CategoryBoxList);
      PRopm_LoadManufacturerList (opmG_ManufacturerList, opmG_ManufacturerBoxList);
      PRopm_LoadTaxList (opmG_TaxList, opmG_TaxBoxList);
      opm_CurrentCurrency := FNopm_LoadCurrency;
      PRopm_RenderLanguageDisplay (opm_ComboBox_DisplayLang, opmG_LanguageList);
      PRopm_RenderCategoryDisplay (opmG_CategoryList, opm_TreeView_Main, opm_CurrentCategory);
      PRopm_ClearProductList (opm_ListView_Main);
      PRopm_SetControls_FullConnected;
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Closes the DB connection, clear the language, category, manufacturer
and product lists, clear the display of the language menu, product list
and category tree, and enable some controls.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_MenuItem_DisconnectClick(Sender: TObject);
begin
  PRopm_Disconnect;
  IF (FNopm_ConnectionState = FALSE) THEN
    BEGIN
      PRopm_ClearLanguageList (opmG_LanguageBoxList);
      PRopm_ClearCategoryList (opmG_CategoryBoxList);
      PRopm_ClearManufacturerList (opmG_ManufacturerBoxList);
      PRopm_ClearTaxList (opmG_TaxBoxList);
      opm_CurrentCurrency := FNopm_ClearCurrency;
      PRopm_ClearProductList (opm_ListView_Main);
      PRopm_RenderLanguageDisplay (opm_ComboBox_DisplayLang, opmG_LanguageList);
      PRopm_RenderCategoryDisplay (opmG_CategoryList, opm_TreeView_Main, opm_CurrentCategory);
      PRopm_RenderProductDisplay (opmG_CategoryList, opmG_ManufacturerList, opmG_ProductList, opm_ListView_Main, opm_CurrentProdID);
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Creates some objects, load the configuration from the Windows registry,
reset all vars, set several parameters of the visual components,
set the language of the user interface and the help balloons (if enabled).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.FormCreate(Sender: TObject);
begin
  opmG_TMPPath := FNopm_GetTemporaryPath;
  opm_DataSource_DEBUG.DataSet := opmG_DBQuery;
  opm_CurrentLang := 0;
  PRopm_LoadConfiguration;
  PRopm_ResetVars;
  PRopm_ResetLog;
  PRopm_SetDisplay (opmG_UIRememberDisplay);
  PRopm_SetControls_Disconnected;
  opm_PRLoad_ModuleList;
  opm_PRAddModules_ToMenu (opm_MenuItem_ExternalModules);
  IF (FNopm_CheckLanguage (opmG_UIGUILang) = FALSE) THEN UseLanguage (opmC_Def_GUILang) ELSE UseLanguage (opmG_UIGUILang);
  TP_GlobalIgnoreClass(TField);
  TP_GlobalIgnoreClass(TDBGrid);
  TranslateComponent (self);
  PRballoon_SetFormBalloons (self, opmG_UIToolTips);
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Resets some variables used to keep track of the product information.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_ResetVars;
BEGIN
  opm_TotalCategories := 0;
  opm_TotalManufacturers := 0;
  opm_TotalLanguages := 0;
  opm_TotalProducts := 0;
  opm_TotalTaxes := 0;
  opm_CurrentCategory := 0;
  opm_CurrentMan := 0;
  opm_CurrentProdID := 0;
  opm_Search_PCategory := 0;
  opm_Search_PManufacturer := 0;
  opm_Search_PModel := '';
  opm_Search_PName := '';
  opm_CanExpandTree_Flag := TRUE;
  opm_WeAreSearching := FALSE;
  opm_WeAreConnected := FALSE;
  opmG_PList_LastOrderColumn := 4;
  opmG_PList_LastOrderType := FALSE;
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Loads the configuration options from the Windows registry.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_LoadConfiguration;
BEGIN
  opmG_DBHost := FNopm_CleanHostName (FNReg_ReadSetting ('OSCHost', opmC_Def_Host, opmC_RegistryKey, opmC_RKConfig));
  opmG_DBPort := FNopm_StrToInt (FNReg_ReadSetting ('OSCPort', INTTOSTR (opmC_Def_Port), opmC_RegistryKey, opmC_RKConfig));
  opmG_DBProtocol := FNReg_ReadSetting ('OSCProtocol', opmC_Def_Protocol, opmC_RegistryKey, opmC_RKConfig);
  opmG_ETABase := FNopm_StrToInt (FNReg_ReadSetting ('OSCETABase', opmC_Def_ETABase, opmC_RegistryKey, opmC_RKConfig));
  opmG_DBDatabase := FNReg_ReadSetting ('OSCDatabase', opmC_Def_Database, opmC_RegistryKey, opmC_RKConfig);
  opmG_DBTable_Categories := FNReg_ReadSetting ('OSCTable01', opmC_Def_DBTable_Categories, opmC_RegistryKey, opmC_RKConfig);
  opmG_DBTable_Manufacturers := FNReg_ReadSetting ('OSCTable02', opmC_Def_DBTable_Manufacturers, opmC_RegistryKey, opmC_RKConfig);
  opmG_DBTable_Languages := FNReg_ReadSetting ('OSCTable03', opmC_Def_DBTable_Languages, opmC_RegistryKey, opmC_RKConfig);
  opmG_DBTable_Products := FNReg_ReadSetting ('OSCTable04', opmC_Def_DBTable_Products, opmC_RegistryKey, opmC_RKConfig);
  opmG_DBTable_Specials := FNReg_ReadSetting ('OSCTable05', opmC_Def_DBTable_Specials, opmC_RegistryKey, opmC_RKConfig);
  opmG_DBTable_ProductsDescription := FNReg_ReadSetting ('OSCTable06', opmC_Def_DBTable_ProductsDescription, opmC_RegistryKey, opmC_RKConfig);
  opmG_DBTable_TaxClass := FNReg_ReadSetting ('OSCTable07', opmC_Def_DBTable_TaxClass, opmC_RegistryKey, opmC_RKConfig);
  opmG_DBTable_Currencies := FNReg_ReadSetting ('OSCTable08', opmC_Def_DBTable_Currencies, opmC_RegistryKey, opmC_RKConfig);
  opmG_DBTable_Configuration := FNReg_ReadSetting ('OSCTable09', opmC_Def_DBTable_Configuration, opmC_RegistryKey, opmC_RKConfig);
  opmG_DBTable_ProductsToCategories := FNReg_ReadSetting ('OSCTable10', opmC_Def_DBTable_ProductsToCategories, opmC_RegistryKey, opmC_RKConfig);
  opmG_DBTable_CategoriesDescription := FNReg_ReadSetting ('OSCTable11', opmC_Def_DBTable_CategoriesDescription, opmC_RegistryKey, opmC_RKConfig);
  opmG_DBTable_TaxRates := FNReg_ReadSetting ('OSCTable13', opmC_Def_DBTable_TaxRates, opmC_RegistryKey, opmC_RKConfig);
  opmG_DBUsername := FNReg_ReadSetting ('OSCUsername', opmC_Def_Username, opmC_RegistryKey, opmC_RKConfig);
  opmG_DBPassword := FNReg_ReadSetting ('OSCPassword', opmC_Def_Password, opmC_RegistryKey, opmC_RKConfig);
  opmG_WBImgURL := FNReg_ReadSetting ('OSCImgURL', opmC_Def_ImgURL, opmC_RegistryKey, opmC_RKConfig);
  opmG_WBUploadURL := FNReg_ReadSetting ('OSCUploadURL', opmC_Def_UploadURL, opmC_RegistryKey, opmC_RKConfig);
  opmG_WBProxyHost := FNopm_CleanHostName (FNReg_ReadSetting ('OSCProxyHost', opmC_Def_ProxyHost, opmC_RegistryKey, opmC_RKConfig));
  opmG_WBProxyPort := FNopm_StrToInt (FNReg_ReadSetting ('OSCProxyPort', INTTOSTR (opmC_Def_ProxyPort), opmC_RegistryKey, opmC_RKConfig));
  opmG_DBConnWait := FNopm_StrToInt (FNReg_ReadSetting ('OSCDBConnWait', INTTOSTR (opmC_Def_DBConnWait), opmC_RegistryKey, opmC_RKConfig));
  opmG_ModConnWait := FNopm_StrToInt (FNReg_ReadSetting ('OSCModConnWait', INTTOSTR (opmC_Def_ModConnWait), opmC_RegistryKey, opmC_RKConfig));
  opmG_SSHConnWait := FNopm_StrToInt (FNReg_ReadSetting ('OSCSSHConnWait', INTTOSTR (opmC_Def_SSHConnWait), opmC_RegistryKey, opmC_RKConfig));
  opmG_DBConnRetries := FNopm_StrToInt (FNReg_ReadSetting ('OSCDBConnRetries', INTTOSTR (opmC_Def_DBConnRetries), opmC_RegistryKey, opmC_RKConfig));
  opmG_ModConnRetries := FNopm_StrToInt (FNReg_ReadSetting ('OSCModConnRetries', INTTOSTR (opmC_Def_ModConnRetries), opmC_RegistryKey, opmC_RKConfig));
  opmG_WBImgX := FNopm_StrToInt (FNReg_ReadSetting ('OSCImgX', INTTOSTR (opmC_Def_ImgX), opmC_RegistryKey, opmC_RKConfig));
  opmG_WBImgY := FNopm_StrToInt (FNReg_ReadSetting ('OSCImgY', INTTOSTR (opmC_Def_ImgY), opmC_RegistryKey, opmC_RKConfig));
  opmG_WBImgQ := FNopm_StrToInt (FNReg_ReadSetting ('OSCImgQ', INTTOSTR (opmC_Def_ImgQ), opmC_RegistryKey, opmC_RKConfig));
  opmG_WBPaddingColor := FNopm_StrToInt (FNReg_ReadSetting ('OSCPaddingColor', INTTOSTR (opmC_Def_PaddingColor), opmC_RegistryKey, opmC_RKConfig));
  IF (opmG_WBImgURL[LENGTH (opmG_WBImgURL)] <> '/') THEN opmG_WBImgURL := opmG_WBImgURL + '/';
  opm_CurrentLang := ABS (FNopm_StrToInt (FNReg_ReadSetting ('OSCLanguage', INTTOSTR (opmC_Def_DisplayLang), opmC_RegistryKey, opmC_RKRoot)));
  opmG_UIHotTracking := FNopm_StrToInt (FNReg_ReadSetting ('OSCHotTracking', INTTOSTR (opmC_Def_HotTracking), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIClickLoad := FNopm_StrToInt (FNReg_ReadSetting ('OSCAutoLoad', INTTOSTR (opmC_Def_AutoLoad), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIDragDrop := FNopm_StrToInt (FNReg_ReadSetting ('OSCDragDrop', INTTOSTR (opmC_Def_DragDrop), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIToolTips := FNopm_StrToInt (FNReg_ReadSetting ('OSCToolTips', INTTOSTR (opmC_Def_ToolTips), opmC_RegistryKey, opmC_RKConfig));
  opmG_DBCompress := FNopm_StrToInt (FNReg_ReadSetting ('OSCCompress', INTTOSTR (opmC_Def_Compress), opmC_RegistryKey, opmC_RKConfig));
  opmG_UseProxy := FNopm_StrToInt (FNReg_ReadSetting ('OSCUseProxy', INTTOSTR (opmC_Def_UseProxy), opmC_RegistryKey, opmC_RKConfig));
  opmG_UseSSH := FNopm_StrToInt (FNReg_ReadSetting ('OSCUseSSH', INTTOSTR (opmC_Def_UseSSH), opmC_RegistryKey, opmC_RKConfig));
  opmG_SSHUsername := FNReg_ReadSetting ('OSCSSHUsername', opmC_Def_SSHUsername, opmC_RegistryKey, opmC_RKConfig);
  opmG_SSHPassword := FNReg_ReadSetting ('OSCSSHPassword', opmC_Def_SSHPassword, opmC_RegistryKey, opmC_RKConfig);
  opmG_SSHLocalPort := FNopm_StrToInt (FNReg_ReadSetting ('OSCSSHLocalPort', INTTOSTR (opmC_Def_SSHLocalPort), opmC_RegistryKey, opmC_RKConfig));
  opmG_DBStorePass := FNopm_StrToInt (FNReg_ReadSetting ('OSCStorePass', INTTOSTR (opmC_Def_StorePass), opmC_RegistryKey, opmC_RKConfig));
  opmG_UISilent := FNopm_StrToInt (FNReg_ReadSetting ('OSCSilent', INTTOSTR (opmC_Def_Silent), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIConfirmDels := FNopm_StrToInt (FNReg_ReadSetting ('OSCConfirmDels', INTTOSTR (opmC_Def_ConfirmDels), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIConfirmDrag := FNopm_StrToInt (FNReg_ReadSetting ('OSCConfirmDrag', INTTOSTR (opmC_Def_ConfirmDrag), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIConfirmMods := FNopm_StrToInt (FNReg_ReadSetting ('OSCConfirmMods', INTTOSTR (opmC_Def_ConfirmMods), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIAllowZeroPrice := FNopm_StrToInt (FNReg_ReadSetting ('OSCAllowZeroPrice', INTTOSTR (opmC_Def_AllowZeroPrice), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIAllowEditImageName := FNopm_StrToInt (FNReg_ReadSetting ('OSCAllowEditImageName', INTTOSTR (opmC_Def_AllowEditImageName), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIAllowNegativeQuantity := FNopm_StrToInt (FNReg_ReadSetting ('OSCAllowNegativeQuantity', INTTOSTR (opmC_Def_AllowNegativeQuantity), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIAutoDownImg := FNopm_StrToInt (FNReg_ReadSetting ('OSCAutoDownImg', INTTOSTR (opmC_Def_AutoDownImg), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIFontName := FNReg_ReadSetting ('UIFontName', opmC_DefaultFont, opmC_RegistryKey, opmC_RKVisual);
  opmG_UIFontHeight := FNopm_StrToInt (FNReg_ReadSetting ('UIFontHeight', INTTOSTR (opmC_DefaultFontHeight), opmC_RegistryKey, opmC_RKVisual));
  opmG_UIFontCharset := FNopm_StrToInt (FNReg_ReadSetting ('UIFontCharset', INTTOSTR (opmC_DefaultFontCharset), opmC_RegistryKey, opmC_RKVisual));
  opmG_Clip_ColSize := FNopm_StrToInt (FNReg_ReadSetting ('Clip_ColSize', INTTOSTR (opmC_Def_Clip_ColSize), opmC_RegistryKey, opmC_RKVisual));
  opmG_PRNDirectPrint := FNopm_StrToInt (FNReg_ReadSetting ('PRNDirectPrint', INTTOSTR (opmC_Def_PRNDirectPrint), opmC_RegistryKey, opmC_RKVisual));
  opmG_Past_PAvailDate := FNopm_StrToInt (FNReg_ReadSetting ('PastAvailDate', INTTOSTR (opmC_Def_Past_PAvailDate), opmC_RegistryKey, opmC_RKVisual));
  opmG_Past_PManufacturer := FNopm_StrToInt (FNReg_ReadSetting ('PastManufacturer', INTTOSTR (opmC_Def_Past_PManufacturer), opmC_RegistryKey, opmC_RKVisual));
  opmG_Past_PTaxClass := FNopm_StrToInt (FNReg_ReadSetting ('PastTaxClass', INTTOSTR (opmC_Def_Past_PTaxClass), opmC_RegistryKey, opmC_RKVisual));
  opmG_Past_PImageDir := FNReg_ReadSetting ('PastImageDir', opmC_Def_Past_PImageDir, opmC_RegistryKey, opmC_RKVisual);
  opmG_WBNoCacheImg := FNopm_StrToInt (FNReg_ReadSetting ('OSCNoCacheImg', INTTOSTR (opmC_Def_NoCacheImg), opmC_RegistryKey, opmC_RKConfig));
  opmG_WBResizeImg := FNopm_StrToInt (FNReg_ReadSetting ('OSCResizeImg', INTTOSTR (opmC_Def_ResizeImg), opmC_RegistryKey, opmC_RKConfig));
  opmG_WBPaddingImg := FNopm_StrToInt (FNReg_ReadSetting ('OSCPaddingImg', INTTOSTR (opmC_Def_PaddingImg), opmC_RegistryKey, opmC_RKConfig));
  opmG_WBKeepARImg := FNopm_StrToInt (FNReg_ReadSetting ('OSCKeepARImg', INTTOSTR (opmC_Def_KeepARImg), opmC_RegistryKey, opmC_RKConfig));
  opmG_WBSmartRename := FNopm_StrToInt (FNReg_ReadSetting ('OSCSmartRename', INTTOSTR (opmC_Def_SmartRename), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIConfirmExit := FNopm_StrToInt (FNReg_ReadSetting ('OSCConfirmExit', INTTOSTR (opmC_Def_ConfirmExit), opmC_RegistryKey, opmC_RKConfig));
  opmG_DBDebugLog := FNopm_StrToInt (FNReg_ReadSetting ('OSCDBDebugLog', INTTOSTR (opmC_Def_DBDebugLog), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIDBDebug := FNopm_StrToInt (FNReg_ReadSetting ('OSCDBDebug', INTTOSTR (opmC_Def_DBDebug), opmC_RegistryKey, opmC_RKConfig));
  opmG_UISSHDebug := FNopm_StrToInt (FNReg_ReadSetting ('OSCSSHDebug', INTTOSTR (opmC_Def_SSHDebug), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIWBDebug := FNopm_StrToInt (FNReg_ReadSetting ('OSCWBDebug', INTTOSTR (opmC_Def_WBDebug), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIGUILang := FNReg_ReadSetting ('OSCGUILang', opmC_Def_GUILang, opmC_RegistryKey, opmC_RKConfig);
  IF (FNopm_CheckLanguage (opmG_UIGUILang) = FALSE) THEN opmG_UIGUILang := opmC_Def_GUILang;
  opmG_UIRememberDisplay := FNopm_StrToInt (FNReg_ReadSetting ('OSCRememberPosition', INTTOSTR (opmC_Def_RememberDisplay), opmC_RegistryKey, opmC_RKConfig));
  opmG_UIWindow_XSize := ABS (FNopm_StrToInt (FNReg_ReadSetting ('OSCWinX', INTTOSTR (opmC_DefWindow_XSize), opmC_RegistryKey, opmC_RKVisual)));
  IF ((opmG_UIWindow_XSize < opmC_MinWindow_XSize) OR (opmG_UIWindow_XSize > opmC_MaxWindow_XSize)) THEN opmG_UIWindow_XSize := opmC_DefWindow_XSize;
  opmG_UIWindow_YSize := ABS (FNopm_StrToInt (FNReg_ReadSetting ('OSCWinY', INTTOSTR (opmC_DefWindow_YSize), opmC_RegistryKey, opmC_RKVisual)));
  IF ((opmG_UIWindow_YSize < opmC_MinWindow_YSize) OR (opmG_UIWindow_YSize > opmC_MaxWindow_YSize)) THEN opmG_UIWindow_YSize := opmC_DefWindow_YSize;
  opmG_UICatList_XSize := ABS (FNopm_StrToInt (FNReg_ReadSetting ('OSCListX', INTTOSTR (opmC_DefCatList_Size), opmC_RegistryKey, opmC_RKVisual)));
  IF ((opmG_UICatList_XSize < opmC_MinCatList_Size) OR (opmG_UICatList_XSize > opmC_MaxCatList_Size)) THEN opmG_UICatList_XSize := opmC_DefCatList_Size;
  IF ((opmG_UICatList_XSize + 100) > opmG_UIWindow_XSize) THEN opmG_UIWindow_XSize := opmG_UICatList_XSize + 100;
  opmG_UICol0X := ABS (FNopm_StrToInt (FNReg_ReadSetting ('Col0X', INTTOSTR (opmC_Def_Col0X), opmC_RegistryKey, opmC_RKVisual)));
  IF (opmG_UICol0X < opmC_MinColX) THEN opmG_UICol0X := opmC_MinColX;
  opmG_UICol1X := ABS (FNopm_StrToInt (FNReg_ReadSetting ('Col1X', INTTOSTR (opmC_Def_Col1X), opmC_RegistryKey, opmC_RKVisual)));
  IF (opmG_UICol1X < opmC_MinColX) THEN opmG_UICol1X := opmC_MinColX;
  opmG_UICol2X := ABS (FNopm_StrToInt (FNReg_ReadSetting ('Col2X', INTTOSTR (opmC_Def_Col2X), opmC_RegistryKey, opmC_RKVisual)));
  IF (opmG_UICol2X < opmC_MinColX) THEN opmG_UICol2X := opmC_MinColX;
  opmG_UICol3X := ABS (FNopm_StrToInt (FNReg_ReadSetting ('Col3X', INTTOSTR (opmC_Def_Col3X), opmC_RegistryKey, opmC_RKVisual)));
  IF (opmG_UICol3X < opmC_MinColX) THEN opmG_UICol3X := opmC_MinColX;
  opmG_UICol4X := ABS (FNopm_StrToInt (FNReg_ReadSetting ('Col4X', INTTOSTR (opmC_Def_Col4X), opmC_RegistryKey, opmC_RKVisual)));
  IF (opmG_UICol4X < opmC_MinColX) THEN opmG_UICol4X := opmC_MinColX;
  opmG_UICol5X := ABS (FNopm_StrToInt (FNReg_ReadSetting ('Col5X', INTTOSTR (opmC_Def_Col5X), opmC_RegistryKey, opmC_RKVisual)));
  IF (opmG_UICol5X < opmC_MinColX) THEN opmG_UICol5X := opmC_MinColX;
  opmG_UICol6X := ABS (FNopm_StrToInt (FNReg_ReadSetting ('Col6X', INTTOSTR (opmC_Def_Col6X), opmC_RegistryKey, opmC_RKVisual)));
  IF (opmG_UICol6X < opmC_MinColX) THEN opmG_UICol6X := opmC_MinColX;
  opmG_UICol7X := ABS (FNopm_StrToInt (FNReg_ReadSetting ('Col7X', INTTOSTR (opmC_Def_Col7X), opmC_RegistryKey, opmC_RKVisual)));
  IF (opmG_UICol7X < opmC_MinColX) THEN opmG_UICol7X := opmC_MinColX;
  opmG_UICol8X := ABS (FNopm_StrToInt (FNReg_ReadSetting ('Col8X', INTTOSTR (opmC_Def_Col8X), opmC_RegistryKey, opmC_RKVisual)));
  IF (opmG_UICol8X < opmC_MinColX) THEN opmG_UICol8X := opmC_MinColX;
  opmG_UICol9X := ABS (FNopm_StrToInt (FNReg_ReadSetting ('Col9X', INTTOSTR (opmC_Def_Col9X), opmC_RegistryKey, opmC_RKVisual)));
  IF (opmG_UICol9X < opmC_MinColX) THEN opmG_UICol9X := opmC_MinColX;
  opmG_UICol10X := ABS (FNopm_StrToInt (FNReg_ReadSetting ('Col10X', INTTOSTR (opmC_Def_Col10X), opmC_RegistryKey, opmC_RKVisual)));
  IF (opmG_UICol10X < opmC_MinColX) THEN opmG_UICol10X := opmC_MinColX;
  opmG_UICol20X := ABS (FNopm_StrToInt (FNReg_ReadSetting ('Col20X', INTTOSTR (opmC_Def_Col20X), opmC_RegistryKey, opmC_RKVisual)));
  IF (opmG_UICol20X < opmC_MinColX) THEN opmG_UICol20X := opmC_MinColX;
  opmG_UICol21X := ABS (FNopm_StrToInt (FNReg_ReadSetting ('Col21X', INTTOSTR (opmC_Def_Col21X), opmC_RegistryKey, opmC_RKVisual)));
  IF (opmG_UICol20X < opmC_MinColX) THEN opmG_UICol21X := opmC_MinColX;
  opmG_UICol22X := ABS (FNopm_StrToInt (FNReg_ReadSetting ('Col22X', INTTOSTR (opmC_Def_Col22X), opmC_RegistryKey, opmC_RKVisual)));
  IF (opmG_UICol20X < opmC_MinColX) THEN opmG_UICol22X := opmC_MinColX;
  PRReg_ReadPastList ('Host', opmC_RegistryKey, opmC_RKServers, opmG_PastHost_BoxList, opmC_MaxPast_Servers);
  PRReg_ReadPastList ('Database', opmC_RegistryKey, opmC_RKServers, opmG_PastDatabase_BoxList, opmC_MaxPast_Databases);
  PRReg_ReadPastList ('Username', opmC_RegistryKey, opmC_RKServers, opmG_PastUsername_BoxList, opmC_MaxPast_Usernames);
  PRReg_ReadPastList ('SSHUsername', opmC_RegistryKey, opmC_RKServers, opmG_PastSSHUsername_BoxList, opmC_MaxPast_SSHUsernames);
  PRReg_ReadPastList ('ImgURL', opmC_RegistryKey, opmC_RKServers, opmG_PastImgURL_BoxList, opmC_MaxPast_ImgURL);
  PRReg_ReadPastList ('UploadURL', opmC_RegistryKey, opmC_RKServers, opmG_PastUploadURL_BoxList, opmC_MaxPast_UploadURL);
  PRReg_ReadPastList ('Proxy', opmC_RegistryKey, opmC_RKServers, opmG_PastProxy_BoxList, opmC_MaxPast_Proxy);
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Saves some configuration options to the Windows registry.
Only options about the user interface are stored here, other
options are stored when running the configuration form.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_SaveConfiguration;
BEGIN
  PRReg_WriteSetting ('OSCWinX', INTTOSTR (opm_Form_Main.Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('OSCWinY', INTTOSTR (opm_Form_Main.Height), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('OSCListX', INTTOSTR (opm_TreeView_Main.Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Col0X', INTTOSTR (opm_ListView_Main.Column[0].Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Col1X', INTTOSTR (opm_ListView_Main.Column[1].Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Col2X', INTTOSTR (opm_ListView_Main.Column[2].Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Col3X', INTTOSTR (opm_ListView_Main.Column[3].Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Col4X', INTTOSTR (opm_ListView_Main.Column[4].Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Col5X', INTTOSTR (opm_ListView_Main.Column[5].Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Col6X', INTTOSTR (opm_ListView_Main.Column[6].Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Col7X', INTTOSTR (opm_ListView_Main.Column[7].Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Col8X', INTTOSTR (opm_ListView_Main.Column[8].Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Col9X', INTTOSTR (opm_ListView_Main.Column[9].Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Col10X', INTTOSTR (opm_ListView_Main.Column[10].Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Col20X', INTTOSTR (opm_Form_Runmod.opm_ListView_RunmodConfirm.Column[1].Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Col21X', INTTOSTR (opm_Form_Runmod.opm_ListView_RunmodConfirm.Column[2].Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Col22X', INTTOSTR (opm_Form_Runmod.opm_ListView_RunmodConfirm.Column[3].Width), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('OSCLanguage', INTTOSTR (opm_CurrentLang), opmC_RegistryKey, opmC_RKRoot);
  PRReg_WriteSetting ('OSCGUILang', opmG_UIGUILang, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('PastAvailDate', INTTOSTR (opmG_Past_PAvailDate), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PastManufacturer', INTTOSTR (opmG_Past_PManufacturer), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PastTaxClass', INTTOSTR (opmG_Past_PTaxClass), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PastImageDir', opmG_Past_PImageDir, opmC_RegistryKey, opmC_RKVisual);
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Sets several parameters of the visual components before
starting.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_SetDisplay (RememberVisual : WORD);
BEGIN
  opm_Form_Main.DoubleBuffered := TRUE;
  opm_Form_Main.Caption := opmC_AppName1 + ' ' + opmC_Version + ' (build ' + opmG_ExeBuildVersion + ')';
  opm_Form_Main.Constraints.MinWidth := opmC_MinWindow_XSize;
  opm_Form_Main.Constraints.MinHeight := opmC_MinWindow_YSize;
  opm_Form_Main.Constraints.MaxWidth := opmC_MaxWindow_XSize;
  opm_Form_Main.Constraints.MaxHeight := opmC_MaxWindow_YSize;

  opm_StatusBar_Main.Height := 16 + (opmC_Bevel_Size * 2);
  opm_StatusBar_Main.Panels[0].Width := 16 + (opmC_Bevel_Size * 2);
  opm_StatusBar_Main.Panels[1].Width := opmC_DefGauge_Size + (opmC_Bevel_Size * 2);
  opm_StatusBar_Main.Panels[2].Width := opmC_DefGauge_Size + (opmC_Bevel_Size * 2);
  opm_StatusBar_Main.Panels[3].Width := opmC_DefCatList_Size;
  opm_StatusBar_Main.Panels[4].Width := opmC_DefCatList_Size;
  opm_StatusBar_Main.Panels[5].Width := opmC_DefCurPan_Size;
  opm_StatusBar_Main.Panels[6].Width := opmC_DefMemPan_Size;

  opm_ProgressBar_Main.Parent := opm_StatusBar_Main;
  opm_ProgressBar_Main.Top := (opmC_Bevel_Size + 1);
  opm_ProgressBar_Main.Left := 16 + (opmC_Bevel_Size * 2) + (opmC_Bevel_Size + 1);
  opm_ProgressBar_Main.Height := (opm_StatusBar_Main.Height - (opmC_Bevel_Size * 2));
  opm_ProgressBar_Main.Width := opmC_DefGauge_Size;
  opm_ProgressBar_Main.Min := 0;
  opm_ProgressBar_Main.Max := 100;

  opm_ProgressBar_Sec.Parent := opm_StatusBar_Main;
  opm_ProgressBar_Sec.Top := (opmC_Bevel_Size + 1);
  opm_ProgressBar_Sec.Left := 16 + (opmC_Bevel_Size * 4) + (opmC_Bevel_Size + 1) + opmC_DefGauge_Size;
  opm_ProgressBar_Sec.Height := (opm_StatusBar_Main.Height - (opmC_Bevel_Size * 2));
  opm_ProgressBar_Sec.Width := opmC_DefGauge_Size;
  opm_ProgressBar_Sec.Min := 0;
  opm_ProgressBar_Sec.Max := 100;

  opm_Image_Status.Parent := opm_StatusBar_Main;
  opm_Image_Status.Top := (opmC_Bevel_Size + 1);
  opm_Image_Status.Left := (opmC_Bevel_Size + 1);
  opm_Image_Status.Height := (opm_StatusBar_Main.Height - (opmC_Bevel_Size * 2));
  opm_Image_Status.Width := 16;
  opm_ImageList_Status.GetIcon (0, opm_Image_Status.Picture.Icon);

  opm_TreeView_Main.ReadOnly := TRUE;
  opm_TreeView_Main.DoubleBuffered := TRUE;
  opm_TreeView_Main.Constraints.MinWidth := opmC_MinCatList_Size;
  opm_ListView_Main.Columns.Clear;
  opm_ListView_Main.Checkboxes := FALSE;
  opm_ListView_Main.ReadOnly := TRUE;
  opm_ListView_Main.RowSelect := TRUE;
  opm_ListView_Main.MultiSelect := TRUE;
  opm_ListView_Main.DoubleBuffered := TRUE;
  opm_ListView_Main.ViewStyle := vsReport;
  opm_ListView_Main.Columns.Add;
  opm_ListView_Main.Columns.Add;
  opm_ListView_Main.Columns.Add;
  opm_ListView_Main.Columns.Add;
  opm_ListView_Main.Columns.Add;
  opm_ListView_Main.Columns.Add;
  opm_ListView_Main.Columns.Add;
  opm_ListView_Main.Columns.Add;
  opm_ListView_Main.Columns.Add;
  opm_ListView_Main.Columns.Add;
  opm_ListView_Main.Columns.Add;
  opm_ListView_Main.Columns.Items[0].Caption := _('Available');
  opm_ListView_Main.Columns.Items[1].Caption := _('ID');
  opm_ListView_Main.Columns.Items[2].Caption := _('Model');
  opm_ListView_Main.Columns.Items[3].Caption := _('Category');
  opm_ListView_Main.Columns.Items[4].Caption := _('Name');
  opm_ListView_Main.Columns.Items[5].Caption := _('Manufacturer');
  opm_ListView_Main.Columns.Items[6].Caption := _('Quantity');
  opm_ListView_Main.Columns.Items[7].Caption := _('Price');
  opm_ListView_Main.Columns.Items[8].Caption := _('Weight');
  opm_ListView_Main.Columns.Items[9].Caption := _('Availability date');
  opm_ListView_Main.Columns.Items[10].Caption := _('Image');
  opm_ListView_Main.Columns.Items[0].Alignment := opmC_Def_Col0Align;
  opm_ListView_Main.Columns.Items[1].Alignment := opmC_Def_Col1Align;
  opm_ListView_Main.Columns.Items[2].Alignment := opmC_Def_Col2Align;
  opm_ListView_Main.Columns.Items[3].Alignment := opmC_Def_Col3Align;
  opm_ListView_Main.Columns.Items[4].Alignment := opmC_Def_Col4Align;
  opm_ListView_Main.Columns.Items[5].Alignment := opmC_Def_Col5Align;
  opm_ListView_Main.Columns.Items[6].Alignment := opmC_Def_Col6Align;
  opm_ListView_Main.Columns.Items[7].Alignment := opmC_Def_Col7Align;
  opm_ListView_Main.Columns.Items[8].Alignment := opmC_Def_Col8Align;
  opm_ListView_Main.Columns.Items[9].Alignment := opmC_Def_Col9Align;
  opm_ListView_Main.Columns.Items[10].Alignment := opmC_Def_Col10Align;
  IF (opmG_UIHotTracking > 0) THEN
    BEGIN
      opm_TreeView_Main.HotTrack := TRUE;
      opm_ListView_Main.HotTrack := FALSE;
      opm_ListView_Main.HotTrackStyles := [htHandPoint, htUnderlineHot];
    END
  ELSE
    BEGIN
      opm_TreeView_Main.HotTrack := FALSE;
      opm_ListView_Main.HotTrack := FALSE;
      opm_ListView_Main.HotTrackStyles := [];
    END;
  IF (opmG_UIDragDrop > 0) THEN
    opm_ListView_Main.DragMode := dmAutomatic
  ELSE
    opm_ListView_Main.DragMode := dmManual;

  IF (opmG_UIDBDebug > 0) THEN
    BEGIN
      opm_DataSource_DEBUG.Enabled := TRUE;
      opm_DBGrid_DEBUG.Enabled := TRUE;
      opm_DBGrid_DEBUG.Visible := TRUE;
      opm_Panel_DEBUG.Visible := TRUE;
    END
  ELSE
    BEGIN
      opm_DataSource_DEBUG.Enabled := FALSE;
      opm_DBGrid_DEBUG.Enabled := FALSE;
      opm_DBGrid_DEBUG.Visible := FALSE;
      opm_Panel_DEBUG.Visible := FALSE;
    END;
  IF (RememberVisual > 0) THEN
    BEGIN
      opm_Form_Main.Width := opmG_UIWindow_XSize;
      opm_Form_Main.Height := opmG_UIWindow_YSize;
      opm_TreeView_Main.Width := opmG_UICatList_XSize;
      opm_ListView_Main.Column[0].Width := opmG_UICol0X;
      opm_ListView_Main.Column[1].Width := opmG_UICol1X;
      opm_ListView_Main.Column[2].Width := opmG_UICol2X;
      opm_ListView_Main.Column[3].Width := opmG_UICol3X;
      opm_ListView_Main.Column[4].Width := opmG_UICol4X;
      opm_ListView_Main.Column[5].Width := opmG_UICol5X;
      opm_ListView_Main.Column[6].Width := opmG_UICol6X;
      opm_ListView_Main.Column[7].Width := opmG_UICol7X;
      opm_ListView_Main.Column[8].Width := opmG_UICol8X;
      opm_ListView_Main.Column[9].Width := opmG_UICol9X;
      opm_ListView_Main.Column[10].Width := opmG_UICol10X;
    END
  ELSE
    BEGIN
      opm_Form_Main.Width := opmC_DefWindow_XSize;
      opm_Form_Main.Height := opmC_DefWindow_YSize;
      opm_TreeView_Main.Width := opmC_DefCatList_Size;
      opm_ListView_Main.Column[0].Width := opmC_Def_Col0X;
      opm_ListView_Main.Column[1].Width := opmC_Def_Col1X;
      opm_ListView_Main.Column[2].Width := opmC_Def_Col2X;
      opm_ListView_Main.Column[3].Width := opmC_Def_Col3X;
      opm_ListView_Main.Column[4].Width := opmC_Def_Col4X;
      opm_ListView_Main.Column[5].Width := opmC_Def_Col5X;
      opm_ListView_Main.Column[6].Width := opmC_Def_Col6X;
      opm_ListView_Main.Column[7].Width := opmC_Def_Col7X;
      opm_ListView_Main.Column[8].Width := opmC_Def_Col8X;
      opm_ListView_Main.Column[9].Width := opmC_Def_Col9X;
      opm_ListView_Main.Column[10].Width := opmC_Def_Col10X;
    END;
  PRballoon_ResetBalloons;
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Updates the status bar information according to the parameters:
connection status (to change connection icon), main progress bar,
secondary progress bar, message caption and total products.
Any option can be left unchanged.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_Update_StatusBar (ConnectedStat, ProgressStat, SecProgress : LONGINT; StatusString : STRING; ProductTotal : LONGINT; CurCurr : STRING);
BEGIN
  IF (StatusString <> '') THEN
    opm_StatusBar_Main.Panels[3].Text := StatusString;
  IF (ProgressStat <> opmC_ProgressIgnore) THEN
    BEGIN
      opm_ProgressBar_Main.Position := ProgressStat;
    END;
  IF (SecProgress <> opmC_ProgressIgnore) THEN
    BEGIN
      opm_ProgressBar_Sec.Position := SecProgress;
    END;
  IF (ConnectedStat <> opmC_ConnStatIgnore) THEN
    BEGIN
      opm_ImageList_Status.GetIcon (ConnectedStat, opm_Image_Status.Picture.Icon);
    END;
  IF (ProductTotal <> opmC_PTotalIgnore) THEN
    opm_StatusBar_Main.Panels[4].Text := INTTOSTR (ProductTotal) + ' ' + _('products');
  IF (CurCurr <> '') THEN
    opm_StatusBar_Main.Panels[5].Text := CurCurr
  ELSE
    opm_StatusBar_Main.Panels[5].Text := _('???');
  opm_StatusBar_Main.Panels[6].Text := _('Mem:') + ' ' + INTTOSTR (FNopm_GetMemoryLoad) + '%';
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Load the list of categories in memory and populate the
category boxlist.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_LoadCategoryList (VAR CatList : opmT_CategoryList; VAR CatBoxList : TStringList);
VAR
  CurCat : LONGINT;
BEGIN
  CatList[0].ID := -1;
  CatList[0].Parent := 0;
  CatList[0].Name := '';
  CurCat := 1;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, 50, opmC_ProgressNone, _('Getting category list...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  IF (FNopm_ExecQuery ('select ' + opmG_DBTable_Categories + '.categories_id, ' + opmG_DBTable_Categories + '.parent_id, ' + opmG_DBTable_CategoriesDescription + '.categories_name from ' + opmG_DBTable_Categories + ', ' + opmG_DBTable_CategoriesDescription + ' where ' + opmG_DBTable_CategoriesDescription + '.categories_id= ' + opmG_DBTable_Categories + '.categories_id and language_id=' + INTTOSTR (opm_CurrentLang) + ' ORDER BY ' + opmG_DBTable_CategoriesDescription + '.categories_name', opmC_SQLSelect) > 0) THEN
    BEGIN
      IF (opmG_DBQuery.Active = TRUE) THEN
        BEGIN
          Screen.Cursor := opmC_Wait_Mouse;
          opmG_DBQuery.First;
          WHILE NOT opmG_DBQuery.EOF DO
            BEGIN
              CatList[CurCat].ID := opmG_DBQuery.Fields[0].AsInteger;
              CatList[CurCat].Parent := opmG_DBQuery.Fields[1].AsInteger;
              CatList[CurCat].Name := FNopm_CleanString (opmG_DBQuery.Fields[2].AsString);
              IF (CatList[CurCat].Name = '') THEN CatList[CurCat].Name := opmC_Unamed_Cat;
              INC (CurCat);
              opmG_DBQuery.Next;
            END;
          Screen.Cursor := opmC_Normal_Mouse;
        END;
    END;




  CatList[CurCat].ID := opmC_SC_TrashCanID;
  CatList[CurCat].Parent := opmC_SC_Parent;
  CatList[CurCat].Name := _('Deleted products');
  CatList[CurCat].TreeIndex := opmC_SC_TrashCanIndex;
  CatList[CurCat].ListIndex := opmC_SC_TrashCanIndex;
  INC (CurCat);







  opm_TotalCategories := CurCat;
  CatBoxList.Clear;
  PRopm_LoadCategoryBoxList (CatList, 0, 0, CurCat, CatBoxList);
  CatList[0].ID := 0;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Got category list.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Scan the category list and recursively build the category boxlist.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_LoadCategoryBoxList (VAR CatList : opmT_CategoryList; CatCurrentID, TreeDepth : LONGINT; VAR CatIndex : LONGINT; VAR CatBoxList : TStringList);
VAR
  CurCat : LONGINT;
BEGIN
  IF (CatCurrentID = 0) THEN CatIndex := 0;
  FOR CurCat := 0 TO (opm_TotalCategories - 1) DO
    BEGIN
      IF ((CatList[CurCat].Parent = CatCurrentID) AND (CatList[CurCat].Parent < opmC_SC_Parent)) THEN
        BEGIN
          CatBoxList.Add (STRINGOFCHAR (opmC_CatList_Spacer, (TreeDepth * 2)) + CatList[CurCat].Name);
          CatList[CurCat].ListIndex := CatIndex;
          INC (CatIndex);
          PRopm_LoadCategoryBoxList (CatList, CatList[CurCat].ID, (TreeDepth + 1), CatIndex, CatBoxList);
        END;
    END;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Recursively build the category tree view.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_AddCatTreeNode (VAR CatList : opmT_CategoryList; CatCurrentID : LONGINT; CurNode : TTreeNode; TreeDepth : INTEGER);
VAR
  CurCat : LONGINT;
  NewNode : TTreeNode;
BEGIN
  FOR CurCat := 0 TO (opm_TotalCategories - 1) DO
    BEGIN
      IF ((CatList[CurCat].Parent = CatCurrentID) AND (CatList[CurCat].ID > 0) AND (CatList[CurCat].Parent < opmC_SC_Parent)) THEN
        BEGIN
          NewNode := opm_TreeView_Main.Items.AddChild (CurNode, CatList[CurCat].Name);
          NewNode.ImageIndex := 2;
          NewNode.SelectedIndex := 3;
          CatList[CurCat].TreeIndex := NewNode.AbsoluteIndex;
          PRopm_AddCatTreeNode (CatList, CatList[CurCat].ID, NewNode, (TreeDepth + 1));
        END;
    END;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Loads the list of manufacturers and populate the
manufacturer boxlist.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_LoadManufacturerList (VAR ManList : opmT_ManufacturerList; VAR ManBoxList : TStringList);
VAR
  CurMan : LONGINT;
BEGIN
  ManBoxList.Clear;
  ManList[0].ID := 0;
  ManList[0].Name := '';
  ManList[0].ListIndex := 0;
  ManBoxList.Add ('');
  CurMan := 1;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, 50, opmC_ProgressNone, _('Getting manufacturers list...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  IF (FNopm_ExecQuery ('select manufacturers_id, manufacturers_name from ' + opmG_DBTable_Manufacturers + ' order by manufacturers_name', opmC_SQLSelect) > 0) THEN
    BEGIN
      IF (opmG_DBQuery.Active = TRUE) THEN
        BEGIN
          Screen.Cursor := opmC_Wait_Mouse;
          opmG_DBQuery.First;
          WHILE NOT opmG_DBQuery.EOF DO
            BEGIN
              ManList[CurMan].ID := opmG_DBQuery.Fields[0].AsInteger;
              ManList[CurMan].Name := FNopm_CleanString (opmG_DBQuery.Fields[1].AsString);
              IF (ManList[CurMan].Name = '') THEN ManList[CurMan].Name := opmC_Unamed_Man;
              ManBoxList.Add (ManList[CurMan].Name);
              ManList[CurMan].ListIndex := CurMan;
              INC (CurMan);
              opmG_DBQuery.Next;
            END;
          Screen.Cursor := opmC_Normal_Mouse;
        END;
    END;
  opm_TotalManufacturers := CurMan;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Got manufacturers list.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Loads the list of available languages and populate the
language boxlist.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_LoadLanguageList (VAR LangList : opmT_LanguageList);
VAR
  CurLang : LONGINT;
  DisplayLangValid : BOOLEAN;
BEGIN
  CurLang := 0;
  DisplayLangValid := FALSE;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, 50, opmC_ProgressNone, _('Getting languages list...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  opmG_LanguageBoxList.Clear;
  IF (FNopm_ExecQuery ('select languages_id, name from ' + opmG_DBTable_Languages + ' order by name', opmC_SQLSelect) > 0) THEN
    BEGIN
      IF (opmG_DBQuery.Active = TRUE) THEN
        BEGIN
          Screen.Cursor := opmC_Wait_Mouse;
          opmG_DBQuery.First;
          WHILE NOT opmG_DBQuery.EOF DO
            BEGIN
              LangList[CurLang].ID := opmG_DBQuery.Fields[0].AsInteger;
              LangList[CurLang].Name := FNopm_CleanString (opmG_DBQuery.Fields[1].AsString);
              IF (opm_CurrentLang = opmG_DBQuery.Fields[0].AsInteger) THEN DisplayLangValid := TRUE;
              LangList[CurLang].ListIndex := CurLang;
              opmG_LanguageBoxList.Add (LangList[CurLang].Name);
              INC (CurLang);
              opmG_DBQuery.Next;
            END;
          Screen.Cursor := opmC_Normal_Mouse;
        END;
    END;
  opm_TotalLanguages := CurLang;
  IF (DisplayLangValid = FALSE) THEN opm_CurrentLang := opmC_Def_DisplayLang;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Got languages list.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Loads the product list according to the given category.
This routine don't modify the current display.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_LoadProductListByCat (ProductCat : LONGINT; VAR ProdList : opmT_ProductList; VAR DescList : opmT_DescriptionList);
VAR
  CurProd : LONGINT;
  SQLStr : STRING;
BEGIN
  BEGIN
    CurProd := 0;
    opm_WeAreSearching := FALSE;
    PRopm_Update_StatusBar (opmC_ConnStatIgnore, 50, opmC_ProgressNone, _('Getting products list...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
    IF (ProductCat > 0) THEN
      SQLStr := 'select ' + opmG_DBTable_Products + '.products_id, ' + opmG_DBTable_Products + '.products_quantity, ' + opmG_DBTable_Products + '.products_model, ' +
                 opmG_DBTable_Products + '.products_price, ' + opmG_DBTable_Products + '.products_weight, ' + opmG_DBTable_Products + '.manufacturers_id, ' +
                 opmG_DBTable_ProductsDescription + '.products_name, ' + opmG_DBTable_Products + '.products_status, ' + opmG_DBTable_ProductsDescription + '.products_description, ' +
                 opmG_DBTable_ProductsDescription + '.products_url, ' + opmG_DBTable_Products + '.products_image, ' +
                 opmG_DBTable_Specials + '.specials_new_products_price, ' + opmG_DBTable_ProductsDescription + '.language_id, ' +
                 opmG_DBTable_Products + '.products_tax_class_id, ' + opmG_DBTable_ProductsDescription + '.products_viewed, ' +
                'DATE_FORMAT(' + opmG_DBTable_Products + '.products_date_available, "%Y-%m-%d %H:%i:%S"), DATE_FORMAT(' + opmG_DBTable_Products + '.products_date_added, "%Y-%m-%d %H:%i:%S"), DATE_FORMAT(' + opmG_DBTable_Products + '.products_last_modified, "%Y-%m-%d %H:%i:%S") ' +
                'from ' + opmG_DBTable_Products + ', ' + opmG_DBTable_ProductsDescription + ', ' + opmG_DBTable_ProductsToCategories + ' ' +
                'left join ' + opmG_DBTable_Specials + ' ON ' + opmG_DBTable_Products + '.products_id = ' + opmG_DBTable_Specials + '.products_id ' +
                'where ' + opmG_DBTable_Products + '.products_id=' + opmG_DBTable_ProductsDescription + '.products_id ' +
                'and ' + opmG_DBTable_ProductsToCategories + '.products_id=' + opmG_DBTable_Products + '.products_id and ' +
                 opmG_DBTable_ProductsToCategories + '.categories_id=' + INTTOSTR (ProductCat) + ' ' +
                'order by ' + opmG_DBTable_ProductsDescription + '.products_name'
    ELSE
      SQLStr := 'select ' + opmG_DBTable_Products + '.products_id, ' + opmG_DBTable_Products + '.products_quantity, ' + opmG_DBTable_Products + '.products_model, ' +
                 opmG_DBTable_Products + '.products_price, ' + opmG_DBTable_Products + '.products_weight, ' + opmG_DBTable_Products + '.manufacturers_id, ' +
                 opmG_DBTable_ProductsDescription + '.products_name, ' + opmG_DBTable_Products + '.products_status, ' + opmG_DBTable_ProductsDescription + '.products_description, ' +
                 opmG_DBTable_ProductsDescription + '.products_url, ' + opmG_DBTable_Products + '.products_image, ' +
                 opmG_DBTable_Specials + '.specials_new_products_price, ' + opmG_DBTable_ProductsDescription + '.language_id, ' +
                 opmG_DBTable_Products + '.products_tax_class_id, ' + opmG_DBTable_ProductsDescription + '.products_viewed, ' +
                'DATE_FORMAT(' + opmG_DBTable_Products + '.products_date_available, "%Y-%m-%d %H:%i:%S"), DATE_FORMAT(' + opmG_DBTable_Products + '.products_date_added, "%Y-%m-%d %H:%i:%S"), DATE_FORMAT(' + opmG_DBTable_Products + '.products_last_modified, "%Y-%m-%d %H:%i:%S") ' +
                'from ' + opmG_DBTable_Products + ', ' + opmG_DBTable_ProductsDescription + ' ' +
                'left join ' + opmG_DBTable_Specials + ' ON ' + opmG_DBTable_Products + '.products_id = ' + opmG_DBTable_Specials + '.products_id ' +
                'LEFT JOIN ' + opmG_DBTable_ProductsToCategories + ' ON ' + opmG_DBTable_ProductsToCategories + '.products_id = ' + opmG_DBTable_Products + '.products_id  ' +
                'where ' + opmG_DBTable_Products + '.products_id=' + opmG_DBTable_ProductsDescription + '.products_id ' +
                'and (' + opmG_DBTable_ProductsToCategories + '.categories_id is null ' +
                'or ' + opmG_DBTable_ProductsToCategories + '.categories_id < 1) ' +
                'order by ' + opmG_DBTable_ProductsDescription + '.products_name';
    IF (FNopm_ExecQuery (SQLStr, opmC_SQLSelect) > 0) THEN
      BEGIN
        IF (opmG_DBQuery.Active = TRUE) THEN
          BEGIN
            Screen.Cursor := opmC_Wait_Mouse;
            opmG_DBQuery.First;
            WHILE NOT opmG_DBQuery.EOF DO
              BEGIN
                ProdList[CurProd].ID := opmG_DBQuery.Fields[0].AsInteger;
                ProdList[CurProd].Model := FNopm_CleanString (opmG_DBQuery.Fields[2].AsString);
                ProdList[CurProd].Quantity := opmG_DBQuery.Fields[1].AsInteger;
                ProdList[CurProd].Price := opmG_DBQuery.Fields[3].AsCurrency;
                ProdList[CurProd].Weight := opmG_DBQuery.Fields[4].AsFloat;
                ProdList[CurProd].ManufacturerID := opmG_DBQuery.Fields[5].AsInteger;
                ProdList[CurProd].CategoryID := ProductCat;
                ProdList[CurProd].DisplayName := FNopm_CleanString (opmG_DBQuery.Fields[6].AsString);
                IF (ProdList[CurProd].DisplayName = '') THEN ProdList[CurProd].DisplayName := opmC_Unamed_Prod;
                ProdList[CurProd].Available := opmG_DBQuery.Fields[7].AsInteger;
                ProdList[CurProd].ImageURL := FNopm_CleanString (opmG_DBQuery.Fields[10].AsString);
                ProdList[CurProd].Special := opmG_DBQuery.Fields[11].AsCurrency;
                ProdList[CurProd].LanguageID := opmG_DBQuery.Fields[12].AsInteger;
                ProdList[CurProd].Tax := opmG_DBQuery.Fields[13].AsInteger;

                ProdList[CurProd].CreationDate := FNopm_StringToDate (opmG_DBQuery.Fields[16].AsString);
                IF (ProdList[CurProd].CreationDate < opmG_Fallback_DateTime) THEN
                  ProdList[CurProd].CreationDate := opmG_Fallback_DateTime;
                ProdList[CurProd].ChangeDate := FNopm_StringToDate (opmG_DBQuery.Fields[17].AsString);
                IF (ProdList[CurProd].ChangeDate < ProdList[CurProd].CreationDate) THEN
                  ProdList[CurProd].ChangeDate := ProdList[CurProd].CreationDate;
                ProdList[CurProd].AvailDate := FNopm_StringToDate (opmG_DBQuery.Fields[15].AsString);
                IF (ProdList[CurProd].AvailDate < ProdList[CurProd].CreationDate) THEN
                  ProdList[CurProd].AvailDate := ProdList[CurProd].CreationDate;

                DescList[CurProd].ID := opmG_DBQuery.Fields[0].AsInteger;
                DescList[CurProd].Name := FNopm_CleanString (opmG_DBQuery.Fields[6].AsString);
                IF (DescList[CurProd].Name = '') THEN DescList[CurProd].Name := opmC_Unamed_Prod;
                DescList[CurProd].Description := FNopm_CleanString (opmG_DBQuery.Fields[8].AsString);
                DescList[CurProd].URL := FNopm_CleanString (opmG_DBQuery.Fields[9].AsString);
                DescList[CurProd].Viewed := opmG_DBQuery.Fields[14].AsInteger;
                DescList[CurProd].LanguageID := opmG_DBQuery.Fields[12].AsInteger;
                INC (CurProd);
                opmG_DBQuery.Next;
              END;
            Screen.Cursor := opmC_Normal_Mouse;
          END;
      END;
    opm_TotalProducts := CurProd;
    PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Got products list.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  END;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Loads the list of available tax classes into 
the taxes boxlist.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_LoadTaxList (VAR TaxList : opmT_TaxList; VAR TaxBoxList : TStringList);
VAR
  CurTax : LONGINT;
BEGIN
  TaxBoxList.Clear;
  TaxList[0].ID := 0;
  TaxList[0].Name := '';
  TaxList[0].ListIndex := 0;
  TaxList[0].SumRate := 0;
  TaxBoxList.Add ('');
  CurTax := 1;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, 50, opmC_ProgressNone, _('Getting taxes list...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  IF (FNopm_ExecQuery ('select ' + opmG_DBTable_TaxClass + '.tax_class_id, tax_class_title, sum(tax_rate) from ' + opmG_DBTable_TaxClass + ' left join ' + opmG_DBTable_TaxRates + ' on ' + opmG_DBTable_TaxClass + '.tax_class_id=' + opmG_DBTable_TaxRates + '.tax_class_id group by tax_class_id order by tax_class_title', opmC_SQLSelect) > 0) THEN
    BEGIN
      IF (opmG_DBQuery.Active = TRUE) THEN
        BEGIN
          Screen.Cursor := opmC_Wait_Mouse;
          opmG_DBQuery.First;
          WHILE NOT opmG_DBQuery.EOF DO
            BEGIN
              TaxList[CurTax].ID := opmG_DBQuery.Fields[0].AsInteger;
              TaxList[CurTax].Name := FNopm_CleanString (opmG_DBQuery.Fields[1].AsString);
              TaxList[CurTax].SumRate := opmG_DBQuery.Fields[2].AsFloat;
              IF (TaxList[CurTax].Name = '') THEN TaxList[CurTax].Name := opmC_Unamed_Tax;
              TaxList[CurTax].Name := TaxList[CurTax].Name + ' (' + CURRTOSTR (TaxList[CurTax].SumRate) + '%)';
              TaxBoxList.Add (TaxList[CurTax].Name);
              TaxList[CurTax].ListIndex := CurTax;
              INC (CurTax);
              opmG_DBQuery.Next;
            END;
          Screen.Cursor := opmC_Normal_Mouse;
        END;
    END;
  opm_TotalTaxes := CurTax;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Got taxes list.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
END;




{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Loads the current currency record
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
FUNCTION Topm_Form_Main.FNopm_LoadCurrency : opmR_Currency;
VAR
  CurCurrR : opmR_Currency;
BEGIN
  CurCurrR.Code := '';
  CurCurrR.Left := '';
  CurCurrR.Right := '';
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, 50, opmC_ProgressNone, _('Getting current currency...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  IF (FNopm_ExecQuery ('select ' + opmG_DBTable_Currencies + '.code, ' + opmG_DBTable_Currencies + '.symbol_left, ' + opmG_DBTable_Currencies + '.symbol_right from ' +
                        opmG_DBTable_Currencies + ', ' + opmG_DBTable_Configuration + ' where ' +
                        opmG_DBTable_Configuration + '.configuration_key="DEFAULT_CURRENCY" and ' + 
                        opmG_DBTable_Configuration + '.configuration_value=' + opmG_DBTable_Currencies + '.code', opmC_SQLSelect) > 0) THEN
    BEGIN
      IF (opmG_DBQuery.Active = TRUE) THEN
        BEGIN
          Screen.Cursor := opmC_Wait_Mouse;
          opmG_DBQuery.First;
          CurCurrR.Code := TRIM (opmG_DBQuery.Fields[0].AsString);
          CurCurrR.Left := TRIM (opmG_DBQuery.Fields[1].AsString);
          CurCurrR.Right := TRIM (opmG_DBQuery.Fields[2].AsString);
          Screen.Cursor := opmC_Normal_Mouse;
        END;
    END;
  FNopm_LoadCurrency := CurCurrR;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Got current currency.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Clears the current currency record
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
FUNCTION Topm_Form_Main.FNopm_ClearCurrency : opmR_Currency;
VAR
  CurCurrR : opmR_Currency;
BEGIN
  CurCurrR.Code := '';
  CurCurrR.Left := '';
  CurCurrR.Right := '';
  FNopm_ClearCurrency := CurCurrR;
END;




{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Start the building of the category tree.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_RenderCategoryDisplay (VAR CatList : opmT_CategoryList; VAR TreeControl : TTreeView; CurCatID : LONGINT);
VAR
  MainNode, CurrentNode : TTreeNode;
  CurCat : opmR_Category;
  CatCount : LONGINT;
BEGIN
  TreeControl.Items.BeginUpdate;
  TreeControl.Items.Clear;
  IF (opm_TotalCategories > 0) THEN
    BEGIN
      MainNode := TreeControl.Items.AddFirst (NIL, opmG_DBHost);
      MainNode.ImageIndex := 0;
      MainNode.SelectedIndex := 1;
      PRopm_AddCatTreeNode (CatList, 0, MainNode, 0);
      FOR CatCount := 0 TO (opm_TotalCategories - 1) DO
        IF (CatList[CatCount].Parent = opmC_SC_Parent) THEN
          BEGIN
            CurrentNode := TreeControl.Items.Add (MainNode, CatList[CatCount].Name);
            CatList[CatCount].TreeIndex := CurrentNode.AbsoluteIndex;
            CurrentNode.ImageIndex := CatList[CatCount].ID - opmC_SC_BaseID + 3;
            CurrentNode.SelectedIndex := CatList[CatCount].ID - opmC_SC_BaseID + 4;
          END;
      TreeControl.FullCollapse;
      TreeControl.Items[0].Expand (FALSE);
    END;
  CurCat := FNopm_GetCategory (CatList, CurCatID, opmC_FindByID);
  IF ((CurCat.TreeIndex > 0) AND (TreeControl.Items.Count >= CurCat.TreeIndex)) THEN
    TreeControl.Items[CurCat.TreeIndex].Selected := TRUE;
  TreeControl.Items.EndUpdate;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_RenderLanguageDisplay (VAR ListControl : TComboBox; VAR LangList : opmT_LanguageList);
VAR
  CurLang : LONGINT;
  DisplayLangIndex : LONGINT;
BEGIN
  ListControl.Items.Clear;
  ListControl.Items := opmG_LanguageBoxList;
  DisplayLangIndex := -1;
  FOR CurLang := 0 TO (opm_TotalLanguages - 1) DO
    IF (opm_CurrentLang = LangList[CurLang].ID) THEN DisplayLangIndex := CurLang;
  ListControl.ItemIndex := DisplayLangIndex;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_RenderProductDisplay (VAR CatList : opmT_CategoryList; VAR ManList : opmT_ManufacturerList; VAR ProdList : opmT_ProductList; VAR ListControl : TListView; CurProdID : LONGINT);
VAR
  CurProd, DispProd : LONGINT;
  CurItem : TListItem;
  CurMan : opmR_Manufacturer;
  CurCat : opmR_Category;
BEGIN
  ListControl.Column[opmG_PList_LastOrderColumn].ImageIndex := -1;
  ListControl.Items.BeginUpdate;
  ListControl.Items.Clear;
  DispProd := 0;
  FOR CurProd := 0 TO (opm_TotalProducts - 1) DO
    BEGIN
      IF (ProdList[CurProd].LanguageID = opm_CurrentLang) THEN
        BEGIN
          CurItem := ListControl.Items.Add;
          IF (ProdList[CurProd].Available > 0) THEN CurItem.ImageIndex := 0 ELSE CurItem.ImageIndex := 1;
          CurItem.SubItems.Add (INTTOSTR (ProdList[CurProd].ID));
          CurItem.SubItems.Add (ProdList[CurProd].Model);
          CurCat := FNopm_GetCategory (CatList, ProdList[CurProd].CategoryID, opmC_FindByID);
          CurItem.SubItems.Add (CurCat.Name);
          CurItem.SubItems.Add (ProdList[CurProd].DisplayName);
          CurMan := FNopm_GetManufacturer (ManList, ProdList[CurProd].ManufacturerID, opmC_FindByID);
          CurItem.SubItems.Add (CurMan.Name);
          CurItem.SubItems.Add (INTTOSTR (ProdList[CurProd].Quantity));
          IF (ProdList[CurProd].Special > 0) THEN
            CurItem.SubItems.Add (FNopm_CleanNumber (CURRTOSTR (ProdList[CurProd].Special), opmC_ValIsFloat))
          ELSE
            CurItem.SubItems.Add (FNopm_CleanNumber (CURRTOSTR (ProdList[CurProd].Price), opmC_ValIsFloat));
          CurItem.SubItems.Add (FLOATTOSTR (ProdList[CurProd].Weight));
          CurItem.SubItems.Add (FNopm_DateToString (ProdList[CurProd].AvailDate));
          CurItem.SubItems.Add ('');
          IF (ProdList[CurProd].Special > 0) THEN CurItem.SubItemImages[6] := 2;
          IF (ProdList[CurProd].ImageURL <> '') THEN
            CurItem.SubItemImages[9] := 6
          ELSE
            CurItem.SubItemImages[9] := 7;
          INC (DispProd);
          IF (CurProdID = ProdList[CurProd].ID) THEN
            BEGIN
              ListControl.Selected := CurItem;
              ListControl.ItemFocused := CurItem;
            END;
        END;
    END;
  ListControl.Column[opmG_PList_LastOrderColumn].ImageIndex := 9;
  ListControl.CustomSort (@FNopm_Sort_ProductList, opmG_PList_LastOrderColumn);
  ListControl.Items.EndUpdate;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, opmC_ProgressIgnore, '', DispProd, opm_CurrentCurrency.Code);
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_ClearCategoryList (VAR CatList : TStringList);
BEGIN
  CatList.Clear;
  opm_CurrentCategory := 0;
  opm_TotalCategories := 0;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_ClearLanguageList (VAR LangList : TStringList);
BEGIN
  LangList.Clear;
  opm_TotalLanguages := 0;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_ClearManufacturerList (VAR ManList : TStringList);
BEGIN
  ManList.Clear;
  opm_TotalManufacturers := 0;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_ClearTaxList (VAR TaxList : TStringList);
BEGIN
  TaxList.Clear;
  opm_TotalTaxes := 0;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_ClearProductList (VAR ListView : TListView);
BEGIN
  ListView.Items.BeginUpdate;
  ListView.Items.Clear;
  ListView.Items.EndUpdate;
  opm_TotalProducts := 0;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_SearchProducts (PCategory, PManufacturer: LONGINT;
                                               PModel, PName, PDesc : STRING;
                                               PSPrice, PImgURL, PAvailable : LONGINT;
                                               VAR ProdList : opmT_ProductList;
                                               VAR DescList : opmT_DescriptionList);
VAR
  SelectStr, FromStr, WhereStr, OrderStr : STRING;
  CurProd : LONGINT;
BEGIN
  SelectStr := 'select ' + opmG_DBTable_Products + '.products_id, ' + opmG_DBTable_Products + '.products_quantity, ' + opmG_DBTable_Products + '.products_model, ' + opmG_DBTable_Products + '.products_price, ' + opmG_DBTable_Products + '.products_weight, ' + opmG_DBTable_Products + '.manufacturers_id, ' +
               '' + opmG_DBTable_ProductsDescription + '.products_name, ' + opmG_DBTable_Products + '.products_status, ' + opmG_DBTable_ProductsDescription + '.products_description, ' + opmG_DBTable_ProductsDescription + '.products_url, ' + opmG_DBTable_Products + '.products_image, ' +
               '' + opmG_DBTable_Specials + '.specials_new_products_price, ' + opmG_DBTable_ProductsToCategories + '.categories_id, ' + opmG_DBTable_ProductsDescription + '.language_id, ' + opmG_DBTable_Products + '.products_tax_class_id, ' + opmG_DBTable_ProductsDescription + '.products_viewed, ' +
               'DATE_FORMAT(' + opmG_DBTable_Products + '.products_date_available, "%Y-%m-%d %H:%i:%S"), DATE_FORMAT(' + opmG_DBTable_Products + '.products_date_added, "%Y-%m-%d %H:%i:%S"), DATE_FORMAT(' + opmG_DBTable_Products + '.products_last_modified, "%Y-%m-%d %H:%i:%S")';
  FromStr := ' from ' + opmG_DBTable_Products + ', ' + opmG_DBTable_ProductsDescription + ', ' + opmG_DBTable_ProductsToCategories + ' left join ' + opmG_DBTable_Specials + ' ON ' + opmG_DBTable_Products + '.products_id = ' + opmG_DBTable_Specials + '.products_id where';
  OrderStr := ' order by ' + opmG_DBTable_ProductsDescription + '.products_name';
  IF (PCategory > 0) THEN
    WhereStr := WhereStr + ' ' + opmG_DBTable_ProductsToCategories + '.products_id=' + opmG_DBTable_Products + '.products_id and ' + opmG_DBTable_ProductsToCategories + '.categories_id=' + INTTOSTR (PCategory)
  ELSE
    WhereStr := WhereStr + ' ' + opmG_DBTable_ProductsToCategories + '.products_id=' + opmG_DBTable_Products + '.products_id';
  IF (PManufacturer > 0) THEN
    IF (WhereStr <> '')
    THEN WhereStr := WhereStr + ' and ' + opmG_DBTable_Products + '.manufacturers_id=' + INTTOSTR (PManufacturer)
    ELSE WhereStr := WhereStr + ' ' + opmG_DBTable_Products + '.manufacturers_id=' + INTTOSTR (PManufacturer);
  IF (PModel <> '') THEN
    IF (WhereStr <> '')
    THEN WhereStr := WhereStr + ' and ' + opmG_DBTable_Products + '.products_model like "%' + FNopm_CleanSQLString (PModel, TRUE) + '%"'
    ELSE WhereStr := WhereStr + ' ' + opmG_DBTable_Products + '.products_model like "%' + FNopm_CleanSQLString (PModel, TRUE) + '%"';
  IF (PName <> '') THEN
    IF (WhereStr <> '')
    THEN WhereStr := WhereStr + ' and ' + opmG_DBTable_ProductsDescription + '.products_name like "%' + FNopm_CleanSQLString (PName, TRUE) + '%"'
    ELSE WhereStr := WhereStr + ' ' + opmG_DBTable_ProductsDescription + '.products_name like "%' + FNopm_CleanSQLString (PName, TRUE) + '%"';
  IF (PDesc <> '') THEN
    IF (WhereStr <> '')
    THEN WhereStr := WhereStr + ' and ' + opmG_DBTable_ProductsDescription + '.products_description like "%' + FNopm_CleanSQLString (PDesc, TRUE) + '%"'
    ELSE WhereStr := WhereStr + ' ' + opmG_DBTable_ProductsDescription + '.products_description like "%' + FNopm_CleanSQLString (PDesc, TRUE) + '%"';
  IF (PAvailable = opmC_SearchYes) THEN
    IF (WhereStr <> '')
    THEN WhereStr := WhereStr + ' and ' + opmG_DBTable_Products + '.products_status > 0'
    ELSE WhereStr := WhereStr + ' ' + opmG_DBTable_Products + '.products_status > 0'
  ELSE IF (PAvailable = opmC_SearchNo) THEN
    IF (WhereStr <> '')
    THEN WhereStr := WhereStr + ' and ' + opmG_DBTable_Products + '.products_status = 0'
    ELSE WhereStr := WhereStr + ' ' + opmG_DBTable_Products + '.products_status = 0';
  IF (PImgURL = opmC_SearchYes) THEN
    IF (WhereStr <> '')
    THEN WhereStr := WhereStr + ' and (' + opmG_DBTable_Products + '.products_image <> "" and ' + opmG_DBTable_Products + '.products_image IS NOT NULL)'
    ELSE WhereStr := WhereStr + ' (' + opmG_DBTable_Products + '.products_image <> "" and ' + opmG_DBTable_Products + '.products_image IS NOT NULL)'
  ELSE IF (PImgURL = opmC_SearchNo) THEN
    IF (WhereStr <> '')
    THEN WhereStr := WhereStr + ' and (' + opmG_DBTable_Products + '.products_image = "" or ' + opmG_DBTable_Products + '.products_image IS NULL)'
    ELSE WhereStr := WhereStr + ' (' + opmG_DBTable_Products + '.products_image = "" or ' + opmG_DBTable_Products + '.products_image IS NULL)';
  IF (PSPrice = opmC_SearchYes) THEN
    IF (WhereStr <> '')
    THEN WhereStr := WhereStr + ' and ' + opmG_DBTable_Specials + '.specials_new_products_price > 0'
    ELSE WhereStr := WhereStr + ' ' + opmG_DBTable_Specials + '.specials_new_products_price > 0'
  ELSE IF (PSPrice = opmC_SearchNo) THEN
    IF (WhereStr <> '')
    THEN WhereStr := WhereStr + ' and (' + opmG_DBTable_Specials + '.specials_new_products_price = 0 or ' + opmG_DBTable_Specials + '.specials_new_products_price IS NULL)'
    ELSE WhereStr := WhereStr + ' (' + opmG_DBTable_Specials + '.specials_new_products_price = 0 or ' + opmG_DBTable_Specials + '.specials_new_products_price IS NULL)';
  IF (WhereStr <> '')
  THEN WhereStr := WhereStr + ' and ' + opmG_DBTable_Products + '.products_id=' + opmG_DBTable_ProductsDescription + '.products_id'
  ELSE WhereStr := WhereStr + ' ' + opmG_DBTable_Products + '.products_id=' + opmG_DBTable_ProductsDescription + '.products_id';
  CurProd := 0;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, 50, opmC_ProgressNone, _('Getting products list...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  opm_WeAreSearching := TRUE;
  IF (FNopm_ExecQuery (SelectStr + FromStr + WhereStr + OrderStr, opmC_SQLSelect) > 0) THEN
    BEGIN
      IF (opmG_DBQuery.Active = TRUE) THEN
        BEGIN
          Screen.Cursor := opmC_Wait_Mouse;
          opmG_DBQuery.First;
          WHILE NOT opmG_DBQuery.EOF DO
            BEGIN
              ProdList[CurProd].ID := opmG_DBQuery.Fields[0].AsInteger;
              ProdList[CurProd].Model := FNopm_CleanString (opmG_DBQuery.Fields[2].AsString);
              ProdList[CurProd].Quantity := opmG_DBQuery.Fields[1].AsInteger;
              ProdList[CurProd].Price := opmG_DBQuery.Fields[3].AsCurrency;
              ProdList[CurProd].Weight := opmG_DBQuery.Fields[4].AsFloat;
              ProdList[CurProd].ManufacturerID := opmG_DBQuery.Fields[5].AsInteger;
              ProdList[CurProd].CategoryID := opmG_DBQuery.Fields[12].AsInteger;
              ProdList[CurProd].DisplayName := FNopm_CleanString (opmG_DBQuery.Fields[6].AsString);
              IF (TRIM (ProdList[CurProd].DisplayName) = '') THEN ProdList[CurProd].DisplayName := opmC_Unamed_Prod;
              ProdList[CurProd].Available := opmG_DBQuery.Fields[7].AsInteger;
              ProdList[CurProd].ImageURL := FNopm_CleanString (opmG_DBQuery.Fields[10].AsString);
              ProdList[CurProd].Special := opmG_DBQuery.Fields[11].AsCurrency;
              ProdList[CurProd].LanguageID := opmG_DBQuery.Fields[13].AsInteger;
              ProdList[CurProd].Tax := opmG_DBQuery.Fields[14].AsInteger;

              ProdList[CurProd].CreationDate := FNopm_StringToDate (opmG_DBQuery.Fields[17].AsString);
              IF (ProdList[CurProd].CreationDate < opmG_Fallback_DateTime) THEN
                ProdList[CurProd].CreationDate := opmG_Fallback_DateTime;
              ProdList[CurProd].ChangeDate := FNopm_StringToDate (opmG_DBQuery.Fields[18].AsString);
              IF (ProdList[CurProd].ChangeDate < ProdList[CurProd].CreationDate) THEN
                ProdList[CurProd].ChangeDate := ProdList[CurProd].CreationDate;
              ProdList[CurProd].AvailDate := FNopm_StringToDate (opmG_DBQuery.Fields[16].AsString);
              IF (ProdList[CurProd].AvailDate < ProdList[CurProd].CreationDate) THEN
                ProdList[CurProd].AvailDate := ProdList[CurProd].CreationDate;

              DescList[CurProd].ID := opmG_DBQuery.Fields[0].AsInteger;
              DescList[CurProd].Name := FNopm_CleanString (opmG_DBQuery.Fields[6].AsString);
              IF (TRIM (DescList[CurProd].Name) = '') THEN DescList[CurProd].Name := opmC_Unamed_Prod;
              DescList[CurProd].Description := FNopm_CleanString (opmG_DBQuery.Fields[8].AsString);
              DescList[CurProd].URL := FNopm_CleanString (opmG_DBQuery.Fields[9].AsString);
              DescList[CurProd].Viewed := opmG_DBQuery.Fields[15].AsInteger;
              DescList[CurProd].LanguageID := opmG_DBQuery.Fields[13].AsInteger;
              INC (CurProd);
              opmG_DBQuery.Next;
            END;
          Screen.Cursor := opmC_Normal_Mouse;
        END;
    END;
  opm_TotalProducts := CurProd;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Got products list.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
END;




{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
FUNCTION Topm_Form_Main.FNopm_GetCategory (VAR CatList : opmT_CategoryList; CatID : LONGINT; SearchBy : INTEGER) : opmR_Category;
VAR
  CurCatR : opmR_Category;
  CurCat : LONGINT;
BEGIN
  CurCatR.ID := 0;
  CurCatR.Parent := 0;
  CurCatR.Name := '';
  CurCatR.ListIndex := 0;
  CurCatR.TreeIndex := 0;
  FNopm_GetCategory := CurCatR;
  IF (SearchBy = opmC_FindByID) THEN
    FOR CurCat := 0 TO (opm_TotalCategories - 1) DO
      BEGIN
        IF (CatList[CurCat].ID = CatID) THEN
          BEGIN
            CurCatR.ID := CatList[CurCat].ID;
            CurCatR.Parent := CatList[CurCat].Parent;
            CurCatR.Name := CatList[CurCat].Name;
            CurCatR.ListIndex := CatList[CurCat].ListIndex;
            CurCatR.TreeIndex := CatList[CurCat].TreeIndex;
            FNopm_GetCategory := CurCatR;
            BREAK;
          END;
      END
  ELSE IF (SearchBy = opmC_FindByIndex) THEN
    FOR CurCat := 0 TO (opm_TotalCategories - 1) DO
      BEGIN
        IF (CatList[CurCat].ListIndex = CatID) THEN
          BEGIN
            CurCatR.ID := CatList[CurCat].ID;
            CurCatR.Parent := CatList[CurCat].Parent;
            CurCatR.Name := CatList[CurCat].Name;
            CurCatR.ListIndex := CatList[CurCat].ListIndex;
            CurCatR.TreeIndex := CatList[CurCat].TreeIndex;
            FNopm_GetCategory := CurCatR;
            BREAK;
          END;
      END
  ELSE
    FOR CurCat := 0 TO (opm_TotalCategories - 1) DO
      BEGIN
        IF (CatList[CurCat].TreeIndex = CatID) THEN
          BEGIN
            CurCatR.ID := CatList[CurCat].ID;
            CurCatR.Parent := CatList[CurCat].Parent;
            CurCatR.Name := CatList[CurCat].Name;
            CurCatR.ListIndex := CatList[CurCat].ListIndex;
            CurCatR.TreeIndex := CatList[CurCat].TreeIndex;
            FNopm_GetCategory := CurCatR;
            BREAK;
          END;
      END;
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_GetCategory_Data (CatID : LONGINT; VAR CatData : opmT_SingleCatList);
VAR
  CurCat : LONGINT;
  MaxCat : LONGINT;
  CurLang : LONGINT;
  TmpCatList : opmT_SingleCatList;
BEGIN
  CatData[0].ID := -1;
  CatData[0].Parent := 0;
  CatData[0].Name := '';
  CatData[0].LanguageID := -1;
  CurCat := 0;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, 50, opmC_ProgressNone, _('Getting single category data...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
  IF (FNopm_ExecQuery ('select ' + opmG_DBTable_Categories + '.categories_id, ' + opmG_DBTable_Categories + '.parent_id, ' + opmG_DBTable_CategoriesDescription + '.categories_name, ' + opmG_DBTable_CategoriesDescription + '.language_id from ' + opmG_DBTable_Categories + ' left join ' + opmG_DBTable_CategoriesDescription + ' on ' + opmG_DBTable_Categories + '.categories_id=' + opmG_DBTable_CategoriesDescription + '.categories_id where ' + opmG_DBTable_Categories + '.categories_id=' + INTTOSTR (CatID) + ' ORDER BY ' + opmG_DBTable_CategoriesDescription + '.language_id', opmC_SQLSelect) > 0) THEN
    BEGIN
      IF (opmG_DBQuery.Active = TRUE) THEN
        BEGIN
          Screen.Cursor := opmC_Wait_Mouse;
          opmG_DBQuery.First;
          WHILE NOT opmG_DBQuery.EOF DO
            BEGIN
              CatData[CurCat].ID := opmG_DBQuery.Fields[0].AsInteger;
              CatData[CurCat].Parent := opmG_DBQuery.Fields[1].AsInteger;
              CatData[CurCat].Name := FNopm_CleanString (opmG_DBQuery.Fields[2].AsString);
              CatData[CurCat].LanguageID := opmG_DBQuery.Fields[3].AsInteger;
              IF (CatData[CurCat].Name = '') THEN CatData[CurCat].Name := opmC_Unamed_Cat;
              INC (CurCat);
              opmG_DBQuery.Next;
            END;
          Screen.Cursor := opmC_Normal_Mouse;
        END;
      MaxCat := (CurCat - 1);
      FOR CurLang := 0 TO (opm_TotalLanguages - 1) DO
        BEGIN
          TmpCatList[CurLang].ID := -1;
          TmpCatList[CurLang].Parent := 0;
          TmpCatList[CurLang].Name := '';
          TmpCatList[CurLang].LanguageID := -1;
        END;
      FOR CurLang := 0 TO (opm_TotalLanguages - 1) DO
        BEGIN
          FOR CurCat := 0 TO MaxCat DO
            BEGIN
              IF (CatData[CurCat].LanguageID = opmG_LanguageList[CurLang].ID) THEN
                BEGIN
                  TmpCatList[CurLang] := CatData[CurCat];
                  BREAK;
                END;
            END;
        END;
      CatData := TmpCatList;
      { Sort the array... }
{      FOR CurCat := 0 TO (MaxCat) DO
        BEGIN
          CatIndex := CurCat;
          FOR CatCount2 := (CurCat + 1) TO (MaxCat) DO
            IF (CatData[CatIndex].LanguageID > CatData[CatCount2].LanguageID) THEN CatIndex := CatCount2;
          opm_SwapCatRecord := CatData[CatIndex];
          CatData[CatIndex] := CatData[CurCat];
          CatData[CurCat] := opm_SwapCatRecord;
        END;}
    END;
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Got single category data.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
FUNCTION Topm_Form_Main.FNopm_GetRealLangIDByIndex (VAR LangList : opmT_LanguageList; LangIndex : LONGINT) : LONGINT;
VAR
  CurLang : LONGINT;
BEGIN
  FNopm_GetRealLangIDByIndex := 0;
  FOR CurLang := 0 TO (opm_TotalLanguages - 1) DO
    BEGIN
      IF (LangList[CurLang].ListIndex = LangIndex) THEN
        BEGIN
          FNopm_GetRealLangIDByIndex := LangList[CurLang].ID;
          BREAK;
        END;
    END;
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
FUNCTION Topm_Form_Main.FNopm_GetManufacturer (VAR ManList : opmT_ManufacturerList; ManID : LONGINT; SearchBy : INTEGER) : opmR_Manufacturer;
VAR
  CurManR : opmR_Manufacturer;
  CurMan : LONGINT;
BEGIN
  CurManR.ID := 0;
  CurManR.Name := '';
  CurManR.ListIndex := 0;
  FNopm_GetManufacturer := CurManR;
  IF (SearchBy = opmC_FindByID) THEN
    FOR CurMan := 0 TO (opm_TotalManufacturers - 1) DO
      BEGIN
        IF (ManList[CurMan].ID = ManID) THEN
          BEGIN
            CurManR.ID := ManList[CurMan].ID;
            CurManR.Name := ManList[CurMan].Name;
            CurManR.ListIndex := ManList[CurMan].ListIndex;
            FNopm_GetManufacturer := CurManR;
            BREAK;
          END;
      END
  ELSE
    FOR CurMan := 0 TO (opm_TotalManufacturers - 1) DO
      BEGIN
        IF (ManList[CurMan].ListIndex = ManID) THEN
          BEGIN
            CurManR.ID := ManList[CurMan].ID;
            CurManR.Name := ManList[CurMan].Name;
            CurManR.ListIndex := ManList[CurMan].ListIndex;
            FNopm_GetManufacturer := CurManR;
            BREAK;
          END;
      END;
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
FUNCTION Topm_Form_Main.FNopm_GetProductByID (ProdID, LangID : LONGINT; VAR ProdList : opmT_ProductList) : opmR_Product;
VAR
  CurProdR : opmR_Product;
  CurProd : LONGINT;
BEGIN
  CurProdR.ID := -1;
  FNopm_GetProductByID := CurProdR;
  FOR CurProd := 0 TO (opm_TotalProducts - 1) DO
    BEGIN
      IF ((ProdList[CurProd].ID = ProdID) AND (ProdList[CurProd].LanguageID = LangID)) THEN
        BEGIN
          CurProdR.ID := ProdList[CurProd].ID;
          CurProdR.Model := ProdList[CurProd].Model;
          CurProdR.Quantity := ProdList[CurProd].Quantity;
          CurProdR.Price := ProdList[CurProd].Price;
          CurProdR.Weight := ProdList[CurProd].Weight;
          CurProdR.ManufacturerID := ProdList[CurProd].ManufacturerID;
          CurProdR.CategoryID := ProdList[CurProd].CategoryID;
          CurProdR.DisplayName := ProdList[CurProd].DisplayName;
          CurProdR.Available := ProdList[CurProd].Available;
          CurProdR.ImageURL := ProdList[CurProd].ImageURL;
          CurProdR.Special := ProdList[CurProd].Special;
          CurProdR.LanguageID := ProdList[CurProd].LanguageID;
          CurProdR.Tax := ProdList[CurProd].Tax;
          CurProdR.CreationDate := ProdList[CurProd].CreationDate;
          CurProdR.ChangeDate := ProdList[CurProd].ChangeDate;
          CurProdR.AvailDate := ProdList[CurProd].AvailDate;
          FNopm_GetProductByID := CurProdR;
          BREAK;
        END;
    END;
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
FUNCTION Topm_Form_Main.FNopm_GetDescriptionByID (ProdID, LangID : LONGINT; VAR DescList : opmT_DescriptionList) : opmR_Description;
VAR
  CurDescR : opmR_Description;
  CurDesc : LONGINT;
BEGIN
  CurDescR.ID := -1;
  FNopm_GetDescriptionByID := CurDescR;
  FOR CurDesc := 0 TO (opm_TotalProducts - 1) DO
    BEGIN
      IF ((DescList[CurDesc].ID = ProdID) AND (DescList[CurDesc].LanguageID = LangID)) THEN
        BEGIN
          CurDescR.ID := DescList[CurDesc].ID;
          CurDescR.Name := DescList[CurDesc].Name;
          CurDescR.Description := DescList[CurDesc].Description;
          CurDescR.URL := DescList[CurDesc].URL;
          CurDescR.LanguageID := DescList[CurDesc].LanguageID;
          CurDescR.Viewed := DescList[CurDesc].Viewed;
          FNopm_GetDescriptionByID := CurDescR;
          BREAK;
        END;
    END;
END;





{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_TreeView_MainChange(Sender: TObject; Node: TTreeNode);
begin
  IF (opm_TreeView_Main.Selected <> NIL) THEN
    BEGIN
      opm_CurrentCatRecord := FNopm_GetCategory (opmG_CategoryList, Node.AbsoluteIndex, opmC_FindByNode);
      opm_CurrentCategory := opm_CurrentCatRecord.ID;
      IF (opm_CurrentCatRecord.ID < opmC_SC_BaseID) THEN
        BEGIN
          IF (opmG_UIClickLoad > 0) THEN
            BEGIN
              PRopm_Sound ('MenuPopup', opmG_UISilent);
              PRopm_LoadProductListByCat (opm_CurrentCategory, opmG_ProductList, opmG_DescriptionList);
              PRopm_RenderProductDisplay (opmG_CategoryList, opmG_ManufacturerList, opmG_ProductList, opm_ListView_Main, opm_CurrentProdID);
              IF (opm_CurrentCatRecord.ID > 0) THEN
                PRopm_Valid_CatOps (opm_WeAreConnected, opm_TreeView_Main.Selected)
              ELSE
                PRopm_Valid_CatOps (opm_WeAreConnected, NIL);
              PRopm_Valid_ProdOps (opm_WeAreConnected, opm_ListView_Main.Selected, opm_ListView_Main.SelCount, opm_TreeView_Main.Selected);
            END;
        END
      ELSE
        BEGIN
          { CLICK IN SPECIAL NODE, PROCESS HERE... }
          PRopm_Valid_CatOps (opm_WeAreConnected, NIL);
          PRopm_Valid_ProdOps (opm_WeAreConnected, NIL, 0, NIL);
        END
    END
  ELSE
    BEGIN
      PRopm_Valid_CatOps (opm_WeAreConnected, NIL);
      PRopm_Valid_ProdOps (opm_WeAreConnected, NIL, 0, NIL);
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_MenuItem_RefreshCategoriesClick (Sender: TObject);
begin
  PRopm_LoadLanguageList (opmG_LanguageList);
  PRopm_LoadCategoryList (opmG_CategoryList, opmG_CategoryBoxList);
  PRopm_LoadManufacturerList (opmG_ManufacturerList, opmG_ManufacturerBoxList);
  PRopm_LoadTaxList (opmG_TaxList, opmG_TaxBoxList);
  opm_CurrentCurrency := FNopm_LoadCurrency;
  PRopm_RenderLanguageDisplay (opm_ComboBox_DisplayLang, opmG_LanguageList);
  PRopm_RenderCategoryDisplay (opmG_CategoryList, opm_TreeView_Main, opm_CurrentCategory);
  PRopm_RenderProductDisplay (opmG_CategoryList, opmG_ManufacturerList, opmG_ProductList, opm_ListView_Main, opm_CurrentProdID);
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_MenuItem_RefreshProductsClick(Sender: TObject);
VAR
  CurItem : TListItem;
BEGIN
  CurItem := opm_ListView_Main.Selected;
  IF (CurItem <> NIL) THEN opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
  PRopm_Reload_ProductList (opm_WeAreSearching);
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_ComboBox_DisplayLangSelect(Sender: TObject);
begin
  PRopm_Sound ('MenuPopup', opmG_UISilent);
  opm_CurrentLang := FNopm_GetRealLangIDByIndex (opmG_LanguageList, opm_ComboBox_DisplayLang.ItemIndex);
  PRopm_LoadLanguageList (opmG_LanguageList);
  PRopm_LoadCategoryList (opmG_CategoryList, opmG_CategoryBoxList);
  PRopm_LoadManufacturerList (opmG_ManufacturerList, opmG_ManufacturerBoxList);
  PRopm_LoadTaxList (opmG_TaxList, opmG_TaxBoxList);
  opm_CurrentCurrency := FNopm_LoadCurrency;
  PRopm_RenderLanguageDisplay (opm_ComboBox_DisplayLang, opmG_LanguageList);
  PRopm_RenderCategoryDisplay (opmG_CategoryList, opm_TreeView_Main, opm_CurrentCategory);
  PRopm_RenderProductDisplay (opmG_CategoryList, opmG_ManufacturerList, opmG_ProductList, opm_ListView_Main, opm_CurrentProdID);
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_MenuItem_SearchProductClick(Sender: TObject);
begin
  IF (opm_Form_SearchProduct.ShowModal = mrOk) THEN
    BEGIN
      PRopm_SearchProducts (opm_Search_PCategory, opm_Search_PManufacturer, opm_Search_PModel, opm_Search_PName, opm_Search_PDesc, opm_Search_PSPrice, opm_Search_PImagURL, opm_Search_PAvailable, opmG_ProductList, opmG_DescriptionList);
      PRopm_RenderProductDisplay (opmG_CategoryList, opmG_ManufacturerList, opmG_ProductList, opm_ListView_Main, opm_CurrentProdID);
      PRopm_Valid_ProdOps (opm_WeAreConnected, opm_ListView_Main.Selected, opm_ListView_Main.SelCount, NIL);
    END;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_ListView_MainDblClick(Sender: TObject);
var
   CurItem : TListItem;
   CurLang : LONGINT;
begin
  CurItem := opm_ListView_Main.Selected;
  IF (CurItem <> NIL) THEN
    BEGIN
      opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
      opm_CurrentProdRecord := FNopm_GetProductByID (opm_CurrentProdID, opm_CurrentLang, opmG_ProductList);
      FOR CurLang := 0 TO (opm_TotalLanguages - 1) DO
        opm_CurrentSingleDescList[CurLang] := FNopm_GetDescriptionByID (opm_CurrentProdRecord.ID, opmG_LanguageList[CurLang].ID, opmG_DescriptionList);
      IF (opm_Form_PEdit.ShowModal = mrOk) THEN
        BEGIN
          PRopm_UpdateProduct (opm_CurrentProdRecord, opm_CurrentPEditRecord, opm_CurrentSingleDescList);
        END;
    END;
end;





{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_UpdateProduct (CurProdRecord, NewProdRecord : opmR_Product; SingleDescList : opmT_SingleDescList);
VAR
  UStrProducts, UStrProdCats, IStrProdCats, DStrProdDesc, IStrProdDesc, DStrProdSpec, IStrProdSpec : STRING;
  CurLang : LONGINT;
BEGIN
  IF ((CurProdRecord.Model <> NewProdRecord.Model) OR
      (CurProdRecord.Quantity <> NewProdRecord.Quantity) OR
      (CurProdRecord.ManufacturerID <> NewProdRecord.ManufacturerID) OR
      (CurProdRecord.CategoryID <> NewProdRecord.CategoryID) OR
      (CurProdRecord.Price <> NewProdRecord.Price) OR
      (CurProdRecord.Weight <> NewProdRecord.Weight) OR
      (CurProdRecord.Available <> NewProdRecord.Available) OR
      (CurProdRecord.Special <> NewProdRecord.Special) OR
      (CurProdRecord.Tax <> NewProdRecord.Tax) OR
      (CurProdRecord.AvailDate <> NewProdRecord.AvailDate) OR
      (CurProdRecord.ImageURL <> NewProdRecord.ImageURL)) THEN
    BEGIN
      UStrProducts := '';
      UStrProdCats := '';
      IStrProdCats := '';
      DStrProdSpec := '';
      IStrProdSpec := '';
      IF (opmG_UIConfirmMods = 0) OR ((opmG_UIConfirmMods > 0) AND (FNopm_Message (_('Do you really want to update this product?'), mtConfirmation, [mbYes, mbNo], opmG_UISilent) = mrYes)) THEN
        BEGIN
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Updating product record...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          UStrProducts := 'update ' + opmG_DBTable_Products + ' set products_model="' + NewProdRecord.Model + '",'
                        + ' products_quantity=' + INTTOSTR (NewProdRecord.Quantity) + ','
                        + ' manufacturers_id=' + INTTOSTR (NewProdRecord.ManufacturerID) + ','
                        + ' products_image="' + TRIM (NewProdRecord.ImageURL) + '",'
                        + ' products_price=' + CURRTOSTR (NewProdRecord.Price) + ','
                        + ' products_weight=' + FLOATTOSTR (NewProdRecord.Weight) + ','
                        + ' products_status=' + INTTOSTR (NewProdRecord.Available) + ','
                        + ' products_last_modified=now()' + ', '
                        + ' products_tax_class_id=' + INTTOSTR (NewProdRecord.Tax) + ', '
                        + ' products_date_available="' + FNopm_DateToString (NewProdRecord.AvailDate) + '"'
                        + ' where products_id=' + INTTOSTR (NewProdRecord.ID);
          IF (CurProdRecord.CategoryID <> NewProdRecord.CategoryID) THEN
            IF (NewProdRecord.CategoryID <= 0) THEN
              BEGIN
                UStrProdCats := 'delete from ' + opmG_DBTable_ProductsToCategories + ''
                              + ' where products_id=' + INTTOSTR (NewProdRecord.ID) + ' and categories_id=' + INTTOSTR (CurProdRecord.CategoryID);
              END
            ELSE IF (CurProdRecord.CategoryID <= 0) THEN
              BEGIN
                IStrProdCats := 'insert into ' + opmG_DBTable_ProductsToCategories + ' (products_id, categories_id)' + ''
                              + ' values (' + INTTOSTR (CurProdRecord.ID) + ', ' + INTTOSTR (NewProdRecord.CategoryID) + ')';
              END
            ELSE
              BEGIN
                UStrProdCats := 'update ' + opmG_DBTable_ProductsToCategories + ' set categories_id=' + INTTOSTR (NewProdRecord.CategoryID) + ''
                              + ' where products_id=' + INTTOSTR (NewProdRecord.ID) + ' and categories_id=' + INTTOSTR (CurProdRecord.CategoryID);
              END
          ELSE
            UStrProdCats := '';
          IF (CurProdRecord.Special <> NewProdRecord.Special) THEN
            DStrProdSpec := 'delete from ' + opmG_DBTable_Specials + ''  + ''
                          + ' where products_id=' + INTTOSTR (NewProdRecord.ID)
          ELSE
            DStrProdSpec := '';
          IF ((ROUND (NewProdRecord.Special) > 0) AND (CurProdRecord.Special <> NewProdRecord.Special)) THEN
            IStrProdSpec := 'insert into ' + opmG_DBTable_Specials + ' (products_id, specials_new_products_price, specials_date_added, specials_last_modified)' + ''
                          + ' values (' + INTTOSTR (NewProdRecord.ID) + ', ' + CURRTOSTR (NewProdRecord.Special) + ', now(), now())'
          ELSE
            IStrProdSpec := '';
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, 18, opmC_ProgressNone, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          IF (UStrProducts <> '') THEN FNopm_ExecQuery (UStrProducts, opmC_SQLUpdate);
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, 36, opmC_ProgressNone, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          IF (UStrProdCats <> '') THEN FNopm_ExecQuery (UStrProdCats, opmC_SQLUpdate);
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, 52, opmC_ProgressNone, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          IF (IStrProdCats <> '') THEN FNopm_ExecQuery (IStrProdCats, opmC_SQLInsert);
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, 70, opmC_ProgressNone, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          IF (DStrProdSpec <> '') THEN FNopm_ExecQuery (DStrProdSpec, opmC_SQLDelete);
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, 88, opmC_ProgressNone, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          IF (IStrProdSpec <> '') THEN FNopm_ExecQuery (IStrProdSpec, opmC_SQLInsert);
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, 100, opmC_ProgressNone, _('Product record updated.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
        END;
    END;
    DStrProdDesc := 'delete from ' + opmG_DBTable_ProductsDescription + ''
                  + ' where products_id=' + INTTOSTR (NewProdRecord.ID);
    FNopm_ExecQuery (DStrProdDesc, opmC_SQLDelete);
    FOR CurLang := 0 TO (opm_TotalLanguages - 1) DO
      IF (SingleDescList[CurLang].ID > 0) THEN
        BEGIN
          IStrProdDesc := 'insert into ' + opmG_DBTable_ProductsDescription + ' (products_name, products_description, products_url, products_id, language_id)' + ''
                        + ' values ("' + FNopm_CleanSQLString (SingleDescList[CurLang].Name, FALSE) + '",'
                        + ' "' + FNopm_CleanSQLString (SingleDescList[CurLang].Description, FALSE) + '",'
                        + ' "' + FNopm_CleanSQLString (SingleDescList[CurLang].URL, FALSE) + '", '
                        + INTTOSTR (SingleDescList[CurLang].ID) + ', ' + INTTOSTR (SingleDescList[CurLang].LanguageID) + ')';
          FNopm_ExecQuery (IStrProdDesc, opmC_SQLInsert);
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, (CurLang * ROUND (100 / opmC_Max_Languages_PerList)), opmC_ProgressNone, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code);
        END;
    PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Reloading product list.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
    opm_CurrentCategory := opm_CurrentCatRecord.ID;
    PRopm_Reload_ProductList (opm_WeAreSearching);
    PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Product list loaded.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
END;




{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_UpdateProdData (ProdID : LONGINT; ProdTable, ProdField, ProdDataStr : STRING;
                                               PDataIsNum : BOOLEAN; SecIDField, SecIDData : STRING;
                                               SQLQueryType : INTEGER);
VAR
  UStrProducts, DStrProducts : STRING;
BEGIN
  UStrProducts := '';
  DStrProducts := '';
  IF (ProdID > 0) AND (ProdTable <> '') AND (ProdField <> '') AND (ProdDataStr <> '') THEN
    BEGIN
      IF (opmG_UIConfirmMods = 0) OR ((opmG_UIConfirmMods > 0) AND (FNopm_Message (_('Do you really want to update this product?'), mtConfirmation, [mbYes, mbNo], opmG_UISilent) = mrYes)) THEN
        BEGIN
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, 0, opmC_ProgressIgnore, _('Updating product record...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, 50, opmC_ProgressIgnore, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          IF (SQLQueryType = opmC_SQLUpdate) THEN
            BEGIN
              IF (PDataIsNum = TRUE) THEN
                UStrProducts := 'update ' + ProdTable + ' set ' + ProdField + '=' + ProdDataStr + ''
                              + ' where products_id=' + INTTOSTR (ProdID)
              ELSE
                UStrProducts := 'update ' + ProdTable + ' set ' + ProdField + '="' + FNopm_CleanSQLString (ProdDataStr, FALSE) + '"'
                              + ' where products_id=' + INTTOSTR (ProdID);
              IF (SecIDField <> '') THEN UStrProducts := UStrProducts + ' and ' + SecIDField + '=' + SecIDData;
              FNopm_ExecQuery (UStrProducts, opmC_SQLUpdate);
            END;
          IF ((SQLQueryType = opmC_SQLDelIns) OR (SQLQueryType = opmC_SQLDelInsNoZero)) THEN
            BEGIN
              DStrProducts := 'delete from ' + ProdTable + '' + ' where products_id=' + INTTOSTR (ProdID);
              IF (PDataIsNum = TRUE) THEN
                BEGIN
                  IF NOT ((SQLQueryType = opmC_SQLDelInsNoZero) AND (STRTOFLOAT (ProdDataStr) = 0)) THEN
                    UStrProducts := 'insert into ' + ProdTable + ' (products_id, ' + ProdField + ')' + ''
                                  + ' values (' + INTTOSTR (ProdID) + ', '  + FNopm_CleanSQLString (ProdDataStr, FALSE) + ')';
                END
              ELSE
                BEGIN
                  IF NOT ((SQLQueryType = opmC_SQLDelInsNoZero) AND (ProdDataStr = '')) THEN
                    UStrProducts := 'insert into ' + ProdTable + ' (products_id, ' + ProdField + ')' + ''
                                  + ' values ('  + INTTOSTR (ProdID) + ', "' + FNopm_CleanSQLString (ProdDataStr, FALSE) + '")';
                END;
              FNopm_ExecQuery (DStrProducts, opmC_SQLUpdate);
              FNopm_ExecQuery (UStrProducts, opmC_SQLUpdate);
            END;
          IF (SQLQueryType = opmC_SQLInsert) THEN
            BEGIN
              IF (PDataIsNum = TRUE) THEN
                UStrProducts := 'insert into ' + ProdTable + ' (products_id, ' + ProdField + ')' + ''
                              + ' values (' + INTTOSTR (ProdID) + ', '  + FNopm_CleanSQLString (ProdDataStr, FALSE) + ')'
              ELSE
                UStrProducts := 'insert into ' + ProdTable + ' (products_id, ' + ProdField + ')' + ''
                              + ' values ('  + INTTOSTR (ProdID) + ', "' + FNopm_CleanSQLString (ProdDataStr, FALSE) + '")';
              FNopm_ExecQuery (UStrProducts, opmC_SQLUpdate);
            END;
        END;
    END;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_DeleteProduct (ProdID : LONGINT);
VAR
  DStrProducts, DStrProdDesc, DStrProdSpec, DStrProdCats : STRING;
  ResStr : STRING;
BEGIN
  IF (ProdID > 0) THEN
    BEGIN
      opm_CurrentProdRecord := FNopm_GetProductByID (ProdID, opm_CurrentLang, opmG_ProductList);
      IF (opmG_UIConfirmDels = 0) OR ((opmG_UIConfirmDels > 0) AND (FNopm_Message (_('Do you really want to delete this product?'), mtConfirmation, [mbYes, mbNo], opmG_UISilent) = mrYes)) THEN
        BEGIN
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, 18, opmC_ProgressIgnore, _('Deleting product record...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          PRopm_Prepare_HTTPClient (NIL, NIL);
          DStrProducts := 'delete from ' + opmG_DBTable_Products + ' where products_id=' + INTTOSTR (ProdID);
          DStrProdCats := 'delete from ' + opmG_DBTable_ProductsToCategories + ' where products_id=' + INTTOSTR (ProdID);
          DStrProdSpec := 'delete from ' + opmG_DBTable_Specials + ' where products_id=' + INTTOSTR (ProdID);
          DStrProdDesc := 'delete from ' + opmG_DBTable_ProductsDescription + ' where products_id=' + INTTOSTR (ProdID);
          IF (FNopm_ExecQuery (DStrProducts, opmC_SQLUpdate) >= 0) THEN
            BEGIN
              PRopm_Update_StatusBar (opmC_ConnStatIgnore, 36, opmC_ProgressIgnore, _('Deleting product record...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
              FNopm_Send_Command (opmG_WBUploadURL, 'delete', opm_CurrentProdRecord.ImageURL, ResStr);
              PRopm_Update_StatusBar (opmC_ConnStatIgnore, 54, opmC_ProgressIgnore, _('Deleting product record...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
              FNopm_ExecQuery (DStrProdCats, opmC_SQLUpdate);
              PRopm_Update_StatusBar (opmC_ConnStatIgnore, 72, opmC_ProgressIgnore, _('Deleting product record...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
              FNopm_ExecQuery (DStrProdSpec, opmC_SQLUpdate);
              PRopm_Update_StatusBar (opmC_ConnStatIgnore, 90, opmC_ProgressIgnore, _('Deleting product record...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
              FNopm_ExecQuery (DStrProdDesc, opmC_SQLUpdate);
            END;
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, 0, opmC_ProgressIgnore, _('Product deleted.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
        END;
    END;
END;




{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_AddProduct (NewProdRecord : opmR_Product; SingleDescList : opmT_SingleDescList);
VAR
  IStrProducts, IStrProdCats, IStrProdDesc, IStrProdSpec, IStrCheckID : STRING;
  LastID : LONGINT;
  CurLang : LONGINT;
BEGIN
  IF ((NewProdRecord.CategoryID > 0) AND
      (NewProdRecord.Price > 0)) THEN
    BEGIN
      LastID := 0;
      PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Adding product record...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
      IStrProducts := 'insert into ' + opmG_DBTable_Products + ' (products_model, products_quantity, manufacturers_id, products_price, products_weight, products_status, products_last_modified, products_date_added, products_tax_class_id, products_date_available, products_image)' + ''
                    + ' values ("' + NewProdRecord.Model + '", '
                    + INTTOSTR (NewProdRecord.Quantity) + ', ' + INTTOSTR (NewProdRecord.ManufacturerID) + ', '
                    + CURRTOSTR (NewProdRecord.Price) + ', ' + FLOATTOSTR (NewProdRecord.Weight) + ', '
                    + INTTOSTR (NewProdRecord.Available) + ', ' + 'now(), now(), '
                    + INTTOSTR (NewProdRecord.Tax) + ', "' + FNopm_DateToString (NewProdRecord.AvailDate) + '", "' + TRIM (NewProdRecord.ImageURL) + '")';
      IStrCheckID := 'select products_id from ' + opmG_DBTable_Products + ' where products_id=last_insert_id()';
      PRopm_Update_StatusBar (opmC_ConnStatIgnore, 30, opmC_ProgressNone, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code);
      FNopm_ExecQuery (IStrProducts, opmC_SQLInsert);
      IF (FNopm_ExecQuery (IStrCheckID, opmC_SQLSelect) > 0) THEN
        IF (opmG_DBQuery.Active = TRUE) THEN
          BEGIN
            opmG_DBQuery.First;
            LastID := opmG_DBQuery.Fields[0].AsInteger;
          END;
      IF (LastID > 0) THEN
        BEGIN
          IStrProdCats := 'insert into ' + opmG_DBTable_ProductsToCategories + ' (products_id, categories_id)' + ''
                        + ' values (' + INTTOSTR (LastID) + ', ' + INTTOSTR (NewProdRecord.CategoryID) + ')';
          IF (ROUND (NewProdRecord.Special) > 0) THEN
            IStrProdSpec := 'insert into ' + opmG_DBTable_Specials + ' (products_id, specials_new_products_price, specials_date_added, specials_last_modified)' + ''
                          + ' values (' + INTTOSTR (LastID) + ', ' + CURRTOSTR (NewProdRecord.Special) + ', now(), now())'
          ELSE
            IStrProdSpec := '';
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, 60, opmC_ProgressNone, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          FNopm_ExecQuery (IStrProdCats, opmC_SQLInsert);
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, 90, opmC_ProgressNone, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          IF (IStrProdSpec <> '') THEN FNopm_ExecQuery (IStrProdSpec, opmC_SQLInsert);
        END;
        FOR CurLang := 0 TO (opm_TotalLanguages - 1) DO
          IF (SingleDescList[CurLang].ID = opmC_InsertProdID) THEN
            BEGIN
              IStrProdDesc := 'insert into ' + opmG_DBTable_ProductsDescription + ' (products_name, products_description, products_url, products_id, language_id, products_viewed)' + ''
                            + ' values ("' + FNopm_CleanSQLString (SingleDescList[CurLang].Name, FALSE) + '",'
                            + ' "' + FNopm_CleanSQLString (SingleDescList[CurLang].Description, FALSE) + '",'
                            + ' "' + FNopm_CleanSQLString (SingleDescList[CurLang].URL, FALSE) + '", '
                            + INTTOSTR (LastID) + ', ' + INTTOSTR (SingleDescList[CurLang].LanguageID) + ', 0)';
              FNopm_ExecQuery (IStrProdDesc, opmC_SQLInsert);
              PRopm_Update_StatusBar (opmC_ConnStatIgnore, (CurLang * ROUND (100 / opmC_Max_Languages_PerList)), opmC_ProgressNone, '', opmC_PTotalIgnore, opm_CurrentCurrency.Code);
            END;
      PRopm_Update_StatusBar (opmC_ConnStatIgnore, 100, opmC_ProgressNone, _('Product record added.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
      PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Reloading product list.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
      opm_CurrentCategory := opm_CurrentCatRecord.ID;
      PRopm_Reload_ProductList (opm_WeAreSearching);
      PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Product list loaded.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
    END;
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_Valid_CatOps (WeAreConnected : BOOLEAN; SelectedCat : TTreeNode);
BEGIN
  IF (WeAreConnected = TRUE) THEN
    BEGIN
      opm_MenuItem_RefreshCategories.Enabled := TRUE;
      opm_MenuItem_SearchProduct.Enabled := TRUE;
      opm_ToolButton_Search.Enabled := TRUE;
      IF (SelectedCat <> NIL) THEN
        BEGIN
          opm_MenuItem_CategoryAdd.Enabled := TRUE;
          opm_ToolButton_AddCat.Enabled := TRUE;
          opm_PopMenuItem_CatAdd.Enabled := TRUE;
          opm_MenuItem_CategoryRename.Enabled := TRUE;
          opm_ToolButton_RenCat.Enabled := TRUE;
          opm_PopMenuItem_CatRename.Enabled := TRUE;
          opm_MenuItem_CategoryDelete.Enabled := TRUE;
          opm_ToolButton_DelCat.Enabled := TRUE;
          opm_PopMenuItem_CatDelete.Enabled := TRUE;
          opm_PopMenuItem_CatExpand2.Enabled := TRUE;
          opm_PopMenuItem_CatCollapse2.Enabled := TRUE;
          opm_PopMenuItem_CatExpand.Enabled := TRUE;
          opm_PopMenuItem_CatCollapse.Enabled := TRUE;
        END
      ELSE
        BEGIN
          opm_MenuItem_CategoryAdd.Enabled := FALSE;
          opm_ToolButton_AddCat.Enabled := FALSE;
          opm_PopMenuItem_CatAdd.Enabled := FALSE;
          opm_MenuItem_CategoryRename.Enabled := FALSE;
          opm_ToolButton_RenCat.Enabled := FALSE;
          opm_PopMenuItem_CatRename.Enabled := FALSE;
          opm_MenuItem_CategoryDelete.Enabled := FALSE;
          opm_ToolButton_DelCat.Enabled := FALSE;
          opm_PopMenuItem_CatDelete.Enabled := FALSE;
          opm_PopMenuItem_CatExpand2.Enabled := FALSE;
          opm_PopMenuItem_CatCollapse2.Enabled := FALSE;
          opm_PopMenuItem_CatExpand.Enabled := FALSE;
          opm_PopMenuItem_CatCollapse.Enabled := FALSE;
        END;
    END
  ELSE
    BEGIN
      opm_MenuItem_RefreshCategories.Enabled := FALSE;
      opm_MenuItem_SearchProduct.Enabled := FALSE;
      opm_ToolButton_Search.Enabled := FALSE;
      opm_MenuItem_CategoryAdd.Enabled := FALSE;
      opm_ToolButton_AddCat.Enabled := FALSE;
      opm_PopMenuItem_CatAdd.Enabled := FALSE;
      opm_MenuItem_CategoryRename.Enabled := FALSE;
      opm_ToolButton_RenCat.Enabled := FALSE;
      opm_PopMenuItem_CatRename.Enabled := FALSE;
      opm_MenuItem_CategoryDelete.Enabled := FALSE;
      opm_ToolButton_DelCat.Enabled := FALSE;
      opm_PopMenuItem_CatDelete.Enabled := FALSE;
      opm_PopMenuItem_CatExpand2.Enabled := FALSE;
      opm_PopMenuItem_CatCollapse2.Enabled := FALSE;
      opm_PopMenuItem_CatExpand.Enabled := FALSE;
      opm_PopMenuItem_CatCollapse.Enabled := FALSE;
    END;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_Valid_ProdOps (WeAreConnected : BOOLEAN; SelectedProduct : TListItem; SelectedProds : LONGINT; SelectedCat : TTreeNode);
BEGIN
  IF (WeAreConnected = TRUE) THEN
    BEGIN
      IF (((SelectedCat <> NIL) OR (SelectedProduct <> NIL)) AND (SelectedProds < 2)) THEN
        BEGIN
          opm_MenuItem_ProductAdd.Enabled := TRUE;
          opm_ToolButton_AddProduct.Enabled := TRUE;
          opm_PopMenuItem_PAdd.Enabled := TRUE;
        END
      ELSE
        BEGIN
          opm_MenuItem_ProductAdd.Enabled := FALSE;
          opm_ToolButton_AddProduct.Enabled := FALSE;
          opm_PopMenuItem_PAdd.Enabled := FALSE;
        END;
      IF (SelectedCat <> NIL) THEN
        BEGIN
          opm_MenuItem_RefreshProducts.Enabled := TRUE;
          opm_MenuItem_ProductSelAll.Enabled := TRUE;
          opm_PopMenuItem_PSelAll.Enabled := TRUE;
          opm_ToolButton_Refresh.Enabled := TRUE;
        END
      ELSE
        BEGIN
          opm_MenuItem_RefreshProducts.Enabled := FALSE;
          opm_MenuItem_ProductSelAll.Enabled := FALSE;
          opm_PopMenuItem_PSelAll.Enabled := FALSE;
          opm_ToolButton_Refresh.Enabled := FALSE;
        END;
      IF (SelectedProduct <> NIL) THEN
        BEGIN
          IF (SelectedProds > 1) THEN
            BEGIN
              opm_MenuItem_ProductEdit.Enabled := FALSE;
              opm_ToolButton_EditProduct.Enabled := FALSE;
              opm_PopMenuItem_PEdit.Enabled := FALSE;
              opm_PopMenuItem_PModel.Enabled := FALSE;
              opm_PopMenuItem_PWeight.Enabled := FALSE;
            END
          ELSE
            BEGIN
              opm_MenuItem_ProductEdit.Enabled := TRUE;
              opm_ToolButton_EditProduct.Enabled := TRUE;
              opm_PopMenuItem_PEdit.Enabled := TRUE;
              opm_PopMenuItem_PModel.Enabled := TRUE;
              opm_PopMenuItem_PWeight.Enabled := TRUE;
            END;
          opm_MenuItem_ProductDel.Enabled := TRUE;
          opm_MenuItem_ProductCopy.Enabled := TRUE;
          opm_MenuItem_ProductCopyAsText.Enabled := TRUE;
          opm_MenuItem_ProductCopyAsPre.Enabled := TRUE;
          opm_MenuItem_ProductExport.Enabled := TRUE;
          opm_MenuItem_ProductPrint.Enabled := TRUE;
          opm_ToolButton_DeleteProduct.Enabled := TRUE;
          opm_ToolButton_ExportProduct.Enabled := TRUE;
          opm_ToolButton_PrintProduct.Enabled := TRUE;
          opm_PopMenuItem_PMod.Enabled := TRUE;
          opm_PopMenuItem_PAvailability.Enabled := TRUE;
          opm_PopMenuItem_PAvailable.Enabled := TRUE;
          opm_PopMenuItem_PNotAvailable.Enabled := TRUE;
          opm_PopMenuItem_PPrice.Enabled := TRUE;
          opm_PopMenuItem_PSpecial.Enabled := TRUE;
          opm_PopMenuItem_PQuantity.Enabled := TRUE;
          opm_PopMenuItem_PCat.Enabled := TRUE;
          opm_PopMenuItem_PMan.Enabled := TRUE;
          opm_PopMenuItem_PDelete.Enabled := TRUE;
          opm_PopMenuItem_PCopy.Enabled := TRUE;
          opm_PopMenuItem_PCopyAsText.Enabled := TRUE;
          opm_PopMenuItem_PCopyAsPre.Enabled := TRUE;
          opm_PopMenuItem_PExport.Enabled := TRUE;
          opm_PopMenuItem_PPrint.Enabled := TRUE;
        END
      ELSE
        BEGIN
          opm_MenuItem_ProductEdit.Enabled := FALSE;
          opm_MenuItem_ProductDel.Enabled := FALSE;
          opm_MenuItem_ProductCopy.Enabled := FALSE;
          opm_MenuItem_ProductCopyAsText.Enabled := FALSE;
          opm_MenuItem_ProductCopyAsPre.Enabled := FALSE;
          opm_MenuItem_ProductExport.Enabled := FALSE;
          opm_MenuItem_ProductPrint.Enabled := FALSE;
          opm_ToolButton_EditProduct.Enabled := FALSE;
          opm_ToolButton_DeleteProduct.Enabled := FALSE;
          opm_ToolButton_ExportProduct.Enabled := FALSE;
          opm_ToolButton_PrintProduct.Enabled := FALSE;
          opm_PopMenuItem_PEdit.Enabled := FALSE;
          opm_PopMenuItem_PMod.Enabled := FALSE;
          opm_PopMenuItem_PAvailability.Enabled := FALSE;
          opm_PopMenuItem_PAvailable.Enabled := FALSE;
          opm_PopMenuItem_PNotAvailable.Enabled := FALSE;
          opm_PopMenuItem_PPrice.Enabled := FALSE;
          opm_PopMenuItem_PSpecial.Enabled := FALSE;
          opm_PopMenuItem_PQuantity.Enabled := FALSE;
          opm_PopMenuItem_PCat.Enabled := FALSE;
          opm_PopMenuItem_PMan.Enabled := FALSE;
          opm_PopMenuItem_PModel.Enabled := FALSE;
          opm_PopMenuItem_PWeight.Enabled := FALSE;
          opm_PopMenuItem_PDelete.Enabled := FALSE;
          opm_PopMenuItem_PCopy.Enabled := FALSE;
          opm_PopMenuItem_PCopyAsText.Enabled := FALSE;
          opm_PopMenuItem_PCopyAsPre.Enabled := FALSE;
          opm_PopMenuItem_PExport.Enabled := FALSE;
          opm_PopMenuItem_PPrint.Enabled := FALSE;
        END;
    END
  ELSE
    BEGIN
      opm_MenuItem_RefreshProducts.Enabled := FALSE;
      opm_MenuItem_ProductAdd.Enabled := FALSE;
      opm_MenuItem_ProductEdit.Enabled := FALSE;
      opm_MenuItem_ProductDel.Enabled := FALSE;
      opm_MenuItem_ProductSelAll.Enabled := FALSE;
      opm_MenuItem_ProductCopy.Enabled := FALSE;
      opm_MenuItem_ProductCopyAsText.Enabled := FALSE;
      opm_MenuItem_ProductCopyAsPre.Enabled := FALSE;
      opm_MenuItem_ProductExport.Enabled := FALSE;
      opm_MenuItem_ProductPrint.Enabled := FALSE;
      opm_ToolButton_Refresh.Enabled := FALSE;
      opm_ToolButton_AddProduct.Enabled := FALSE;
      opm_ToolButton_EditProduct.Enabled := FALSE;
      opm_ToolButton_DeleteProduct.Enabled := FALSE;
      opm_ToolButton_ExportProduct.Enabled := FALSE;
      opm_ToolButton_PrintProduct.Enabled := FALSE;
      opm_PopMenuItem_PEdit.Enabled := FALSE;
      opm_PopMenuItem_PMod.Enabled := FALSE;
      opm_PopMenuItem_PAvailability.Enabled := FALSE;
      opm_PopMenuItem_PAvailable.Enabled := FALSE;
      opm_PopMenuItem_PNotAvailable.Enabled := FALSE;
      opm_PopMenuItem_PPrice.Enabled := FALSE;
      opm_PopMenuItem_PSpecial.Enabled := FALSE;
      opm_PopMenuItem_PQuantity.Enabled := FALSE;
      opm_PopMenuItem_PCat.Enabled := FALSE;
      opm_PopMenuItem_PMan.Enabled := FALSE;
      opm_PopMenuItem_PModel.Enabled := FALSE;
      opm_PopMenuItem_PWeight.Enabled := FALSE;
      opm_PopMenuItem_PAdd.Enabled := FALSE;
      opm_PopMenuItem_PDelete.Enabled := FALSE;
      opm_PopMenuItem_PSelAll.Enabled := FALSE;
      opm_PopMenuItem_PCopy.Enabled := FALSE;
      opm_PopMenuItem_PCopyAsText.Enabled := FALSE;
      opm_PopMenuItem_PCopyAsPre.Enabled := FALSE;
      opm_PopMenuItem_PExport.Enabled := FALSE;
      opm_PopMenuItem_PPrint.Enabled := FALSE;
    END;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_Valid_GralOps (WeAreConnected : BOOLEAN);
BEGIN
  IF (WeAreConnected = TRUE) THEN
    BEGIN
      opm_MenuItem_Connect.Enabled := FALSE;
      opm_ToolButton_Connect.Enabled := FALSE;
      opm_PopMenuItem_ConnConn.Enabled := FALSE;
      opm_MenuItem_Disconnect.Enabled := TRUE;
      opm_ToolButton_Disconnect.Enabled := TRUE;
      opm_PopMenuItem_ConnDisconn.Enabled := TRUE;
    END
  ELSE
    BEGIN
      opm_MenuItem_Connect.Enabled := TRUE;
      opm_ToolButton_Connect.Enabled := TRUE;
      opm_PopMenuItem_ConnConn.Enabled := TRUE;
      opm_MenuItem_Disconnect.Enabled := FALSE;
      opm_ToolButton_Disconnect.Enabled := FALSE;
      opm_PopMenuItem_ConnDisconn.Enabled := FALSE;
    END;
END;






{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_ListView_MainChange(Sender: TObject; Item: TListItem; Change: TItemChange);
begin
  PRopm_Valid_ProdOps (opm_WeAreConnected, opm_ListView_Main.Selected, opm_ListView_Main.SelCount, opm_TreeView_Main.Selected);
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_Reload_ProductList (SearchLoad : BOOLEAN);
BEGIN
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Reloading product list.'), 0, opm_CurrentCurrency.Code);
  IF (SearchLoad = FALSE) THEN
    BEGIN
      opm_CurrentCategory := opm_CurrentCatRecord.ID;
      PRopm_LoadProductListByCat (opm_CurrentCategory, opmG_ProductList, opmG_DescriptionList);
    END
  ELSE
    BEGIN
      PRopm_SearchProducts (opm_Search_PCategory, opm_Search_PManufacturer, opm_Search_PModel, opm_Search_PName, opm_Search_PDesc, opm_Search_PSPrice, opm_Search_PImagURL, opm_Search_PAvailable, opmG_ProductList, opmG_DescriptionList);
    END;
  PRopm_RenderProductDisplay (opmG_CategoryList, opmG_ManufacturerList, opmG_ProductList, opm_ListView_Main, opm_CurrentProdID);
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Product list loaded.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PAvailableClick(Sender: TObject);
VAR
  CurItem : TListItem;
  ProgStep, Progress : LONGINT;
BEGIN
  CurItem := opm_ListView_Main.Selected;
  Progress := 0;
  IF (CurItem <> NIL) THEN
    BEGIN
      ProgStep := ROUND (100 / opm_ListView_Main.SelCount);
      opm_ListView_Main.Enabled := FALSE;
      WHILE (CurItem <> NIL) DO
        BEGIN
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, Progress, _('Updating availability...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
          PRopm_UpdateProdData (opm_CurrentProdID, opmG_DBTable_Products, 'products_status', '1', TRUE, '', '', opmC_SQLUpdate);
          CurItem := opm_ListView_Main.GetNextItem (CurItem, sdAll, [isSelected]);
          INC (Progress, ProgStep);
        END;
      PRopm_Reload_ProductList (opm_WeAreSearching);
      opm_ListView_Main.Enabled := TRUE;
      opm_Form_Main.FocusControl (opm_ListView_Main);
    END;
END;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PNotAvailableClick(Sender: TObject);
VAR
  CurItem : TListItem;
  ProgStep, Progress : LONGINT;
BEGIN
  CurItem := opm_ListView_Main.Selected;
  Progress := 0;
  IF (CurItem <> NIL) THEN
    BEGIN
      ProgStep := ROUND (100 / opm_ListView_Main.SelCount);
      opm_ListView_Main.Enabled := FALSE;
      WHILE (CurItem <> NIL) DO
        BEGIN
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, Progress, _('Updating availability...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
          PRopm_UpdateProdData (opm_CurrentProdID, opmG_DBTable_Products, 'products_status', '0', TRUE, '', '', opmC_SQLUpdate);
          CurItem := opm_ListView_Main.GetNextItem (CurItem, sdAll, [isSelected]);
          INC (Progress, ProgStep);
        END;
      PRopm_Reload_ProductList (opm_WeAreSearching);
      opm_ListView_Main.Enabled := TRUE;
      opm_Form_Main.FocusControl (opm_ListView_Main);
    END;
END;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PPriceClick(Sender: TObject);
VAR
  CurItem : TListItem;
  Operand, NewPrice : STRING;
  FirstPass, CanContinue : BOOLEAN;
  ProgStep, Progress : LONGINT;
BEGIN
  CurItem := opm_ListView_Main.Selected;
  FirstPass := TRUE;
  CanContinue := TRUE;
  Progress := 0;
  IF (CurItem <> NIL) THEN
    BEGIN
      ProgStep := ROUND (100 / opm_ListView_Main.SelCount);
      opm_ListView_Main.Enabled := FALSE;
      WHILE (CurItem <> NIL) DO
        BEGIN
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, Progress, _('Updating prices...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
          opm_CurrentProdRecord := FNopm_GetProductByID (opm_CurrentProdID, opm_CurrentLang, opmG_ProductList);
          IF (FirstPass = TRUE) THEN
            BEGIN
              IF (opm_ListView_Main.SelCount > 1) THEN
                BEGIN
                  opm_Form_AskUser.AU_Title := _('Change price for products');
                  opm_Form_AskUser.AU_DataText := '0.00';
                END
              ELSE
                BEGIN
                  opm_Form_AskUser.AU_Title := _('Change price for product ') + opm_CurrentProdRecord.DisplayName;
                  opm_Form_AskUser.AU_DataText := CURRTOSTR (opm_CurrentProdRecord.Price);
                END;
              opm_Form_AskUser.AU_Directions := _('Type the new price (xxx, -xxx, +xxx, -xxx%, +xxx%):') + ' [' + TRIM (opm_CurrentCurrency.Code + ' ' + opm_CurrentCurrency.Left + ' ' + opm_CurrentCurrency.Right) + ']';
              opm_Form_AskUser.AU_TextOrList := TRUE;
              opm_Form_AskUser.AU_PassChar := #0;
              opm_Form_AskUser.AU_MaxLen := opmC_ProdPrice_MaxLen;
              FirstPass := FALSE;
              IF (opm_Form_AskUser.ShowModal = mrOk) THEN CanContinue := TRUE ELSE CanContinue := FALSE;
              Operand := FNopm_CleanNumber (opm_Form_AskUser.AU_DataText, opmC_ValIsNumOp);
            END;
          IF (CanContinue = TRUE) THEN
            BEGIN
              NewPrice := FNopm_Apply_Operation (CURRTOSTR (opm_CurrentProdRecord.Price), Operand, opmC_ValIsFloat, FALSE);
              IF ((STRTOCURR (NewPrice) = 0) AND (opmG_UIAllowZeroPrice = 0)) THEN
                FNopm_Message (_('Zero value not allowed.'), mtError, [mbOk], opmG_UISilent)
              ELSE
                PRopm_UpdateProdData (opm_CurrentProdID, opmG_DBTable_Products, 'products_price', NewPrice, TRUE, '', '', opmC_SQLUpdate);
            END
          ELSE BREAK;
          CurItem := opm_ListView_Main.GetNextItem (CurItem, sdAll, [isSelected]);
          INC (Progress, ProgStep);
        END;
      IF (CanContinue = TRUE) THEN PRopm_Reload_ProductList (opm_WeAreSearching);
      opm_ListView_Main.Enabled := TRUE;
      opm_Form_Main.FocusControl (opm_ListView_Main);
    END;
END;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PSpecialClick(Sender: TObject);
VAR
  CurItem : TListItem;
  NewSpecial : STRING;
  FirstPass, CanContinue : BOOLEAN;
  ProgStep, Progress : LONGINT;
BEGIN
  CurItem := opm_ListView_Main.Selected;
  FirstPass := TRUE;
  CanContinue := TRUE;
  Progress := 0;
  IF (CurItem <> NIL) THEN
    BEGIN
      ProgStep := ROUND (100 / opm_ListView_Main.SelCount);
      opm_ListView_Main.Enabled := FALSE;
      WHILE (CurItem <> NIL) DO
        BEGIN
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, Progress, _('Updating special prices...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
          opm_CurrentProdRecord := FNopm_GetProductByID (opm_CurrentProdID, opm_CurrentLang, opmG_ProductList);
          IF (FirstPass = TRUE) THEN
            BEGIN
              IF (opm_ListView_Main.SelCount > 1) THEN
                BEGIN
                  opm_Form_AskUser.AU_Title := _('Change special price for products');
                  opm_Form_AskUser.AU_DataText := '0.00';
                END
              ELSE
                BEGIN
                  opm_Form_AskUser.AU_Title := _('Change special price for product ') + opm_CurrentProdRecord.DisplayName;
                  opm_Form_AskUser.AU_DataText := CURRTOSTR (opm_CurrentProdRecord.Price);
                END;
              opm_Form_AskUser.AU_Directions := _('Type the new special price (xxx, -xxx, +xxx, -xxx%, +xxx%, 0 to disable):') + ' [' + TRIM (opm_CurrentCurrency.Code + ' ' + opm_CurrentCurrency.Left + ' ' + opm_CurrentCurrency.Right) + ']';
              opm_Form_AskUser.AU_TextOrList := TRUE;
              opm_Form_AskUser.AU_PassChar := #0;
              opm_Form_AskUser.AU_MaxLen := opmC_ProdSpecial_MaxLen;
              FirstPass := FALSE;
              IF (opm_Form_AskUser.ShowModal = mrOk) THEN CanContinue := TRUE ELSE CanContinue := FALSE;
              NewSpecial := FNopm_CleanNumber (opm_Form_AskUser.AU_DataText, opmC_ValIsNumOp);
            END;
          IF (CanContinue = TRUE) THEN PRopm_UpdateProdData (opm_CurrentProdID, opmG_DBTable_Specials, 'specials_new_products_price', FNopm_Apply_Operation (CURRTOSTR (opm_CurrentProdRecord.Price), NewSpecial, opmC_ValIsFloat, FALSE), TRUE, '', '', opmC_SQLDelInsNoZero) ELSE BREAK;
          CurItem := opm_ListView_Main.GetNextItem (CurItem, sdAll, [isSelected]);
          INC (Progress, ProgStep);
        END;
      IF (CanContinue = TRUE) THEN PRopm_Reload_ProductList (opm_WeAreSearching);
      opm_ListView_Main.Enabled := TRUE;
      opm_Form_Main.FocusControl (opm_ListView_Main);
    END;
END;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PQuantityClick(Sender: TObject);
VAR
  CurItem : TListItem;
  Operand, NewQuantity : STRING;
  FirstPass, CanContinue : BOOLEAN;
  ProgStep, Progress : LONGINT;
BEGIN
  CurItem := opm_ListView_Main.Selected;
  FirstPass := TRUE;
  CanContinue := TRUE;
  Progress := 0;
  IF (CurItem <> NIL) THEN
    BEGIN
      ProgStep := ROUND (100 / opm_ListView_Main.SelCount);
      opm_ListView_Main.Enabled := FALSE;
      WHILE (CurItem <> NIL) DO
        BEGIN
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, Progress, _('Updating quantity...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
          opm_CurrentProdRecord := FNopm_GetProductByID (opm_CurrentProdID, opm_CurrentLang, opmG_ProductList);
          IF (FirstPass = TRUE) THEN
            BEGIN
              IF (opm_ListView_Main.SelCount > 1) THEN
                BEGIN
                  opm_Form_AskUser.AU_Title := _('Change quantity for products');
                  opm_Form_AskUser.AU_DataText := '0';
                END
              ELSE
                BEGIN
                  opm_Form_AskUser.AU_Title := _('Change quantity for product ') + opm_CurrentProdRecord.DisplayName;
                  opm_Form_AskUser.AU_DataText := INTTOSTR (opm_CurrentProdRecord.Quantity);
                END;
              opm_Form_AskUser.AU_Directions := _('Type the new quantity (xxx, -xxx, +xxx, -xxx%, +xxx%):');
              opm_Form_AskUser.AU_TextOrList := TRUE;
              opm_Form_AskUser.AU_PassChar := #0;
              opm_Form_AskUser.AU_MaxLen := opmC_ProdQuantity_MaxLen;
              FirstPass := FALSE;
              IF (opm_Form_AskUser.ShowModal = mrOk) THEN CanContinue := TRUE ELSE CanContinue := FALSE;
              Operand := FNopm_CleanNumber (opm_Form_AskUser.AU_DataText, opmC_ValIsNumOp);
            END;
          IF (CanContinue = TRUE) THEN
            BEGIN
              NewQuantity := FNopm_Apply_Operation (INTTOSTR (opm_CurrentProdRecord.Quantity), Operand, opmC_ValIsInteger, (opmG_UIAllowNegativeQuantity = 1));
              IF ((STRTOINT (NewQuantity) < 0) AND (opmG_UIAllowNegativeQuantity = 0)) THEN
                FNopm_Message (_('Negative value not allowed.'), mtError, [mbOk], opmG_UISilent)
              ELSE
                PRopm_UpdateProdData (opm_CurrentProdID, opmG_DBTable_Products, 'products_quantity', NewQuantity, TRUE, '', '', opmC_SQLUpdate);
	    END
          ELSE BREAK;
          CurItem := opm_ListView_Main.GetNextItem (CurItem, sdAll, [isSelected]);
          INC (Progress, ProgStep);
        END;
      IF (CanContinue = TRUE) THEN PRopm_Reload_ProductList (opm_WeAreSearching);
      opm_ListView_Main.Enabled := TRUE;
      opm_Form_Main.FocusControl (opm_ListView_Main);
    END;
END;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PManClick(Sender: TObject);
VAR
  CurItem : TListItem;
  CurMan : opmR_Manufacturer;
  FirstPass, CanContinue : BOOLEAN;
  ProgStep, Progress : LONGINT;
begin
  CurItem := opm_ListView_Main.Selected;
  FirstPass := TRUE;
  CanContinue := TRUE;
  Progress := 0;
  IF (CurItem <> NIL) THEN
    BEGIN
      ProgStep := ROUND (100 / opm_ListView_Main.SelCount);
      opm_ListView_Main.Enabled := FALSE;
      WHILE (CurItem <> NIL) DO
        BEGIN
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, Progress, _('Updating manufacturer...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
          opm_CurrentProdRecord := FNopm_GetProductByID (opm_CurrentProdID, opm_CurrentLang, opmG_ProductList);
          IF (FirstPass = TRUE) THEN
            BEGIN
              opm_CurrentManRecord := FNopm_GetManufacturer (opmG_ManufacturerList, opm_CurrentProdRecord.ManufacturerID, opmC_FindByID);
              opm_Form_AskUser.AU_DataList := opmG_ManufacturerBoxList;
              IF (opm_ListView_Main.SelCount > 1) THEN
                BEGIN
                  opm_Form_AskUser.AU_Title := _('Change manufacturer for products');
                  opm_Form_AskUser.AU_ListItem := 0;
                END
              ELSE
                BEGIN
                  opm_Form_AskUser.AU_Title := _('Change manufacturer for product ') + opm_CurrentProdRecord.DisplayName;
                  opm_Form_AskUser.AU_ListItem := opm_CurrentManRecord.ListIndex;
                END;
              opm_Form_AskUser.AU_Directions := _('Select the new manufacturer:');
              opm_Form_AskUser.AU_TextOrList := FALSE;
              FirstPass := FALSE;
              IF (opm_Form_AskUser.ShowModal = mrOk) THEN CanContinue := TRUE ELSE CanContinue := FALSE;
              CurMan := FNopm_GetManufacturer (opmG_ManufacturerList, opm_Form_AskUser.AU_ListItem, opmC_FindByIndex);
            END;
          IF (CanContinue = TRUE) THEN PRopm_UpdateProdData (opm_CurrentProdID, opmG_DBTable_Products, 'manufacturers_id', INTTOSTR (CurMan.ID), TRUE, '', '', opmC_SQLUpdate) ELSE BREAK;
          CurItem := opm_ListView_Main.GetNextItem (CurItem, sdAll, [isSelected]);
          INC (Progress, ProgStep);
        END;
      IF (CanContinue = TRUE) THEN PRopm_Reload_ProductList (opm_WeAreSearching);
      opm_ListView_Main.Enabled := TRUE;
      opm_Form_Main.FocusControl (opm_ListView_Main);
    END;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PCatClick(Sender: TObject);
VAR
  CurItem : TListItem;
  CurCat : opmR_Category;
  FirstPass, CanContinue : BOOLEAN;
  ProgStep, Progress : LONGINT;
BEGIN
  CurItem := opm_ListView_Main.Selected;
  FirstPass := TRUE;
  CanContinue := TRUE;
  Progress := 0;
  IF (CurItem <> NIL) THEN
    BEGIN
      ProgStep := ROUND (100 / opm_ListView_Main.SelCount);
      opm_ListView_Main.Enabled := FALSE;
      WHILE (CurItem <> NIL) DO
        BEGIN
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, Progress, _('Updating category...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
          opm_CurrentProdRecord := FNopm_GetProductByID (opm_CurrentProdID, opm_CurrentLang, opmG_ProductList);
          IF (FirstPass = TRUE) THEN
            BEGIN
              opm_CurrentCatRecord := FNopm_GetCategory (opmG_CategoryList, opm_CurrentProdRecord.CategoryID, opmC_FindByID);
              opm_Form_AskUser.AU_DataList := opmG_CategoryBoxList;
              IF (opm_ListView_Main.SelCount > 1) THEN
                BEGIN
                  opm_Form_AskUser.AU_Title := _('Change category for products');
                  opm_Form_AskUser.AU_ListItem := opm_CurrentCatRecord.ListIndex;
                END
              ELSE
                BEGIN
                  opm_Form_AskUser.AU_Title := _('Change category for product ') + opm_CurrentProdRecord.DisplayName;
                  opm_Form_AskUser.AU_ListItem := opm_CurrentCatRecord.ListIndex;
                END;
              opm_Form_AskUser.AU_Directions := _('Select the new category:');
              opm_Form_AskUser.AU_TextOrList := FALSE;
              FirstPass := FALSE;
              IF (opm_Form_AskUser.ShowModal = mrOk) THEN CanContinue := TRUE ELSE CanContinue := FALSE;
              CurCat := FNopm_GetCategory (opmG_CategoryList, opm_Form_AskUser.AU_ListItem, opmC_FindByIndex);
            END;
            IF (CanContinue = TRUE) THEN
              PRopm_UpdateProdData (opm_CurrentProdID, opmG_DBTable_ProductsToCategories, 'categories_id', INTTOSTR (CurCat.ID), TRUE, 'categories_id', INTTOSTR (opm_CurrentProdRecord.CategoryID), opmC_SQLUpdate)
{
              IF (opm_CurrentProdRecord.CategoryID > 0) THEN
                BEGIN
                  PRopm_UpdateProdData (opm_CurrentProdID, opmG_DBTable_ProductsToCategories, 'categories_id', INTTOSTR (CurCat.ID), TRUE, 'categories_id', INTTOSTR (opm_CurrentProdRecord.CategoryID), opmC_SQLUpdate);
                END
              ELSE
                BEGIN
                  PRopm_UpdateProdData (opm_CurrentProdID, opmG_DBTable_ProductsToCategories, 'categories_id', INTTOSTR (CurCat.ID), TRUE, '', '', opmC_SQLInsert);
                END
}
             ELSE BREAK;
          CurItem := opm_ListView_Main.GetNextItem (CurItem, sdAll, [isSelected]);
          INC (Progress, ProgStep);
        END;
      IF (CanContinue = TRUE) THEN PRopm_Reload_ProductList (opm_WeAreSearching);
      opm_ListView_Main.Enabled := TRUE;
      opm_Form_Main.FocusControl (opm_ListView_Main);
    END;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_TreeView_MainDragDrop (Sender, Source: TObject; X, Y: Integer);
VAR
  DropNode : TTreeNode;
  CurCat : opmR_Category;
  CurProdR : opmR_Product;
  CurProd : LONGINT;
  CurItem : TListItem;
  FirstPass, CanContinue : BOOLEAN;
  ProgStep, Progress : LONGINT;
begin
  IF ((Source IS TListView) AND (opmG_UIDragDrop > 0) AND (opm_TreeView_Main.Selected <> NIL)) THEN
    BEGIN
      DropNode := opm_TreeView_Main.GetNodeAt (X, Y);
      CurItem := opm_ListView_Main.Selected;
      FirstPass := TRUE;
      CanContinue := TRUE;
      Progress := 0;
      IF ((CurItem <> NIL) AND (DropNode <> NIL)) THEN
        BEGIN
          ProgStep := ROUND (100 / opm_ListView_Main.SelCount);
          opm_ListView_Main.Enabled := FALSE;
          WHILE (CurItem <> NIL) DO
            BEGIN
              PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, Progress, _('Updating category...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
              CurProd := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
              CurProdR := FNopm_GetProductByID (CurProd, opm_CurrentLang, opmG_ProductList);
              CurCat := FNopm_GetCategory (opmG_CategoryList, DropNode.AbsoluteIndex, opmC_FindByNode);
              IF (CurCat.ID < opmC_SC_BaseID) THEN
                BEGIN
                  IF (FirstPass = TRUE) THEN
                    BEGIN
                      IF (opmG_UIConfirmDrag > 0) THEN
                        IF (FNopm_Message (_('Do you want to move these products to category ') + CurCat.Name + '?', mtConfirmation, [mbYes, mbNo], opmG_UISilent) = mrYes) THEN
                          CanContinue := TRUE
                        ELSE
                          CanContinue := FALSE;
                      FirstPass := FALSE;
                    END;
                  IF (CurCat.ID > 0) THEN
                    IF (CanContinue = TRUE) THEN
                      IF (CurProdR.CategoryID > 0) THEN
                        BEGIN
                          PRopm_UpdateProdData (CurProdR.ID, opmG_DBTable_ProductsToCategories, 'categories_id', INTTOSTR (CurCat.ID), TRUE, 'categories_id', INTTOSTR (CurProdR.CategoryID), opmC_SQLUpdate);
                        END
                      ELSE
                        BEGIN
                          PRopm_UpdateProdData (CurProdR.ID, opmG_DBTable_ProductsToCategories, 'categories_id', INTTOSTR (CurCat.ID), TRUE, 'categories_id', INTTOSTR (CurProdR.CategoryID), opmC_SQLDelIns);
                        END
                    ELSE BREAK;
                END;
              CurItem := opm_ListView_Main.GetNextItem (CurItem, sdAll, [isSelected]);
              INC (Progress, ProgStep);
            END;
        END;
      IF (CanContinue = TRUE) THEN PRopm_Reload_ProductList (opm_WeAreSearching);
      opm_ListView_Main.Enabled := TRUE;
      opm_Form_Main.FocusControl (opm_ListView_Main);
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PModelClick(Sender: TObject);
VAR
  CurItem : TListItem;
BEGIN
  CurItem := opm_ListView_Main.Selected;
  IF (CurItem <> NIL) THEN
    BEGIN
      opm_ListView_Main.Enabled := FALSE;
      opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
      opm_CurrentProdRecord := FNopm_GetProductByID (opm_CurrentProdID, opm_CurrentLang, opmG_ProductList);
      opm_Form_AskUser.AU_Title := _('Change model for product ') + opm_CurrentProdRecord.DisplayName;
      opm_Form_AskUser.AU_Directions := _('Type the new model:');
      opm_Form_AskUser.AU_TextOrList := TRUE;
      opm_Form_AskUser.AU_PassChar := #0;
      opm_Form_AskUser.AU_MaxLen := opmC_ProdModel_MaxLen;
      opm_Form_AskUser.AU_DataText := FNopm_CleanString (opm_CurrentProdRecord.Model);
      IF (opm_Form_AskUser.ShowModal = mrOk) THEN
        BEGIN
          PRopm_UpdateProdData (opm_CurrentProdID, opmG_DBTable_Products, 'products_model', FNopm_CleanSQLString (opm_Form_AskUser.AU_DataText, FALSE), FALSE, '', '', opmC_SQLUpdate);
        END;
      PRopm_Reload_ProductList (opm_WeAreSearching);
      opm_ListView_Main.Enabled := TRUE;
      opm_Form_Main.FocusControl (opm_ListView_Main);
    END;
END;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PWeightClick(Sender: TObject);
VAR
  CurItem : TListItem;
  NewWeight : STRING;
BEGIN
  CurItem := opm_ListView_Main.Selected;
  IF (CurItem <> NIL) THEN
    BEGIN
      opm_ListView_Main.Enabled := FALSE;
      opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
      opm_CurrentProdRecord := FNopm_GetProductByID (opm_CurrentProdID, opm_CurrentLang, opmG_ProductList);
      opm_Form_AskUser.AU_Title := _('Change weight for product ') + opm_CurrentProdRecord.DisplayName;
      opm_Form_AskUser.AU_Directions := _('Type the new weight:');
      opm_Form_AskUser.AU_TextOrList := TRUE;
      opm_Form_AskUser.AU_PassChar := #0;
      opm_Form_AskUser.AU_MaxLen := opmC_ProdWeight_MaxLen;
      opm_Form_AskUser.AU_DataText := FLOATTOSTR (opm_CurrentProdRecord.Weight);
      IF (opm_Form_AskUser.ShowModal = mrOk) THEN
        BEGIN
          NewWeight := FNopm_CleanNumber (opm_Form_AskUser.AU_DataText, opmC_ValIsNumOp);
          PRopm_UpdateProdData (opm_CurrentProdID, opmG_DBTable_Products, 'products_weight', FNopm_Apply_Operation (FLOATTOSTR (opm_CurrentProdRecord.Weight), NewWeight, opmC_ValIsFloat, FALSE), TRUE, '', '', opmC_SQLUpdate);
        END;
      PRopm_Reload_ProductList (opm_WeAreSearching);
      opm_ListView_Main.Enabled := TRUE;
      opm_Form_Main.FocusControl (opm_ListView_Main);
    END;
END;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_CatExpandClick(Sender: TObject);
begin
  opm_TreeView_Main.FullExpand;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_CatCollapseClick(Sender: TObject);
begin
  opm_TreeView_Main.FullCollapse;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_CatExpand2Click(Sender: TObject);
begin
  opm_TreeView_Main.Selected.Expanded := TRUE;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_CatCollapse2Click(Sender: TObject);
begin
  opm_TreeView_Main.Selected.Expanded := FALSE;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_TreeView_MainContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
begin
  opm_TreeView_Main.Selected := opm_TreeView_Main.GetNodeAt (MousePos.X, MousePos.Y);
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_TreeView_MainKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  CASE Key OF
    VK_SPACE, VK_RETURN : opm_TreeView_Main.Selected.Expanded := NOT (opm_TreeView_Main.Selected.Expanded);
    VK_DELETE : opm_PopMenuItem_CatDeleteClick (Sender);
    VK_INSERT : opm_PopMenuItem_CatAddClick (Sender);
  END;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_TreeView_MainKeyPress(Sender: TObject; var Key: Char);
begin
  IF ((Key = ' ') OR (Key = #13)) THEN
    Key := #0;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_TreeView_MainDragOver (Sender, Source: TObject;
                                                    X, Y: Integer; State: TDragState;
                                                    var Accept: Boolean);
begin
  IF ((Source IS TListView) AND (opmG_UIDragDrop > 0)) THEN
    BEGIN
      Accept := TRUE;
    END
  ELSE
    BEGIN
      Accept := FALSE;
    END;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_MenuItem_LicenseClick(Sender: TObject);
begin
  opm_Form_License.ShowModal;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_MenuItem_AboutClick(Sender: TObject);
begin
  opm_Form_About.ShowModal;
{$IFDEF OSCPMDEBUG}
  FNopm_Message (_('THIS IS A SPECIAL DEBUG-VERSION. Use it only to report crashes and fatal errors. DO NOT DISTRIBUTE. The full open-source version can be found in the website.'), mtInformation, [mbOk], opmG_UISilent);
{$ENDIF}
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_HideDebugClick(Sender: TObject);
begin
  opmG_UIDBDebug := 0;
  PRReg_WriteSetting ('OSCDBDebug', INTTOSTR (opmG_UIDBDebug), opmC_RegistryKey, opmC_RKConfig);
  opm_DataSource_DEBUG.Enabled := FALSE;
  opm_DBGrid_DEBUG.Enabled := FALSE;
  opm_DBGrid_DEBUG.Visible := FALSE;
  opm_Panel_DEBUG.Visible := FALSE;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  IF (opmG_UIConfirmExit > 0) THEN
    BEGIN
      IF (FNopm_Message (_('Do you really want to quit the ') + opmC_AppName1 +'?', mtConfirmation, [mbYes, mbNo], opmG_UISilent) = mrYes) THEN
        BEGIN
          Application.HelpCommand (HELP_QUIT, 0);
          Action := caFree;
          FNopm_CloseDBConnection;
          PRopm_CloseSSHTunnel;
          PRopm_SaveConfiguration;
        END
      ELSE
        Action := caNone;
    END
  ELSE
    BEGIN
      FNopm_CloseDBConnection;
      PRopm_CloseSSHTunnel;
      PRopm_SaveConfiguration;
    END;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_TreeView_MainDblClick(Sender: TObject);
begin
  IF (opm_CurrentCatRecord.ID < opmC_SC_BaseID) THEN
    IF (opmG_UIClickLoad <= 0) THEN
      BEGIN
        PRopm_LoadProductListByCat (opm_CurrentCategory, opmG_ProductList, opmG_DescriptionList);
        PRopm_RenderProductDisplay (opmG_CategoryList, opmG_ManufacturerList, opmG_ProductList, opm_ListView_Main, opm_CurrentProdID);
        PRopm_Valid_CatOps (opm_WeAreConnected, opm_TreeView_Main.Selected);
        PRopm_Valid_ProdOps (opm_WeAreConnected, opm_ListView_Main.Selected, opm_ListView_Main.SelCount, opm_TreeView_Main.Selected);
      END;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_TreeView_MainExpanding(Sender: TObject; Node: TTreeNode; var AllowExpansion: Boolean);
begin
  AllowExpansion := opm_CanExpandTree_Flag;
  opm_CanExpandTree_Flag := TRUE;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_TreeView_MainCollapsing(Sender: TObject; Node: TTreeNode; var AllowCollapse: Boolean);
begin
  AllowCollapse := opm_CanExpandTree_Flag;
  opm_CanExpandTree_Flag := TRUE;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_SetUILang (LangISOID : STRING);
BEGIN
  IF (FNopm_CheckLanguage (LangISOID) = FALSE) THEN LangISOID := opmC_Def_GUILang;
  UseLanguage(LangISOID);
  TranslateComponent (opm_Form_Main);
  TranslateComponent (opm_Form_License);
  TranslateComponent (opm_Form_About);
  TranslateComponent (opm_Form_PEdit);
  TranslateComponent (opm_Form_ImageZoom);
  TranslateComponent (opm_Form_SearchProduct);
  TranslateComponent (opm_Form_UploadImage);
  TranslateComponent (opm_Form_AskUser);
  TranslateComponent (opm_Form_Config);
  TranslateComponent (opm_Form_Runmod);
  TranslateComponent (opm_Form_Colorsel);
  PRballoon_DestroyAllBalloons;
  PRballoon_SetFormBalloons (opm_Form_Main, opmG_UIToolTips);
  PRballoon_SetFormBalloons (opm_Form_License, opmG_UIToolTips);
  PRballoon_SetFormBalloons (opm_Form_About, opmG_UIToolTips);
  PRballoon_SetFormBalloons (opm_Form_PEdit, opmG_UIToolTips);
  PRballoon_SetFormBalloons (opm_Form_ImageZoom, opmG_UIToolTips);
  PRballoon_SetFormBalloons (opm_Form_SearchProduct, opmG_UIToolTips);
  PRballoon_SetFormBalloons (opm_Form_UploadImage, opmG_UIToolTips);
  PRballoon_SetFormBalloons (opm_Form_AskUser, opmG_UIToolTips);
  PRballoon_SetFormBalloons (opm_Form_Config, opmG_UIToolTips);
  PRballoon_SetFormBalloons (opm_Form_Runmod, opmG_UIToolTips);
  PRballoon_SetFormBalloons (opm_Form_Colorsel, opmG_UIToolTips);
END;




{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PDeleteClick(Sender: TObject);
VAR
  CurItem : TListItem;
  ProgStep, Progress : LONGINT;
BEGIN
  CurItem := opm_ListView_Main.Selected;
  Progress := 0;
  IF (CurItem <> NIL) THEN
    BEGIN
      ProgStep := ROUND (100 / opm_ListView_Main.SelCount);
      opm_ListView_Main.Enabled := FALSE;
      WHILE (CurItem <> NIL) DO
        BEGIN
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressIgnore, Progress, _('Deleting product...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
          PRopm_DeleteProduct (opm_CurrentProdID);
          CurItem := opm_ListView_Main.GetNextItem (CurItem, sdAll, [isSelected]);
          INC (Progress, ProgStep);
        END;
      PRopm_Reload_ProductList (opm_WeAreSearching);
      opm_ListView_Main.Enabled := TRUE;
      opm_Form_Main.FocusControl (opm_ListView_Main);
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PAddClick(Sender: TObject);
VAR
  CurLang : LONGINT;
begin
  opm_CurrentPEditRecord.ID := 0;
  opm_CurrentPEditRecord.Model := '';
  opm_CurrentPEditRecord.Quantity := 0;
  opm_CurrentPEditRecord.Price := 0;
  opm_CurrentPEditRecord.Weight := 0;
  opm_CurrentPEditRecord.ManufacturerID := opmG_Past_PManufacturer;
  opm_CurrentPEditRecord.CategoryID := opm_CurrentCategory;
  opm_CurrentPEditRecord.DisplayName := '';
  opm_CurrentPEditRecord.Available := 1;
  opm_CurrentPEditRecord.ImageURL := '';
  opm_CurrentPEditRecord.Special := 0;
  opm_CurrentPEditRecord.LanguageID := opm_CurrentLang;
  opm_CurrentPEditRecord.Tax := opmG_Past_PTaxClass;
  opm_CurrentPEditRecord.AvailDate := opmG_Past_PAvailDate;
  opm_CurrentPEditRecord.CreationDate := opmG_Past_PAvailDate;
  opm_CurrentPEditRecord.ChangeDate := opmG_Past_PAvailDate;
  opm_CurrentProdRecord := opm_CurrentPEditRecord;
  FOR CurLang := 0 TO (opm_TotalLanguages - 1) DO
    BEGIN
      opm_CurrentSingleDescList[CurLang].ID := opmC_InsertProdID;
      opm_CurrentSingleDescList[CurLang].Name := '';
      opm_CurrentSingleDescList[CurLang].Description := '';
      opm_CurrentSingleDescList[CurLang].URL := '';
      opm_CurrentSingleDescList[CurLang].LanguageID := opmG_LanguageList[CurLang].ID;
      opm_CurrentSingleDescList[CurLang].Viewed := 0;
    END;
  FOR CurLang := opm_TotalLanguages TO opmC_Max_Languages_PerList DO
    BEGIN
      opm_CurrentSingleDescList[CurLang].ID := 0;
      opm_CurrentSingleDescList[CurLang].Name := '';
      opm_CurrentSingleDescList[CurLang].Description := '';
      opm_CurrentSingleDescList[CurLang].URL := '';
      opm_CurrentSingleDescList[CurLang].LanguageID := 0;
      opm_CurrentSingleDescList[CurLang].Viewed := 0;
    END;
  IF (opm_Form_PEdit.ShowModal = mrOk) THEN
    BEGIN
      PRopm_AddProduct (opm_CurrentPEditRecord, opm_CurrentSingleDescList);
      opmG_Past_PAvailDate := ROUND (opm_CurrentPEditRecord.AvailDate);
      opmG_Past_PManufacturer := opm_CurrentPEditRecord.ManufacturerID;
      opmG_Past_PTaxClass := opm_CurrentPEditRecord.Tax;
    END;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_Create_ExportList (VAR ExportString : STRING; VAR CatList : opmT_CategoryList; VAR ManList : opmT_ManufacturerList; JustifyCols : BOOLEAN);
VAR
  CurItem : TListItem;
  ExportLine : STRING;
  CurProd : opmR_Product;
  CurCat : opmR_Category;
  CurMan : opmR_Manufacturer;
  MaxWidths : ARRAY [0..20] OF LONGINT;
  FmtString : ARRAY [0..20] OF STRING;
BEGIN
  ExportString := '';
  opm_ListView_Main.Enabled := FALSE;
  IF (JustifyCols = TRUE) THEN
    BEGIN
      CurItem := opm_ListView_Main.Selected;
      WHILE (CurItem <> NIL) DO
        BEGIN
          opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
          CurProd := FNopm_GetProductByID (opm_CurrentProdID, opm_CurrentLang, opmG_ProductList);
          CurCat := FNopm_GetCategory (CatList, CurProd.CategoryID, opmC_FindByID);
          CurMan := FNopm_GetManufacturer (ManList, CurProd.ManufacturerID, opmC_FindByID);
          MaxWidths [0] := MAX (LENGTH (INTTOSTR (CurProd.ID)), MaxWidths [0]);
          MaxWidths [1] := MAX (LENGTH (FNopm_NumToYesNo (CurProd.Available)), MaxWidths [1]);
          MaxWidths [2] := MAX (LENGTH (FNopm_CleanString (CurProd.Model)), MaxWidths [2]);
          MaxWidths [3] := MAX (LENGTH (INTTOSTR (CurProd.CategoryID)), MaxWidths [3]);
          MaxWidths [4] := MAX (LENGTH (FNopm_CleanString (CurCat.Name)), MaxWidths [4]);
          MaxWidths [5] := MAX (LENGTH (INTTOSTR (CurProd.ManufacturerID)), MaxWidths [5]);
          MaxWidths [6] := MAX (LENGTH (FNopm_CleanString (CurMan.Name)), MaxWidths [6]);
          MaxWidths [7] := MAX (LENGTH (FNopm_CleanString (CurProd.DisplayName)), MaxWidths [7]);
          MaxWidths [8] := MAX (LENGTH (INTTOSTR (CurProd.Quantity)), MaxWidths [8]);
          MaxWidths [9] := MAX (LENGTH (FNopm_CleanNumber (CURRTOSTR (CurProd.Price), opmC_ValIsFloat)), MaxWidths [9]);
          MaxWidths [10] := MAX (LENGTH (FNopm_CleanNumber (CURRTOSTR (CurProd.Special), opmC_ValIsFloat)), MaxWidths [10]);
          MaxWidths [11] := MAX (LENGTH (FNopm_CleanNumber (CURRTOSTR (CurProd.Weight), opmC_ValIsFloat)), MaxWidths [11]);
          CurItem := opm_ListView_Main.GetNextItem (CurItem, sdAll, [isSelected]);
        END;
      MaxWidths [0] := MIN (opmG_Clip_ColSize, MaxWidths [0]);
      MaxWidths [1] := MIN (opmG_Clip_ColSize, MaxWidths [1]);
      MaxWidths [2] := MIN (opmG_Clip_ColSize, MaxWidths [2]);
      MaxWidths [3] := MIN (opmG_Clip_ColSize, MaxWidths [3]);
      MaxWidths [4] := MIN (opmG_Clip_ColSize, MaxWidths [4]);
      MaxWidths [5] := MIN (opmG_Clip_ColSize, MaxWidths [5]);
      MaxWidths [6] := MIN (opmG_Clip_ColSize, MaxWidths [6]);
      MaxWidths [7] := MIN (opmG_Clip_ColSize, MaxWidths [7]);
      MaxWidths [8] := MIN (opmG_Clip_ColSize, MaxWidths [8]);
      MaxWidths [9] := MIN (opmG_Clip_ColSize, MaxWidths [9]);
      MaxWidths [10] := MIN (opmG_Clip_ColSize, MaxWidths [10]);
      MaxWidths [11] := MIN (opmG_Clip_ColSize, MaxWidths [11]);
      FmtString [0] := '%' + INTTOSTR (MaxWidths [0]) + '.' + INTTOSTR (MaxWidths [0]) + 's' + opmC_ExportJSeparator;
      FmtString [1] := '%-' + INTTOSTR (MaxWidths [1]) + '.' + INTTOSTR (MaxWidths [1]) + 's' + opmC_ExportJSeparator;
      FmtString [2] := '%-' + INTTOSTR (MaxWidths [2]) + '.' + INTTOSTR (MaxWidths [2]) + 's' + opmC_ExportJSeparator;
      FmtString [3] := '%' + INTTOSTR (MaxWidths [3]) + '.' + INTTOSTR (MaxWidths [3]) + 's' + opmC_ExportJSeparator;
      FmtString [4] := '%-' + INTTOSTR (MaxWidths [4]) + '.' + INTTOSTR (MaxWidths [4]) + 's' + opmC_ExportJSeparator;
      FmtString [5] := '%' + INTTOSTR (MaxWidths [5]) + '.' + INTTOSTR (MaxWidths [5]) + 's' + opmC_ExportJSeparator;
      FmtString [6] := '%-' + INTTOSTR (MaxWidths [6]) + '.' + INTTOSTR (MaxWidths [6]) + 's' + opmC_ExportJSeparator;
      FmtString [7] := '%-' + INTTOSTR (MaxWidths [7]) + '.' + INTTOSTR (MaxWidths [7]) + 's' + opmC_ExportJSeparator;
      FmtString [8] := '%' + INTTOSTR (MaxWidths [8]) + '.' + INTTOSTR (MaxWidths [8]) + 's' + opmC_ExportJSeparator;
      FmtString [9] := '%' + INTTOSTR (MaxWidths [9]) + '.' + INTTOSTR (MaxWidths [9]) + 's' + opmC_ExportJSeparator;
      FmtString [10] := '%' + INTTOSTR (MaxWidths [10]) + '.' + INTTOSTR (MaxWidths [10]) + 's' + opmC_ExportJSeparator;
      FmtString [11] := '%' + INTTOSTR (MaxWidths [11]) + '.' + INTTOSTR (MaxWidths [11]) + 's' + opmC_ExportJSeparator;
    END;
  CurItem := opm_ListView_Main.Selected;
  IF (CurItem <> NIL) THEN
    BEGIN
      ExportLine := '';
      IF (JustifyCols = TRUE) THEN
        BEGIN
          ExportLine := ExportLine + FORMAT (FmtString [0], [_('Product ID')]);
          ExportLine := ExportLine + FORMAT (FmtString [1], [_('Available')]);
          ExportLine := ExportLine + FORMAT (FmtString [2], [_('Model')]);
          ExportLine := ExportLine + FORMAT (FmtString [3], [_('Category ID')]);
          ExportLine := ExportLine + FORMAT (FmtString [4], [_('Category name')]);
          ExportLine := ExportLine + FORMAT (FmtString [5], [_('Manufacturer ID')]);
          ExportLine := ExportLine + FORMAT (FmtString [6], [_('Manufacturer name')]);
          ExportLine := ExportLine + FORMAT (FmtString [7], [_('Product name')]);
          ExportLine := ExportLine + FORMAT (FmtString [8], [_('Quantity')]);
          ExportLine := ExportLine + FORMAT (FmtString [9], [_('Price')]);
          ExportLine := ExportLine + FORMAT (FmtString [10], [_('Special price')]);
          ExportLine := ExportLine + FORMAT (FmtString [11], [_('Weight')]);
          ExportString := ExportString + opmC_ExportJSeparator + ExportLine + #13#10;
          ExportString := ExportString + DUPESTRING (opmC_ExportJHSeparator, LENGTH (opmC_ExportJSeparator + ExportLine)) + #13#10;
        END
      ELSE
        BEGIN
          ExportLine := ExportLine + _('Product ID') + opmC_ExportSeparator;
          ExportLine := ExportLine + _('Available') + opmC_ExportSeparator;
          ExportLine := ExportLine + _('Model') + opmC_ExportSeparator;
          ExportLine := ExportLine + _('Category ID') + opmC_ExportSeparator;
          ExportLine := ExportLine + _('Category name') + opmC_ExportSeparator;
          ExportLine := ExportLine + _('Manufacturer ID') + opmC_ExportSeparator;
          ExportLine := ExportLine + _('Manufacturer name') + opmC_ExportSeparator;
          ExportLine := ExportLine + _('Product name') + opmC_ExportSeparator;
          ExportLine := ExportLine + _('Quantity') + opmC_ExportSeparator;
          ExportLine := ExportLine + _('Price') + opmC_ExportSeparator;
          ExportLine := ExportLine + _('Special price') + opmC_ExportSeparator;
          ExportLine := ExportLine + _('Weight') + opmC_ExportSeparator;
          ExportString := ExportString + ExportLine + #13#10;
        END;
      ExportLine := '';
      WHILE (CurItem <> NIL) DO
        BEGIN
          IF (JustifyCols = TRUE) THEN
            BEGIN
              opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
              CurProd := FNopm_GetProductByID (opm_CurrentProdID, opm_CurrentLang, opmG_ProductList);
              CurCat := FNopm_GetCategory (CatList, CurProd.CategoryID, opmC_FindByID);
              CurMan := FNopm_GetManufacturer (ManList, CurProd.ManufacturerID, opmC_FindByID);
              ExportLine := ExportLine + FORMAT (FmtString [0], [INTTOSTR (CurProd.ID)]);
              ExportLine := ExportLine + FORMAT (FmtString [1], [FNopm_NumToYesNo (CurProd.Available)]);
              ExportLine := ExportLine + FORMAT (FmtString [2], [FNopm_CleanString (CurProd.Model)]);
              ExportLine := ExportLine + FORMAT (FmtString [3], [INTTOSTR (CurProd.CategoryID)]);
              ExportLine := ExportLine + FORMAT (FmtString [4], [FNopm_CleanString (CurCat.Name)]);
              ExportLine := ExportLine + FORMAT (FmtString [5], [INTTOSTR (CurProd.ManufacturerID)]);
              ExportLine := ExportLine + FORMAT (FmtString [6], [FNopm_CleanString (CurMan.Name)]);
              ExportLine := ExportLine + FORMAT (FmtString [7], [FNopm_CleanString (CurProd.DisplayName)]);
              ExportLine := ExportLine + FORMAT (FmtString [8], [INTTOSTR (CurProd.Quantity)]);
              ExportLine := ExportLine + FORMAT (FmtString [9], [FNopm_CleanNumber (CURRTOSTR (CurProd.Price), opmC_ValIsFloat)]);
              ExportLine := ExportLine + FORMAT (FmtString [10], [FNopm_CleanNumber (CURRTOSTR (CurProd.Special), opmC_ValIsFloat)]);
              ExportLine := ExportLine + FORMAT (FmtString [11], [FNopm_CleanNumber (CURRTOSTR (CurProd.Weight), opmC_ValIsFloat)]);
              ExportString := ExportString + opmC_ExportJSeparator + ExportLine + #13#10;
            END
          ELSE
            BEGIN
              opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
              CurProd := FNopm_GetProductByID (opm_CurrentProdID, opm_CurrentLang, opmG_ProductList);
              CurCat := FNopm_GetCategory (CatList, CurProd.CategoryID, opmC_FindByID);
              CurMan := FNopm_GetManufacturer (ManList, CurProd.ManufacturerID, opmC_FindByID);
              ExportLine := ExportLine + INTTOSTR (CurProd.ID) + opmC_ExportSeparator;
              ExportLine := ExportLine + INTTOSTR (CurProd.Available) + opmC_ExportSeparator;
              ExportLine := ExportLine + FNopm_CleanString (CurProd.Model) + opmC_ExportSeparator;
              ExportLine := ExportLine + INTTOSTR (CurProd.CategoryID) + opmC_ExportSeparator;
              ExportLine := ExportLine + FNopm_CleanString (CurCat.Name) + opmC_ExportSeparator;
              ExportLine := ExportLine + INTTOSTR (CurProd.ManufacturerID) + opmC_ExportSeparator;
              ExportLine := ExportLine + FNopm_CleanString (CurMan.Name) + opmC_ExportSeparator;
              ExportLine := ExportLine + FNopm_CleanString (CurProd.DisplayName) + opmC_ExportSeparator;
              ExportLine := ExportLine + INTTOSTR (CurProd.Quantity) + opmC_ExportSeparator;
              ExportLine := ExportLine + FNopm_CleanNumber (CURRTOSTR (CurProd.Price), opmC_ValIsFloat) + opmC_ExportSeparator;
              ExportLine := ExportLine + FNopm_CleanNumber (CURRTOSTR (CurProd.Special), opmC_ValIsFloat) + opmC_ExportSeparator;
              ExportLine := ExportLine + FNopm_CleanNumber (CURRTOSTR (CurProd.Weight), opmC_ValIsFloat) + opmC_ExportSeparator;
              ExportString := ExportString + ExportLine + #13#10;
            END;
          CurItem := opm_ListView_Main.GetNextItem (CurItem, sdAll, [isSelected]);
          ExportLine := '';
        END;
    END;
  opm_ListView_Main.Enabled := TRUE;
  opm_Form_Main.FocusControl (opm_ListView_Main);
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PExportClick(Sender: TObject);
VAR
  ExportFile : TEXTFILE;
  ExportText : STRING;
BEGIN
    opm_SaveDialog_Export.DefaultExt := opmC_Def_ExportExt;
    opm_SaveDialog_Export.FileName := opmC_Def_ExportFilename;
    opm_SaveDialog_Export.Filter := _('Text record files') + ' (' + opmC_Def_ExportFilter + ')|' + opmC_Def_ExportFilter + '|' + _('All files (*.*)');
    opm_SaveDialog_Export.Title := _('Exporting product list...');
    IF (opm_SaveDialog_Export.Execute = TRUE) THEN
      BEGIN
        PRopm_Create_ExportList (ExportText, opmG_CategoryList, opmG_ManufacturerList, FALSE);
        TRY
          AssignFile (ExportFile, opm_SaveDialog_Export.FileName);
          Rewrite (ExportFile);
          WRITELN (ExportFile, ExportText);
          CloseFile (ExportFile);
        EXCEPT
          ON E : Exception DO
            BEGIN
              FNopm_Message (_('Error while exporting product list') + #13#10 + opm_SaveDialog_Export.FileName + #13#10 + E.Message, mtError, [mbOk], opmG_UISilent);
            END;
        END;
        SHAddToRecentDocs (SHARD_PATH, PCHAR (opm_SaveDialog_Export.FileName));
      END;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PCopyAsTextClick(Sender: TObject);
VAR
  ExportText : STRING;
BEGIN
  PRopm_Create_ExportList (ExportText, opmG_CategoryList, opmG_ManufacturerList, FALSE);
  Clipboard.AsText := ExportText;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PCopyAsPreClick(Sender: TObject);
VAR
  ExportText : STRING;
BEGIN
  PRopm_Create_ExportList (ExportText, opmG_CategoryList, opmG_ManufacturerList, TRUE);
  Clipboard.AsText := ExportText;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PSelAllClick(Sender: TObject);
begin
  opm_ListView_Main.SelectAll;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
FUNCTION Topm_Form_Main.FNopm_Create_ExchangeList (VAR ExchangeList : opmT_ExchangeList;
                                                   IndexData, TargetData : STRING) : LONGINT;
VAR
  CurItem : TListItem;
  CurProd : opmR_Product;
  ProdCount : LONGINT;
BEGIN
  CurItem := opm_ListView_Main.Selected;
  ProdCount := 0;
  IF (CurItem <> NIL) THEN
    BEGIN
      opm_ListView_Main.Enabled := FALSE;
      WHILE (CurItem <> NIL) DO
        BEGIN
          opm_CurrentProdID := STRTOINT (TRIM (CurItem.SubItems.Strings[0]));
          CurProd := FNopm_GetProductByID (opm_CurrentProdID, opm_CurrentLang, opmG_ProductList);
          IF (IndexData = opmC_SyncField_ProductID) THEN
            ExchangeList[ProdCount].IndexString := INTTOSTR (CurProd.ID)
          ELSE
            ExchangeList[ProdCount].IndexString := CurProd.Model;
          IF (TargetData = opmC_SyncField_ProductQuantity) THEN
            ExchangeList[ProdCount].CurrentString := INTTOSTR (CurProd.Quantity)
          ELSE IF (TargetData = opmC_SyncField_ProductPrice) THEN
            ExchangeList[ProdCount].CurrentString := CURRTOSTR (CurProd.Price)
          ELSE IF (TargetData = opmC_SyncField_ProductImage) THEN
            ExchangeList[ProdCount].CurrentString := CurProd.ImageURL
          ELSE IF (TargetData = opmC_SyncField_ProductWeight) THEN
            ExchangeList[ProdCount].CurrentString := FLOATTOSTR (CurProd.Weight)
          ELSE IF (TargetData = opmC_SyncField_ProductStatus) THEN
            ExchangeList[ProdCount].CurrentString := INTTOSTR (CurProd.Available)
          ELSE ExchangeList[ProdCount].CurrentString := '';
          ExchangeList[ProdCount].ResultString := '';
          CurItem := opm_ListView_Main.GetNextItem (CurItem, sdAll, [isSelected]);
          INC (ProdCount);
        END;
      opm_ListView_Main.Enabled := TRUE;
      opm_Form_Main.FocusControl (opm_ListView_Main);
    END;
  FNopm_Create_ExchangeList := ProdCount;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_MenuItem_ExternalModulesClick (Sender: TObject);
begin
  opm_PRSetValidModules (opm_MenuItem_ExternalModules, opm_ListView_Main.SelCount);
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_TreeView_MainMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
end;




{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
FUNCTION FNopm_Sort_ProductList (Item1, Item2: TListItem; Column: INTEGER) : INTEGER; STDCALL;
BEGIN
  CASE Column OF
  1, 6, 7, 8 :
    IF (opmG_PList_LastOrderType = FALSE) THEN
      FNopm_Sort_ProductList := ROUND ((STRTOFLOAT (Item1.SubItems[Column - 1]) - STRTOFLOAT (Item2.SubItems[Column - 1])))
    ELSE
      FNopm_Sort_ProductList := ROUND ((STRTOFLOAT (Item1.SubItems[Column - 1]) - STRTOFLOAT (Item2.SubItems[Column - 1])) * -1);
  0 :
    IF (opmG_PList_LastOrderType = FALSE) THEN
      FNopm_Sort_ProductList := ROUND ((Item1.ImageIndex - Item2.ImageIndex))
    ELSE
      FNopm_Sort_ProductList := ROUND ((Item1.ImageIndex - Item2.ImageIndex) * -1);
  ELSE
    IF (opmG_PList_LastOrderType = FALSE) THEN
      FNopm_Sort_ProductList := AnsiCompareText (Item1.SubItems[Column - 1], Item2.SubItems[Column - 1])
    ELSE
      FNopm_Sort_ProductList := ((AnsiCompareText (Item1.SubItems[Column - 1], Item2.SubItems[Column - 1])) * -1);
  END;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_ListView_MainColumnClick(Sender: TObject; Column: TListColumn);
begin
  IF (Column.Index >= 0) AND (Column.Index < 10) THEN
    BEGIN
      opm_ListView_Main.Column[opmG_PList_LastOrderColumn].ImageIndex := -1;
      IF (opmG_PList_LastOrderColumn = Column.Index) THEN
        opmG_PList_LastOrderType := NOT (opmG_PList_LastOrderType)
      ELSE
        opmG_PList_LastOrderType := FALSE;
      IF (opmG_PList_LastOrderType = TRUE) THEN
        Column.ImageIndex := 8
      ELSE
        Column.ImageIndex := 9;
      opmG_PList_LastOrderColumn := Column.Index;
      TListView (Sender).CustomSort (@FNopm_Sort_ProductList, Column.Index);
    END;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_PPrintClick(Sender: TObject);
BEGIN
  opmG_Cur_PPrintEOF := FALSE;
  opmG_Cur_PPrintTitle := opmC_AppName1 + ' ' + opmC_AppName2 + ' (' + opmC_AppShortName + ') ' + opmC_Version + ' (build ' + opmG_ExeBuildVersion + ')';
  opmG_Cur_PPrintTitle2 := DATETIMETOSTR (NOW) + ' ' + opmG_DBHost + ' / ' + opmG_DBDatabase;
  TRY
    opm_frReport_ProdList.LoadFromFile (ExtractFilePath (Application.Exename) + opmC_DirReports + '/' + opmC_Report_ProdList1);
    IF (opmG_PRNDirectPrint > 0) THEN
      BEGIN
        opm_frReport_ProdList.PrepareReport;
        opm_frReport_ProdList.PrintPreparedReport('', 1);
      END
    ELSE opm_frReport_ProdList.ShowReport;
  EXCEPT
    ON E : Exception DO
      BEGIN
        FNopm_Message (_('Error while printing product list') + #13#10 + E.Message, mtError, [mbOk], opmG_UISilent);
      END;
  END;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_frReport_ProdListGetValue (const ParName: String; var ParValue: Variant);
VAR
  CurCat : opmR_Category;
  CurMan : opmR_Manufacturer;
  CurDescR : opmR_Description;
begin
  IF (ParName = 'RepTitle') THEN ParValue := opmG_Cur_PPrintTitle
  ELSE IF (ParName = 'RepSubtitle') THEN ParValue := opmG_Cur_PPrintTitle2
  ELSE IF (ParName = 'RepHeadID') THEN ParValue := _('Product ID')
  ELSE IF (ParName = 'RepHeadAvailable') THEN ParValue := _('Available')
  ELSE IF (ParName = 'RepHeadModel') THEN ParValue := _('Model')
  ELSE IF (ParName = 'RepHeadCategory') THEN ParValue := _('Category name')
  ELSE IF (ParName = 'RepHeadManufacturer') THEN ParValue := _('Manufacturer name')
  ELSE IF (ParName = 'RepHeadName') THEN ParValue := _('Product name')
  ELSE IF (ParName = 'RepHeadQuantity') THEN ParValue := _('Quantity')
  ELSE IF (ParName = 'RepHeadPrice') THEN ParValue := _('Price')
  ELSE IF (ParName = 'RepHeadSpecial') THEN ParValue := _('Special price')
  ELSE IF (ParName = 'RepHeadWeight') THEN ParValue := _('Weight')
  ELSE IF (ParName = 'RepHeadImage') THEN ParValue := _('URL')
  ELSE IF (ParName = 'RepHeadTax') THEN ParValue := _('Weight')
  ELSE IF (ParName = 'RepHeadAvailDate') THEN ParValue := _('Availability date')
  ELSE IF (ParName = 'RepHeadCreatDate') THEN ParValue := _('Creation date')
  ELSE IF (ParName = 'RepHeadChangeDate') THEN ParValue := _('Change date')
  ELSE IF (ParName = 'RepHeadDescription') THEN ParValue := _('Description')
  ELSE IF (ParName = 'RepHeadURL') THEN ParValue := _('URL')
  ELSE IF (ParName = 'RepHeadViewed') THEN ParValue := _('Times viewed')
  ELSE IF (ParName = 'ProdID') THEN ParValue := opmG_Cur_PPrintRecord.ID
  ELSE IF (ParName = 'ProdAvailable') THEN ParValue := FNopm_NumToYesNo (opmG_Cur_PPrintRecord.Available)
  ELSE IF (ParName = 'ProdModel') THEN ParValue := opmG_Cur_PPrintRecord.Model
  ELSE IF (ParName = 'ProdCategory') THEN
         BEGIN
           CurCat := FNopm_GetCategory (opmG_CategoryList, opmG_Cur_PPrintRecord.CategoryID, opmC_FindByID);
           ParValue := CurCat.Name;
         END
  ELSE IF (ParName = 'ProdManufacturer') THEN
         BEGIN
           CurMan := FNopm_GetManufacturer (opmG_ManufacturerList, opmG_Cur_PPrintRecord.ManufacturerID, opmC_FindByID);
           ParValue := CurMan.Name;
         END
  ELSE IF (ParName = 'ProdName') THEN ParValue := opmG_Cur_PPrintRecord.DisplayName
  ELSE IF (ParName = 'ProdQuantity') THEN ParValue := opmG_Cur_PPrintRecord.Quantity
  ELSE IF (ParName = 'ProdPrice') THEN ParValue := opmG_Cur_PPrintRecord.Price
  ELSE IF (ParName = 'ProdSpecial') THEN ParValue := opmG_Cur_PPrintRecord.Special
  ELSE IF (ParName = 'ProdWeight') THEN ParValue := opmG_Cur_PPrintRecord.Weight
  ELSE IF (ParName = 'ProdImage') THEN ParValue := opmG_Cur_PPrintRecord.ImageURL
  ELSE IF (ParName = 'ProdTax') THEN ParValue := opmG_Cur_PPrintRecord.Tax
  ELSE IF (ParName = 'ProdAvailDate') THEN ParValue := DATETIMETOSTR (opmG_Cur_PPrintRecord.AvailDate)
  ELSE IF (ParName = 'ProdCreatDate') THEN ParValue := DATETIMETOSTR (opmG_Cur_PPrintRecord.CreationDate)
  ELSE IF (ParName = 'ProdChangeDate') THEN ParValue := DATETIMETOSTR (opmG_Cur_PPrintRecord.ChangeDate)
  ELSE IF (ParName = 'ProdDescription') THEN
         BEGIN
           CurDescR := FNopm_GetDescriptionByID (opmG_Cur_PPrintRecord.ID, opm_CurrentLang, opmG_DescriptionList);
           ParValue := CurDescR.Description;
         END
  ELSE IF (ParName = 'ProdURL') THEN
         BEGIN
           CurDescR := FNopm_GetDescriptionByID (opmG_Cur_PPrintRecord.ID, opm_CurrentLang, opmG_DescriptionList);
           ParValue := CurDescR.URL;
         END
  ELSE IF (ParName = 'ProdViewed') THEN
         BEGIN
           CurDescR := FNopm_GetDescriptionByID (opmG_Cur_PPrintRecord.ID, opm_CurrentLang, opmG_DescriptionList);
           ParValue := CurDescR.Viewed;
         END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_frUserDataset_ProdListCheckEOF(Sender: TObject; var Eof: Boolean);
begin
  EOF := opmG_Cur_PPrintEOF;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_frUserDataset_ProdListFirst(Sender: TObject);
BEGIN
  opmG_Cur_PPrintEOF := FALSE;
  opmG_Cur_PrintListItem := opm_ListView_Main.Selected;
  IF (opmG_Cur_PrintListItem <> NIL) THEN
    BEGIN
      opmG_Cur_PPrintID := STRTOINT (TRIM (opmG_Cur_PrintListItem.SubItems.Strings[0]));
      opmG_Cur_PPrintRecord := FNopm_GetProductByID (opmG_Cur_PPrintID, opm_CurrentLang, opmG_ProductList);
    END
  ELSE opmG_Cur_PPrintEOF := TRUE;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_frUserDataset_ProdListNext(Sender: TObject);
begin
  opmG_Cur_PrintListItem := opm_ListView_Main.GetNextItem (opmG_Cur_PrintListItem, sdAll, [isSelected]);
  IF (opmG_Cur_PrintListItem <> NIL) THEN
    BEGIN
      opmG_Cur_PPrintID := STRTOINT (TRIM (opmG_Cur_PrintListItem.SubItems.Strings[0]));
      opmG_Cur_PPrintRecord := FNopm_GetProductByID (opmG_Cur_PPrintID, opm_CurrentLang, opmG_ProductList);
    END
  ELSE opmG_Cur_PPrintEOF := TRUE;
end;


procedure Topm_Form_Main.FormShow(Sender: TObject);
begin
{$IFDEF OSCPMDEBUG}
  FNopm_Message (_('THIS IS A SPECIAL DEBUG-VERSION. Use it only to report crashes and fatal errors. DO NOT DISTRIBUTE. The full open-source version can be found in the website.'), mtInformation, [mbOk], opmG_UISilent);
{$ENDIF}
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_CatDeleteClick (Sender: TObject);
begin
  IF ((opm_CurrentCategory > 0) AND (opm_CurrentCatRecord.ID < opmC_SC_BaseID)) THEN
    BEGIN
      PRopm_DeleteCategory (opm_CurrentCategory);
    END;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_CatAddClick(Sender: TObject);
VAR
  CatParent : LONGINT;
begin
  IF ((opm_CurrentCategory >= 0) AND (opm_CurrentCatRecord.ID < opmC_SC_BaseID)) THEN
    BEGIN
      CatParent := opm_CurrentCatRecord.ID;
      opm_Form_AskCat.AC_Title := _('Add new category');
      opm_Form_AskCat.AC_Directions := _('Enter the name of the new category and its translations.');
      opm_Form_AskCat.AC_MaxLen := opmC_CatName_MaxLen;
      opm_Form_AskCat.AC_ClearCats := TRUE;
      IF (opm_Form_AskCat.ShowModal = mrOk) THEN PRopm_AddCategory (opm_Form_AskCat.AC_CategoryData, opm_TotalLanguages, CatParent);
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_PopMenuItem_CatRenameClick (Sender: TObject);
begin
  IF ((opm_CurrentCategory > 0) AND (opm_CurrentCatRecord.ID < opmC_SC_BaseID)) THEN
    BEGIN
    opm_Form_AskCat.AC_Title := _('Rename category') + ' ' + opm_CurrentCatRecord.Name;
    opm_Form_AskCat.AC_Directions := _('Enter the new name of the category and its translations.');
    opm_Form_AskCat.AC_MaxLen := opmC_CatName_MaxLen;
    opm_Form_AskCat.AC_ClearCats := FALSE;
    PRopm_GetCategory_Data (opm_CurrentCategory, opm_Form_AskCat.AC_CategoryData);
    IF (opm_Form_AskCat.ShowModal = mrOk) THEN PRopm_UpdateCatName (opm_Form_AskCat.AC_CategoryData, opm_TotalLanguages);
  END;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_UpdateCatName (CatData : opmT_SingleCatList; TotalCats : LONGINT);
VAR
  CurCat : LONGINT;
  UStrCatName : STRING;
  Progress, ProgStep : LONGINT;
BEGIN
  Progress := 0;
  ProgStep := ROUND (100 / TotalCats);
  IF (opmG_UIConfirmMods = 0) OR ((opmG_UIConfirmMods > 0) AND (FNopm_Message (_('Do you really want to update this category name?'), mtConfirmation, [mbYes, mbNo], opmG_UISilent) = mrYes)) THEN
    BEGIN
      FOR CurCat := 0 TO (TotalCats - 1) DO
        BEGIN
          IF ((CatData[CurCat].ID > 0) AND (CatData[CurCat].Parent >= 0) AND
              (CatData[CurCat].Name <> '') AND (CatData[CurCat].LanguageID >= 0)) THEN
            BEGIN
              PRopm_Update_StatusBar (opmC_ConnStatIgnore, Progress, opmC_ProgressNone, _('Updating category record...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
              UStrCatName := 'update ' + opmG_DBTable_CategoriesDescription + ' set categories_name="' + CatData[CurCat].Name + '"'
                           + ' where categories_id=' + INTTOSTR (CatData[CurCat].ID) + ' and language_id=' + INTTOSTR (CatData[CurCat].LanguageID);
              FNopm_ExecQuery (UStrCatName, opmC_SQLUpdate);
            END;
          INC (Progress, ProgStep);
        END;
      PRopm_LoadCategoryList (opmG_CategoryList, opmG_CategoryBoxList);
      PRopm_RenderCategoryDisplay (opmG_CategoryList, opm_TreeView_Main, opm_CurrentCategory);
      PRopm_RenderProductDisplay (opmG_CategoryList, opmG_ManufacturerList, opmG_ProductList, opm_ListView_Main, opm_CurrentProdID);
      PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Category record updated.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
    END;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_AddCategory (CatData : opmT_SingleCatList; TotalCats : LONGINT; ParentCat : LONGINT);
VAR
  CurCat : LONGINT;
  IStrCat, IStrCatDesc, IStrCheckID : STRING;
  Progress, ProgStep : LONGINT;
  LastID : LONGINT;
BEGIN
  Progress := 10;
  ProgStep := ROUND (90 / TotalCats);
  LastID := 0;
  IF (ParentCat >= 0) THEN
    BEGIN
      PRopm_Update_StatusBar (opmC_ConnStatIgnore, Progress, opmC_ProgressNone, _('Adding category record...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
      IStrCat := 'insert into ' + opmG_DBTable_Categories + ' (parent_id, date_added) values (' + INTTOSTR (ParentCat) + ', now())';
      IStrCheckID := 'select categories_id from ' + opmG_DBTable_Categories + ' where categories_id=last_insert_id()';
      FNopm_ExecQuery (IStrCat, opmC_SQLInsert);
      IF (FNopm_ExecQuery (IStrCheckID, opmC_SQLSelect) > 0) THEN
        IF (opmG_DBQuery.Active = TRUE) THEN
          BEGIN
            opmG_DBQuery.First;
            LastID := opmG_DBQuery.Fields[0].AsInteger;
          END;
    END;
  IF (LastID > 0) THEN
    FOR CurCat := 0 TO (TotalCats - 1) DO
      BEGIN
        IF (CatData[CurCat].LanguageID >= 0) THEN
          BEGIN
            PRopm_Update_StatusBar (opmC_ConnStatIgnore, Progress, opmC_ProgressNone, _('Adding category record...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
            IStrCatDesc := 'insert into ' + opmG_DBTable_CategoriesDescription + ' (categories_id, language_id, categories_name)'
                         + ' values (' + INTTOSTR (LastID) + ', ' + INTTOSTR (CatData[CurCat].LanguageID) + ', "' + CatData[CurCat].Name + '")';
            FNopm_ExecQuery (IStrCatDesc, opmC_SQLInsert);
          END;
        INC (Progress, ProgStep);
      END;
  PRopm_LoadCategoryList (opmG_CategoryList, opmG_CategoryBoxList);
  PRopm_RenderCategoryDisplay (opmG_CategoryList, opm_TreeView_Main, opm_CurrentCategory);
  PRopm_RenderProductDisplay (opmG_CategoryList, opmG_ManufacturerList, opmG_ProductList, opm_ListView_Main, opm_CurrentProdID);
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Category records added.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Main.PRopm_DeleteCategory (CatID : LONGINT);
VAR
  DStrCat, UStrCat, DStrCatDesc, UProdCats, SParentCat : STRING;
  ParentCat : LONGINT;
BEGIN
  ParentCat := opm_CurrentCategory;
  IF (CatID > 0) THEN
    BEGIN
      IF (opmG_UIConfirmDels = 0) OR ((opmG_UIConfirmDels > 0) AND (FNopm_Message (_('Do you really want to delete this category?'), mtConfirmation, [mbYes, mbNo], opmG_UISilent) = mrYes)) THEN
        BEGIN
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, 20, opmC_ProgressIgnore, _('Deleting category...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
          ParentCat := 0;
          SParentCat := 'select parent_id from ' + opmG_DBTable_Categories + ' where categories_id=' + INTTOSTR (CatID);
          IF (FNopm_ExecQuery (SParentCat, opmC_SQLSelect) > 0) THEN
            IF (opmG_DBQuery.Active = TRUE) THEN
              BEGIN
                opmG_DBQuery.First;
                ParentCat := opmG_DBQuery.Fields[0].AsInteger;
                IF (ParentCat < 0) THEN ParentCat := 0;
              END;
          DStrCat := 'delete from ' + opmG_DBTable_Categories + ' where categories_id=' + INTTOSTR (CatID);
          UStrCat := 'update ' + opmG_DBTable_Categories + ' set parent_id=' + INTTOSTR (ParentCat) + ' where parent_id=' + INTTOSTR (CatID);
          DStrCatDesc := 'delete from ' + opmG_DBTable_CategoriesDescription + ' where categories_id=' + INTTOSTR (CatID);
          UProdCats := 'update ' + opmG_DBTable_ProductsToCategories + ' set categories_id=' + INTTOSTR (ParentCat) + ' where categories_id=' + INTTOSTR (CatID);
          IF (FNopm_ExecQuery (DStrCat, opmC_SQLUpdate) >= 0) THEN
            BEGIN
              PRopm_Update_StatusBar (opmC_ConnStatIgnore, 40, opmC_ProgressIgnore, _('Moving categories from category...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
              FNopm_ExecQuery (UStrCat, opmC_SQLUpdate);
              PRopm_Update_StatusBar (opmC_ConnStatIgnore, 60, opmC_ProgressIgnore, _('Deleting category record...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
              FNopm_ExecQuery (DStrCatDesc, opmC_SQLUpdate);
              PRopm_Update_StatusBar (opmC_ConnStatIgnore, 80, opmC_ProgressIgnore, _('Deleting category descriptions...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
              FNopm_ExecQuery (UProdCats, opmC_SQLUpdate);
              PRopm_Update_StatusBar (opmC_ConnStatIgnore, 100, opmC_ProgressIgnore, _('Moving products from category...'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
            END;
          PRopm_Update_StatusBar (opmC_ConnStatIgnore, 0, opmC_ProgressIgnore, _('Category deleted.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
        END;
    END;
  PRopm_LoadCategoryList (opmG_CategoryList, opmG_CategoryBoxList);
  PRopm_RenderCategoryDisplay (opmG_CategoryList, opm_TreeView_Main, ParentCat);
  PRopm_ClearProductList (opm_ListView_Main);
  PRopm_RenderProductDisplay (opmG_CategoryList, opmG_ManufacturerList, opmG_ProductList, opm_ListView_Main, opm_CurrentProdID);
  PRopm_Update_StatusBar (opmC_ConnStatIgnore, opmC_ProgressNone, opmC_ProgressNone, _('Category records added.'), opmC_PTotalIgnore, opm_CurrentCurrency.Code);
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Main.opm_ListView_MainKeyDown (Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  CASE Key OF
    VK_RETURN : opm_ListView_MainDblClick (Sender);
    VK_DELETE : opm_PopMenuItem_PDeleteClick (Sender);
    VK_INSERT : opm_PopMenuItem_PAddClick (Sender);
  END;

end;


END.



